#include "stdafx.h"
#include "sparse_matrix.h"




short region(float x, float y, float z,  short regions_array[], parameters &param);


float level_set_value(float x, float y, float z, float signed_dist_array[], parameters &param, short this_region_number, bool use_only_this_region, short regions_array[]);

void cross_product(float a[], float b[], float vec_out[]);
float vec_length(float vec[]);
void add(long size, float A[], float B[], float M[]);

void get_ls(node_info node_class[], short regions_array[],  float signed_dist_array[], parameters &param){

	float xx, yy, zz;
	short region_number;
	float ls_val;

	for(long n=0; n<param.nodes_number;n++){

			for(short r=0;r<node_class[n].number_of_regions_belong;r++){

				xx = param.n_x[n];
				yy = param.n_y[n];
				zz = param.n_z[n];

				region_number = node_class[n].regions_belong[r];

				ls_val = level_set_value(xx,yy,zz,signed_dist_array, param, region_number, true, regions_array);
				//cout << "dist " << sqrt( (xx-35)*(xx-35)+(yy-35)*(yy-35)+(zz-35)*(zz-35) ) << endl;
				//cout << "ls value " << ls_val << endl;

				node_class[n].set_ls(r, ls_val);

			
			}

		}

}








void get_node_info(node_info node_class[],  short regions_array[],  float signed_dist_array[], parameters &param){

	/*
	for(long n=0;n<param.size3D;n++){
		cout << gradient_field_x[n] << endl;
		cout << gradient_field_y[n] << endl;
		cout << gradient_field_z[n] << endl;
	};
	*/

	long unassigned_nodes_count = 0;
	long ok_nodes=0;

	for(long n=0;n<param.nodes_number;n++){

		node_class[n].set_size_to_0();

	}

	//adding all the regions associated with each node


	long p[4];
	short region_added;

	for(long n=0;n<param.tets_number;n++){

		p[0]=param.t_1[n];
		p[1]=param.t_2[n];
		p[2]=param.t_3[n];
		p[3]=param.t_4[n];

		for(long m=0;m<4;m++){

			//p[m] = tets_(n,m);
			region_added = short (param.t_r[n]);

			node_class[p[m]].add_region(region_added);

		}

	}

	//for(long n=0;n<param.tets_number;n++){
	//	for(long m=0;m<4;m++){

	//		p[m] = tets_(n,m);
	//		for(short z=0; z<node_class[p[m]].number_of_regions_belong; z++){
	//			cout <<  node_class[p[m]].regions_belong[z] << endl;
	//		}
	//	}
	//}

	for(long n=0; n<param.nodes_number;n++){

		node_class[n].set_vec_sizes();

		node_class[n].set_ls_size();

		node_class[n].set_associated_node_volumes_size();
		//node_class[n].set_associated_node_areas_size();

		node_class[n].set_vecs_to_0();

	}


	




	//adding all the vectors associated with each node

	//note that the boundary nodes associated with a region will have more that one set of vectors, (one for each region)
	//also note that the boundary nodes may not be in the region being considered.
	//move 1 in each direction (6 directions) and pick out the value that is the largest.  normalize to 1.
	//the class contains the regions associated with the boundary node and the associated vectors

	float xx, yy, zz, xx_p1, yy_p1, zz_p1, xx_m1, yy_m1, zz_m1;
	float grad_x, grad_y, grad_z;
	grad_x=0; grad_y=0; grad_z=0;
	float mag_previous_largest;
	float mag_current;
	float l_vec_x, l_vec_y, l_vec_z;

	float ls_val;
	float ls_current;
	float ls_previous_largest;

	short region_number;

	//////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////
	//the following code attaches a single value to the nodes


		param.ls_max =0;

		for(long n=0; n<param.nodes_number;n++){

			node_class[n].boundary = false;

			for(short r=0;r<node_class[n].number_of_regions_belong;r++){

				xx = param.n_x[n];
				yy = param.n_y[n];
				zz = param.n_z[n];

				region_number = node_class[n].regions_belong[r];

				ls_val = level_set_value(xx,yy,zz,signed_dist_array, param, region_number, true, regions_array);
				//cout << "dist " << sqrt( (xx-35)*(xx-35)+(yy-35)*(yy-35)+(zz-35)*(zz-35) ) << endl;
				//cout << "ls value " << ls_val << endl;

				//cout << ls_val << endl;

				node_class[n].set_ls(r, ls_val);

				if(ls_val>param.ls_max){
					param.ls_max = ls_val;
					


				}

				

				if(node_class[n].ls_val[r] < .1){

					node_class[n].boundary = true;

					//cout << "n = " << n << endl;
					//cout << "region_number = " << region_number << endl;
					//cout << "num reg belong = " << node_class[n].number_of_regions_belong << endl;
					//cout << xx << " " << yy << " " << zz << endl;

					//cout << "boundary crds" << xx << " " << yy << " " << zz << endl;

				}

			
			}

		}

		/*
		for(long n=0;n<param.nodes_number;n++){

			if(node_class[n].boundary == true){

				node_class[n].hit_list = new long[30];

				for(short m=0;m<30;m++){
					node_class[n].hit_list[m] = -1;
				}

			}

		}
		*/

			

		

		short r;

		short *color_list;
		color_list = new short[param.nodes_number];

	for(long n=0;n<param.nodes_number;n++){

		if(node_class[n].boundary == true){
			node_class[n].boundary_0 = true;
		}else{
			node_class[n].boundary_0 = false;
		}

		color_list[n] = 0;

	}

	for(long n=0;n<param.tets_number;n++){

		r = short (param.t_r[n]);

		p[0]=param.t_1[n];
		p[1]=param.t_2[n];
		p[2]=param.t_3[n];
		p[3]=param.t_4[n];

		for(long m=0;m<4;m++){

			//p[m] = tets_(n,m);
			

			if( (node_class[p[m]].boundary == true) ){
				if(color_list[p[m]] == 0){
					color_list[p[m]] = r;
				}else{
					if(r != color_list[p[m]]){
						node_class[p[m]].boundary_0 = false;
					}
				}
			}

		}
	}

	for(long n=0;n<param.nodes_number;n++){

		if( (node_class[n].boundary == true) && (node_class[n].boundary_0 == false) ){

			xx = param.n_x[n];
			yy = param.n_y[n];
			zz = param.n_z[n];

			xx_p1 = xx+.1;
			yy_p1 = yy+.1;
			zz_p1 = zz+.1;
			xx_m1 = xx -.1;
			yy_m1 = yy - .1;
			zz_m1 = zz - .1;

			if( region(xx_m1, yy_m1, zz_m1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_m1, yy_m1, zz_p1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_m1, yy_p1, zz_m1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_m1, yy_p1, zz_p1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_p1, yy_m1, zz_m1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_p1, yy_m1, zz_p1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_p1, yy_p1, zz_m1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}
			if( region(xx_p1, yy_p1, zz_p1,  regions_array, param) == 0){
				node_class[n].boundary_0 = true;
			}

		}

	}

	for(long n=0;n<param.nodes_number;n++){
		node_class[n].near_boundary = false;
	}


	for(long n=0;n<param.tets_number;n++){

		p[0]=param.t_1[n];
		p[1]=param.t_2[n];
		p[2]=param.t_3[n];
		p[3]=param.t_4[n];

		for(long m=0;m<4;m++){

			//p[m] = tets_(n,m);

			if(node_class[p[m]].boundary == true){

				node_class[p[0]].near_boundary = true;
				node_class[p[1]].near_boundary = true;
				node_class[p[2]].near_boundary = true;
				node_class[p[3]].near_boundary = true;

				param.boundary_tet[n] = true;

			}

		}

	}


	//////////////////////////////////////////

	for(long n=0;n<param.nodes_number;n++){

		if(node_class[n].near_boundary == true){

			node_class[n].edge_points = new long[30];
			for(short m=0;m<30;m++){
				node_class[n].edge_points[m] = -1;
			}
		}

	}

	bool stop;

	for(long n=0;n<param.tets_number;n++){

			//if(param.boundary_tet[n] == true){

				p[0]=param.t_1[n];
				p[1]=param.t_2[n];
				p[2]=param.t_3[n];
				p[3]=param.t_4[n];

				for(short s=0;s<4;s++){

					if(node_class[p[s]].near_boundary == true){

						
						for(short t=0;t<4;t++){
							stop = false;
							for(short m=0;m<30;m++){
								if(stop == false){
									if(node_class[p[s]].edge_points[m] == -1){
										node_class[p[s]].edge_points[m] = p[t];
										stop = true;
									}
									if(node_class[p[s]].edge_points[m] == p[t]){
										stop = true;
									}
								}
							}
						}
					}
				}
			//}
	}

	long *temp_edge;
	temp_edge = new long[30];
	for(short m=0;m<30;m++){
		temp_edge[m] =-1;
	}

	for(long n=0;n<param.nodes_number;n++){
		if(node_class[n].near_boundary == true){

			node_class[n].edge_num = 0;

			for(short m=0;m<30;m++){
				temp_edge[m] = node_class[n].edge_points[m];
				if(node_class[n].edge_points[m] != -1){

					node_class[n].edge_num ++;

				}
			}

			delete [] node_class[n].edge_points;

			node_class[n].edge_points = new long[node_class[n].edge_num];

			for(short m=0;m<node_class[n].edge_num;m++){

				node_class[n].edge_points[m] = temp_edge[m];

			}

		}
	}

			




	/*
	for(long n=0;n<100;n++){
		if( node_class[n].boundary == true){

			for(short s=0;s<30;s++){

				cout << node_class[n].edge_points[s] << " " ;

			}
			cout << " " << endl;

		}
	}

	exit(1);
	*/













	////////////////////////////////////////////








	float bdry_all_val;

	if(param.zoom_level == 3){
		bdry_all_val = 4.0;
	}
	if(param.zoom_level == 2){
		bdry_all_val = 2.0;
	}
	if(param.zoom_level == 1){
		bdry_all_val = 1.0;
	}

	//param.SG_length = param.nodes_number;
	

	for(long n=0;n<param.nodes_number;n++){

		node_class[n].boundary_all = false;

		if( node_class[n].number_of_regions_belong == 1){
			if( node_class[n].regions_belong[0] == 0){
				if(node_class[n].ls_val[0] > bdry_all_val){

					node_class[n].boundary_all = true;


					//cout << node_class[n].ls_val[0] << " " << node_class[n].regions_belong[0] << endl;

					//param.SG_length = param.SG_length - 1;

				}
			}
		}


	}

	param.SG_length = 0;

	for(long n=0;n<param.nodes_number;n++){

		if((node_class[n].boundary == false) && (node_class[n].number_of_regions_belong > 0) ){

			param.SG_length =  param.SG_length + 1;

		}
	}

	param.conv_inv = new long[param.SG_length];

	long counter = 0;

	for(long n=0;n<param.nodes_number;n++){

		if((node_class[n].boundary == false) && (node_class[n].number_of_regions_belong > 0) ){

			param.conv[n] = counter;

			param.conv_inv[counter] = n;

			counter = counter + 1;

		}else{

			param.conv[n] = -1;

		}

	}

	//cout << param.SG_length << endl;

	//for(long n=0;n<param.nodes_number;n++){

		//if( (node_class[n].number_of_regions_belong == 0) ){

			//cout << " unconnected node " << endl;

		//}
	//}




	param.SG_initial_entry_num = 0;

	for(long ii=0;ii<param.tets_number; ii++){

		p[0]=param.t_1[ii];
		p[1]=param.t_2[ii];
		p[2]=param.t_3[ii];
		p[3]=param.t_4[ii];

		counter = 0;

		if(node_class[p[0]].boundary == true){
			counter = counter +1;
		}
		if(node_class[p[1]].boundary == true){
			counter = counter +1;
		}
		if(node_class[p[2]].boundary == true){
			counter = counter +1;
		}
		if(node_class[p[3]].boundary == true){
			counter = counter +1;
		}

		if(counter == 0){
			param.SG_initial_entry_num = param.SG_initial_entry_num + 16;
		}
		if(counter == 1){
			param.SG_initial_entry_num = param.SG_initial_entry_num + 9;
		}
		if(counter == 2){
			param.SG_initial_entry_num = param.SG_initial_entry_num + 4;
		}
		if(counter == 3){
			param.SG_initial_entry_num = param.SG_initial_entry_num + 1;
		}

	}

	
}

/////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////



void initialize_sparse_matrix(sparse_matrix &A, node_info node_class[], parameters &param){


	long p1, p2, p3, p4;
	long p1c, p2c, p3c, p4c;

	long length_input = param.SG_length;
	long sm_entry_num_input = param.SG_initial_entry_num;

	cout << "begin initialize sparse matrix" << endl;
	A.initialize_s(sm_entry_num_input, length_input);
	cout << "end initialize sparse matrix" << endl;






	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		p1c = param.conv[p1];
		p2c = param.conv[p2];
		p3c = param.conv[p3];
		p4c = param.conv[p4];


	

		if(node_class[p1].boundary == false){
			if(node_class[p2].boundary == false){
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//add all
						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						A.add_entry_num_to_order_number(p1c,p3c);
						A.add_entry_num_to_order_number(p1c,p4c);
						A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						A.add_entry_num_to_order_number(p2c,p4c);
						A.add_entry_num_to_order_number(p3c,p1c);
						A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						A.add_entry_num_to_order_number(p4c,p1c);
						A.add_entry_num_to_order_number(p4c,p2c);
						A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//1,2,3
						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						A.add_entry_num_to_order_number(p1c,p3c);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						A.add_entry_num_to_order_number(p3c,p1c);
						A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
												
						
					}
				}else{
					if(node_class[p4].boundary == false){
						//1,2,4
						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						A.add_entry_num_to_order_number(p1c,p4c);
						A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p2c,p4c);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p1c);
						A.add_entry_num_to_order_number(p4c,p2c);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p4c);
						
					}else{
						//1,2
						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);

					}
				}
			}else{
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//1,3,4
						A.add_entry_num_to_order_number(p1c,p1c);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p1c,p3c);
						A.add_entry_num_to_order_number(p1c,p4c);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						A.add_entry_num_to_order_number(p3c,p1c);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						A.add_entry_num_to_order_number(p4c,p1c);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//1,3
						A.add_entry_num_to_order_number(p1c,p1c);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p1c,p3c);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						A.add_entry_num_to_order_number(p3c,p1c);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p3c,p3c);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}else{
					if(node_class[p4].boundary == false){
						//1,4
						A.add_entry_num_to_order_number(p1c,p1c);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						A.add_entry_num_to_order_number(p1c,p4c);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p1c);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//1
						A.add_entry_num_to_order_number(p1c,p1c);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}
			}
		}else{
			if(node_class[p2].boundary == false){
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						// 2,3,4
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						A.add_entry_num_to_order_number(p2c,p4c);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						A.add_entry_num_to_order_number(p4c,p2c);
						A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						// 2,3
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}else{
					if(node_class[p4].boundary == false){
						//2,4
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p2c,p2c);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p2c,p4c);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						A.add_entry_num_to_order_number(p4c,p2c);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//2
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						A.add_entry_num_to_order_number(p2c,p2c);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}
			}else{
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//3,4
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//3
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						A.add_entry_num_to_order_number(p3c,p3c);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}else{
					if(node_class[p4].boundary == false){
						//4
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						A.add_entry_num_to_order_number(p4c,p4c);
					}else{
						//none
						//A.add_entry_num_to_order_number(p1c,p1c,add_to_p1_p1);
						//A.add_entry_num_to_order_number(p1c,p2c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p1c,p3c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p1c,p4c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p2c,p1c,add_to_p1_p2);
						//A.add_entry_num_to_order_number(p2c,p2c,add_to_p2_p2);
						//A.add_entry_num_to_order_number(p2c,p3c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p2c,p4c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p3c,p1c,add_to_p1_p3);
						//A.add_entry_num_to_order_number(p3c,p2c,add_to_p2_p3);
						//A.add_entry_num_to_order_number(p3c,p3c,add_to_p3_p3);
						//A.add_entry_num_to_order_number(p3c,p4c,add_to_p3_p4);
						//A.add_entry_num_to_order_number(p4c,p1c,add_to_p1_p4);
						//A.add_entry_num_to_order_number(p4c,p2c,add_to_p2_p4);
						//A.add_entry_num_to_order_number(p4c,p3c,add_to_p3_p4);
						//A.add_entry_num_to_order_number_num_to_order_number(p4c,p4c,add_to_p4_p4);
					}
				}
			}
		}
		






		}

		A.sort_sparse_matrix_s();


}

///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

void initialize_sparse_matrix2(sparse_matrix &A, node_info node_class[], parameters &param){


	param.SG_length = 0;

	for(long n=0;n<param.nodes_number;n++){

		if( (node_class[n].number_of_regions_belong > 0) ){

			param.SG_length = param.SG_length + 1;


		}
	}

	delete [] param.conv_inv;
	param.conv_inv = new long[param.SG_length];

	long counter = 0;

	for(long n=0;n<param.nodes_number;n++){

		if( (node_class[n].number_of_regions_belong > 0) ){


			param.conv[n] = counter;

			param.conv_inv[counter] = n;

			counter = counter + 1;

		}else{

			param.conv[n] = -1;

		}

	}


	param.SG_initial_entry_num = 6*param.tets_number;

	long p1, p2, p3, p4;
	long p1c, p2c, p3c, p4c;

	long length_input = param.SG_length;
	long sm_entry_num_input = param.SG_initial_entry_num;

	cout << "begin initialize sparse matrix" << endl;
	A.initialize_s(sm_entry_num_input, length_input);
	cout << "end initialize sparse matrix" << endl;





	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		p1c = param.conv[p1];
		p2c = param.conv[p2];
		p3c = param.conv[p3];
		p4c = param.conv[p4];


						/*
						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						A.add_entry_num_to_order_number(p1c,p3c);
						A.add_entry_num_to_order_number(p1c,p4c);
						A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						A.add_entry_num_to_order_number(p2c,p4c);
						A.add_entry_num_to_order_number(p3c,p1c);
						A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						A.add_entry_num_to_order_number(p4c,p1c);
						A.add_entry_num_to_order_number(p4c,p2c);
						A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
						*/


						A.add_entry_num_to_order_number(p1c,p1c);
						A.add_entry_num_to_order_number(p1c,p2c);
						A.add_entry_num_to_order_number(p1c,p3c);
						A.add_entry_num_to_order_number(p1c,p4c);
						//A.add_entry_num_to_order_number(p2c,p1c);
						A.add_entry_num_to_order_number(p2c,p2c);
						A.add_entry_num_to_order_number(p2c,p3c);
						A.add_entry_num_to_order_number(p2c,p4c);
						//A.add_entry_num_to_order_number(p3c,p1c);
						//A.add_entry_num_to_order_number(p3c,p2c);
						A.add_entry_num_to_order_number(p3c,p3c);
						A.add_entry_num_to_order_number(p3c,p4c);
						//A.add_entry_num_to_order_number(p4c,p1c);
						//A.add_entry_num_to_order_number(p4c,p2c);
						//A.add_entry_num_to_order_number(p4c,p3c);
						A.add_entry_num_to_order_number(p4c,p4c);
					


		}

		
		A.sort_sparse_matrix_s();
		


}




//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////



void delete_node_info(node_info node_class[], parameters &param){

	for(long n=0;n<param.nodes_number;n++){
		delete []	node_class[n].associated_node_volumes;
		delete [] node_class[n].ls_val;
		delete [] node_class[n].regions_belong;
		delete [] node_class[n].vec_x;
		delete [] node_class[n].vec_y;
		delete [] node_class[n].vec_z;
	}

}




//this function needs to be updated at each time step
void get_nodes_current_voxel_region(node_info node_class[], short regions_array[],  parameters &param){

	float xx, yy, zz;
	short r;

	for(long n=0;n<param.nodes_number;n++){

			xx = param.n_x[n];
			yy = param.n_y[n];
			zz = param.n_z[n];

			r = region(xx, yy, zz, regions_array, param);

			node_class[n].set_current_voxel_region(r);


	}




}

void get_M( node_info node_class[], float current_tet_volumes[], long t, parameters &param){



	//loop through tets
	//if the the four points are in the correct region, add tet volume to total

	float *overlap; overlap = new float[param.max_number_of_regions];
	float *initial; initial = new float[param.max_number_of_regions];
	//float *extra; extra = new float[param.max_number_of_regions];

	for(short m=0;m<param.max_number_of_regions;m++){
		param.M[m]=0.0;
		overlap[m]=0.0;
		initial[m]=0.0;
	}
		param.M[0] = 1.0;



	float int_term1=0.0;
	float int_term2=0.0;
	float int_term3=0.0;


	long p1, p2, p3, p4;
	short region_number;

	bool hit;

	//tets with all four nodes in a region are added to overlap.  all four nodes not in region are added to initial.  boderline tets are split evenly 
	//between the two categories

	for(long n=0;n<param.tets_number;n++){

		hit = false;

		p1=param.t_1[n];
		p2=param.t_2[n];
		p3=param.t_3[n];
		p4=param.t_4[n];
		region_number=param.t_r[n];

		//if( node_class[p1].current_voxel_region == region_number){
			//if( node_class[p2].current_voxel_region == region_number){
				//if( node_class[p3].current_voxel_region == region_number){
					//if( node_class[p4].current_voxel_region == region_number){
				
						//overlap[region_number] = overlap[region_number] + current_tet_volumes[n];
						//hit=true;

					//}
				//}
			//}
		//}

		if( node_class[p1].current_voxel_region != region_number){
			if( node_class[p2].current_voxel_region != region_number){
				if( node_class[p3].current_voxel_region != region_number){
					if( node_class[p4].current_voxel_region != region_number){
				
						initial[region_number] = initial[region_number] + current_tet_volumes[n];
						hit=true;

					}
				}
			}
		}

		if(hit == false){
			//extra[region_number] = extra[region_number] + current_tet_volumes[n];
			overlap[region_number] = overlap[region_number] + current_tet_volumes[n];
		}


	}

	for(short m=1;m<param.max_number_of_regions;m++){
	
		

		if(param.target_image_size[m] == 0.0){
			param.M[m]=0.0;
			//cout << m << " target image size 0" << endl;
		}else{
			param.M[m] = overlap[m]/param.target_image_size[m];

			//int_term1 = int_term1 + param.M[m]*initial[m];
			//int_term2 = int_term2 + (param.target_image_size[m]-param.M[m]);
			//int_term3 = int_term3 + (1.0-param.M[m])*(param.empty_space_size[m] - initial[m]);

			int_term1 = int_term1 + param.target_image_size[m]-overlap[m];
			int_term2 = int_term2 + param.M[m]*initial[m];
			int_term3 = int_term3 + (1.0-param.M[m])*(param.empty_space_size[m] - initial[m]);
			
			//cout << "added to int terms" << endl;

		}
		
	}

	//cout << param.empty_space_size[0] << endl;
	//cout << param.empty_space_size[1] << endl;
	//cout << param.empty_space_size[2] << endl;
	//cout << param.target_image_size[0] << endl;
	//cout << param.target_image_size[1] << endl;
	//cout << param.target_image_size[2] << endl;


	//int_term1 = int_term1 + param.target_image_size[0] - overlap[0];
	int_term2 = int_term2 + initial[0];



	//cout << "overlap0 "<<overlap[0] << endl;
	//cout << "overlap1 "<<overlap[1] << endl;
	//cout << "overlap2 "<<overlap[2] << endl;
	//cout << "initial0 "<< initial[0] << endl;
	//cout << "initial1 " << initial[1] << endl;
	//cout << "initial2 " << initial[2] << endl;

	//int_term1 = M*initial;
	//int_term2 = (param.target_image_size - M);
	//int_term3 = (1.0-M)*(param.empty_space_size - initial);

	//cout << int_term1 << " " << int_term2 << " " << int_term3 << endl;

	float delta = (1/(param.pi*param.eps))/(1+(0)/(param.eps*param.eps));

	param.F[t] = param.alpha*delta*(int_term1+int_term2+int_term3);

	param.G[t] = param.G[t] + param.F[t];

	cout << "F = " << param.F[t] << endl;
	cout << "G = " << param.G[t] << endl;

	//cout << " targ size" <<param.target_image_size << endl;
	//cout << " tet vol" << tot2 << endl;

	for(short m=0;m<param.max_number_of_regions;m++){
		if(param.M[m] !=0){
			cout << "M["<<m<<"] = "<<param.M[m]<<endl;
		}
	}





}
	


void update_time_step(  float current_tet_volumes[], node_info node_class[], long t, parameters &param){


		//just pick a large number
	param.smallest_insphere_radius = 1000;


	//if(t==2){
	//	param.initial_smallest_timestep = param.zeta*param.initial_smallest_insphere_size*param.initial_smallest_insphere_size*param.initial_smallest_insphere_size;
	//	cout << "initial smallest timestep req = " << param.initial_smallest_timestep << endl;
	//}

	float insphere_radius;
	float val1, val2;
	float vec1[3], vec2[3];
	float a[3], b[3], c[3];
	float b_cross_c[3], c_cross_a[3], a_cross_b[3];
	float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
	long p1, p2, p3, p4;
	short r[5];
	short random_integer, vals_entered;
	short tet_region;
	float this_time_step;
	short region;

	/*
	for(long n=0;n<param.nodes_number;n++){
		node_class[n].singleton = false;
		node_class[n].hard_limit = false;
	}
	*/


	for(long n=0;n<param.tets_number;n++){

		p1=param.t_1[n];
		p2=param.t_2[n];
		p3=param.t_3[n];
		p4=param.t_4[n];
		region=param.t_r[n];

		//if(region!=0){

		x1 = param.n_x[p1];
		x2 = param.n_x[p2];
		x3 = param.n_x[p3];
		x4 = param.n_x[p4];
		y1 = param.n_y[p1];
		y2 = param.n_y[p2];
		y3 = param.n_y[p3];
		y4 = param.n_y[p4];
		z1 = param.n_z[p1];
		z2 = param.n_z[p2];
		z3 = param.n_z[p3];
		z4 = param.n_z[p4];

		a[0] = x2 - x1;
		a[1] = y2 - y1;
		a[2] = z2 - z1;

		b[0] = x3 - x1;
		b[1] = y3 - y1;
		b[2] = z3 - z1;

		c[0] = x4 - x1;
		c[1] = y4 - y1;
		c[2] = z4 - z1;

		cross_product(b, c, b_cross_c);
		cross_product(c, a, c_cross_a);
		cross_product(a, b, a_cross_b);

		val1 = vec_length(b_cross_c) + vec_length(c_cross_a) + vec_length(a_cross_b);

		add(3, b_cross_c, c_cross_a, vec1);
		add(3, vec1, a_cross_b, vec2);
		val2 = val1 + vec_length(vec2);

		insphere_radius = (6*current_tet_volumes[n])/val2;

		//cout << a_cross_b[0] << endl;
		//cout << val2 << endl;
		//cout << "tet volume " <<current_tet_volumes[n] << endl;
		//cout << insphere_radius << endl;
		//cout << "insphere volume= " << (4/3)*param.pi*insphere_radius*insphere_radius*insphere_radius << endl;


		if(insphere_radius < param.smallest_insphere_radius){

			param.smallest_insphere_radius = insphere_radius;

		}

			/*
			cout << insphere_radius << endl;
			cout << x1 << " " << y1 << " " << z1 << endl;
			cout << x2 << " " << y2 << " " << z2 << endl;
			cout << x3 << " " << y3 << " " << z3 << endl;
			cout << x4 << " " << y4 << " " << z4 << endl;
			*/

			/*
			if(param.jagged_compression == true){
				if(t==1){
					param.initial_smallest_insphere_size = insphere_radius;	
				}
			}

		}
		*/

		

		this_time_step = param.zeta*insphere_radius*insphere_radius*insphere_radius;

		param.inflate[n] = false;

/*
		if( (t>1) && (param.jagged_compression == true) ){
		
		if(this_time_step < (param.min_timestep) ){

			node_class[p1].singleton = true;
			node_class[p2].singleton = true;
			node_class[p3].singleton = true;
			node_class[p4].singleton = true;

			param.inflate[n] = true;

			if(this_time_step < (param.min_timestep*.75) ){

				node_class[p1].hard_limit = true;
				node_class[p2].hard_limit = true;
				node_class[p3].hard_limit = true;
				node_class[p4].hard_limit = true;

				if(this_time_step < (param.min_timestep*.60) ){

					node_class[p1].hard_limitb = true;
					node_class[p2].hard_limitb = true;
					node_class[p3].hard_limitb = true;
					node_class[p4].hard_limitb = true;


				}



			}




		}

		}
		
*/

	


		param.delta_t = param.zeta*param.smallest_insphere_radius*param.smallest_insphere_radius*param.smallest_insphere_radius;
		//delta_t = zeta*smallest_insphere_radius;

		}

		cout << "Time step size reduced to " << param.delta_t << endl;

	

}



void adjust_node_positions(parameters &param){

	//add 1.5 then subtract 8

	for(long n=0;n<param.nodes_number;n++){

		param.n_x[n] = param.n_x[n] - 6.5;
		param.n_y[n] = param.n_y[n] - 6.5;
		param.n_z[n] = param.n_z[n] - 6.5;

		//multiply by resolution

		param.n_x[n] = param.n_x[n]*param.res_x;
		param.n_y[n] = param.n_y[n]*param.res_y;
		param.n_z[n] = param.n_z[n]*param.res_z;

	}



}
	