#ifndef IMAGE3D_H
#define IMAGE3D_H
#include "image2d.h"

//using namespace std;


class Image3D {
 public:
   Image3D();
   Image3D(int, int, int, int);
   Image3D(int,int,int,int,double);
   Image3D(const Image3D&);
   ~Image3D();
   //member functions.
   void getImageInfo(int&, int&, int&, int&) const;
   double mean() const;
   double min() const;
   double max() const;
   bool inBounds(int, int, int) const;
   //void border(int);
   void reflect(int n);
   //void reflect(int, int);
   //overloaded operators.
   double& operator()(int,int,int);
   double operator()(int,int,int) const;
   //Image2D& slicing(int k);
   const Image2D& slicing(int k) const;
   Image3D& operator=(const Image3D&);
   Image3D& operator-=(const Image3D&);
   Image3D& operator-=(double);
   Image3D& operator+=(const Image3D&);
   Image3D& operator+=(double);
   Image3D& operator*=(const Image3D&);
   Image3D& operator*=(double);
   Image3D& operator/=(const Image3D&);

 private:
   int NX,NY,NZ,Q;
   Image2D *images;
};

//non-member functions.

void readImage3D(char fileName[], Image3D&, bool type);
//void readImage3D_PGM2(char fileName[], Image3D&, bool type);
void readImage3DHeader(char fname[], int& NX, int& NY, int& NZ, int& Q, bool& type);
//void writeImage3D(Image3D&);
Image3D operator-(const Image3D&, const Image3D&); 
Image3D operator-(const Image3D&, double);
Image3D operator-(double, const Image3D&);
Image3D operator+(const Image3D&, const Image3D&);
Image3D operator+(const Image3D&, double);
Image3D operator+(double, const Image3D&);
Image3D operator*(const Image3D&, const Image3D&);
Image3D operator*(const Image3D&, double);
Image3D operator*(double, const Image3D&);
Image3D operator/(const Image3D&, const Image3D&);

#endif
