#include "perform_front_propagation_3d.h"
#include "fib.h"
#include "fibpriv.h"
#include <iostream>
#include <fstream>
#include<iomanip>

#include"parameters.h"
using namespace std;



void get_boundary(short regions_array[], long grad0[], parameters param){

	double grad;




	for(long kk=0; kk<(2*param.size1D_z);kk++){
		for(long jj=0;jj<(2*param.size1D_y);jj++){
			for(long ii=0;ii<(2*param.size1D_x);ii++){

				grad0_(ii,jj,kk)=0;

			}
		}
	}

	long iih, jjh, kkh;

	for(long kk=1; kk<(2*param.size1D_z-1);kk++){
		for(long jj=1;jj<(2*param.size1D_y-1);jj++){
			for(long ii=1;ii<(2*param.size1D_x-1);ii++){

				if( ((ii%2)==0) && ((jj%2)==0) && ((kk%2)==0) ){
					grad0_(ii,jj,kk) = 0;
				}
				if( ((ii%2)==1) && ((jj%2)==0) && ((kk%2)==0) ){
					iih = (ii-1)/2;
					jjh = jj/2;
					kkh = kk/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}				
				}
				if( ((ii%2)==0) && ((jj%2)==1) && ((kk%2)==0) ){
					iih = ii/2;
					jjh = (jj-1)/2;
					kkh = kk/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}
				}
				if( ((ii%2)==0) && ((jj%2)==0) && ((kk%2)==1) ){
					iih = ii/2;
					jjh = jj/2;
					kkh = (kk-1)/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh,kkh+1)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}
				}
				if( ((ii%2)==1) && ((jj%2)==1) && ((kk%2)==0) ){
					iih = (ii-1)/2;
					jjh = (jj-1)/2;
					kkh = kk/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh+1,kkh)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}
				}
				if( ((ii%2)==1) && ((jj%2)==0) && ((kk%2)==1) ){
					iih = (ii-1)/2;
					jjh = jj/2;
					kkh = (kk-1)/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh,kkh+1)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh+1)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}
				}
				if( ((ii%2)==0) && ((jj%2)==1) && ((kk%2)==1) ){
					iih = ii/2;
					jjh = (jj-1)/2;
					kkh = (kk-1)/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh,kkh+1)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh+1)) ){
						grad0_(ii,jj,kk) = 0;
					}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}
				}
				if( ((ii%2)==1) && ((jj%2)==1) && ((kk%2)==1) ){
					iih = (ii-1)/2;
					jjh = (jj-1)/2;
					kkh = (kk-1)/2;
					if( (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh,kkh+1)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh))
						&& (regions_array_(iih,jjh,kkh) == regions_array_(iih,jjh+1,kkh+1)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh))
						&& (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh,kkh+1)) && (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh+1,kkh))
						&& (regions_array_(iih,jjh,kkh) == regions_array_(iih+1,jjh+1,kkh+1)) ){

						grad0_(ii,jj,kk) = 0;
				}else{
						grad0_(ii,jj,kk) = 1;
						nb_start_points = nb_start_points + 1;
					}

				}
			}
		}
	}









//the gradient norm is calculated, only on values that aren't right next to a larger value.

/*

	for(long kk=1; kk<(param.size1D_z-1);kk++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long ii=1;ii<(param.size1D_x-1);ii++){


				grad = 0;

				if( (regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj-1,kk-1) )
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj-1,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj-1,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj+1,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj+1,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj+1,kk-1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj-1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj-1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj-1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj+1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj+1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj+1,kk) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj-1,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj-1,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj-1,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii-1,jj+1,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii,jj+1,kk+1) ) 
					&& ( regions_array_(ii,jj,kk) <= regions_array_(ii+1,jj+1,kk+1) ) 
					 ){


						grad = ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk-1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk-1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk-1) )

						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk) )

						+( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj-1,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj-1,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj-1,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii-1,jj+1,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii,jj+1,kk+1) )
						+ ( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk+1) )*( regions_array_(ii,jj,kk) - regions_array_(ii+1,jj+1,kk+1) );
						

			
				}

				
				if(grad != 0){
					grad0_(ii,jj,kk) = 1;
					nb_start_points = nb_start_points + 1;
				}
				else{
					grad0_(ii,jj,kk) = 0;
				};
			};
		};
	};
*/

}



void one_region(short regions_array[], parameters &param){


	long old_size1D_x = param.size1D_x;
	long old_size1D_y = param.size1D_y;
	long old_size1D_z = param.size1D_z;

	long x_min = param.size1D_x;
	long x_max = -1;
	long y_min = param.size1D_y;
	long y_max = -1;
	long z_min = param.size1D_z;
	long z_max = -1;


	for(long ii=0;ii<param.size1D_x;ii++){
		for(long jj=0;jj<param.size1D_y;jj++){
			for(long kk=0;kk<param.size1D_z;kk++){

				if(regions_array_(ii,jj,kk) == param.single_region){

					if(ii < x_min){
						x_min = ii;
					}
					if(ii > x_max){
						x_max = ii;
					}
					if(jj < y_min){
						y_min = jj;
					}
					if(jj > y_max){
						y_max = jj;
					}
					if(kk < z_min){
						z_min = kk;
					}
					if(kk > z_max){
						z_max = kk;
					}
					regions_array_(ii,jj,kk) = param.single_region;

				}else{

					regions_array_(ii,jj,kk)=0;
				}

			}
		}
	}

		
	x_min = x_min - 30;
	y_min = y_min - 30;
	z_min = z_min - 30;
	x_max = x_max + 30;
	y_max = y_max + 30;
	z_max = z_max + 30;



	//or specify x_min, x_max, etc here

	if(param.specify_min_max == true){

		x_min = param.x_min;
		x_max = param.x_max;
		y_min = param.y_min;
		y_max = param.y_max;
		z_min = param.z_min;
		z_max = param.z_max;

	};

	cout << "x_min is" << x_min << endl;
	cout << "y_min is" << y_min << endl;
	cout << "z_min is" << z_min << endl;
	cout << "x_max is" << x_max << endl;
	cout << "y_max is" << y_max << endl;
	cout << "z_max is" << z_max << endl;

	param.change_size((x_max - x_min), (y_max - y_min), (z_max - z_min));

	short *temp_array; temp_array = new short[param.size3D];

	long ii_p, jj_p, kk_p, old_index;
	for(long ii=0;ii<param.size1D_x;ii++){
		for(long jj=0;jj<param.size1D_y;jj++){
			for(long kk=0;kk<param.size1D_z;kk++){
		
				ii_p=ii+x_min;
				jj_p=jj+y_min;
				kk_p=kk+z_min;

				old_index = ii_p+old_size1D_x*jj_p+old_size1D_x*old_size1D_y*kk_p;

				temp_array_(ii,jj,kk) = regions_array[old_index];

			}
		}
	}

		
	delete [] regions_array;
	regions_array = new short[param.size3D];

	for(long ii=0;ii<param.size1D_x;ii++){
		for(long jj=0;jj<param.size1D_y;jj++){
			for(long kk=0;kk<param.size1D_z;kk++){

				regions_array_(ii,jj,kk) = temp_array_(ii,jj,kk);

			}
		}
	}


	delete [] temp_array;

	ofstream out_stream;

	out_stream.open(param.filename_one_region);
	for(long zz=0;zz<param.size3D;zz++){
	out_stream << regions_array[zz] << " " ;
	};
	out_stream.close();
	cout << "one region printed" << endl;



}








void load_regions_function(char filename_txt_format[],  short regions_array[], parameters param){

	ifstream in_stream;

	in_stream.open(filename_txt_format);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<param.size3D;n++){
		in_stream >> regions_array[n];
	};

	in_stream.close();




}



void set_all_regions_to_one(short regions_array[], parameters param){

	for( long n=0;n<param.size3D; n++){

		if(regions_array[n] != 0){

			regions_array[n] = 1;

		}

	}


	ofstream out_stream;

	out_stream.open(param.filename_one_region);
	for(long zz=0;zz<param.size3D;zz++){
	out_stream << regions_array[zz] << " " ;
	};
	out_stream.close();
	cout << "all voxels set to 1 or 0" << endl;

}



void remove_singletons(short regions_array[], parameters param){

	long singleton_number;
	singleton_number = 0;

	short neighbor_region[300];
	short nb_num;
	short lg_nb;
	short lg_nb_num;

	for(long kk=1; kk<(param.size1D_z-1);kk++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long ii=1;ii<(param.size1D_x-1);ii++){

				nb_num=0;
				for (short m=0;m<300;m++){
					neighbor_region[m]=0;
				}

				if(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii+1,jj,kk))]=neighbor_region[(regions_array_(ii+1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii-1,jj,kk))]=neighbor_region[(regions_array_(ii-1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj+1,kk))]=neighbor_region[(regions_array_(ii,jj+1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj-1,kk))]=neighbor_region[(regions_array_(ii,jj-1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk+1))]=neighbor_region[(regions_array_(ii,jj,kk+1))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk-1))]=neighbor_region[(regions_array_(ii,jj,kk-1))]+1;
				}

				if(nb_num == 0){

					singleton_number = singleton_number + 1;
					
					lg_nb_num = neighbor_region[0];
					lg_nb = 0;
					for(short m=0;m<300; m++){
						if(neighbor_region[m] > lg_nb_num){
							lg_nb_num = neighbor_region[m];
							lg_nb = m;
						}
					}

					regions_array_(ii,jj,kk) = lg_nb;

				}

			}
		}
	}

	cout << "singleton_number " << singleton_number << endl;


}


void remove_doubletons(short regions_array[], parameters param){

		long doubleton_number;
	doubleton_number = 0;

	short neighbor_region[300];
	short nb_num;
	short lg_nb;
	short lg_nb_num;

	for(long kk=1; kk<(param.size1D_z-1);kk++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long ii=1;ii<(param.size1D_x-1);ii++){

				nb_num=0;
				for (short m=0;m<300;m++){
					neighbor_region[m]=0;
				}

				if(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii+1,jj,kk))]=neighbor_region[(regions_array_(ii+1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii-1,jj,kk))]=neighbor_region[(regions_array_(ii-1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj+1,kk))]=neighbor_region[(regions_array_(ii,jj+1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj-1,kk))]=neighbor_region[(regions_array_(ii,jj-1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk+1))]=neighbor_region[(regions_array_(ii,jj,kk+1))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk-1))]=neighbor_region[(regions_array_(ii,jj,kk-1))]+1;
				}

				if(nb_num < 3){

					doubleton_number = doubleton_number + 1;
					
					lg_nb_num = neighbor_region[0];
					lg_nb = 0;
					for(short m=0;m<300; m++){
						if(neighbor_region[m] > lg_nb_num){
							lg_nb_num = neighbor_region[m];
							lg_nb = m;
						}
					}

					if(lg_nb_num > 2){
						regions_array_(ii,jj,kk) = lg_nb;
					}

				}

			}
		}
	}

	cout << "doubleton_number " << doubleton_number << endl;


}


void remove_binytons(short regions_array[], parameters param){

		long binyton_number;
	binyton_number = 0;

	short neighbor_region[300];
	short nb_num;
	short lg_nb;
	short lg_nb_num;

	for(long kk=1; kk<(param.size1D_z-1);kk++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long ii=1;ii<(param.size1D_x-1);ii++){

				nb_num=0;
				for (short m=0;m<300;m++){
					neighbor_region[m]=0;
				}

				if(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii+1,jj,kk))]=neighbor_region[(regions_array_(ii+1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii-1,jj,kk))]=neighbor_region[(regions_array_(ii-1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj+1,kk))]=neighbor_region[(regions_array_(ii,jj+1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj-1,kk))]=neighbor_region[(regions_array_(ii,jj-1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk+1))]=neighbor_region[(regions_array_(ii,jj,kk+1))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk-1))]=neighbor_region[(regions_array_(ii,jj,kk-1))]+1;
				}

				if(nb_num < 2){

					binyton_number = binyton_number + 1;
					
					lg_nb_num = neighbor_region[0];
					lg_nb = 0;
					for(short m=0;m<300; m++){
						if(neighbor_region[m] > lg_nb_num){
							lg_nb_num = neighbor_region[m];
							lg_nb = m;
						}
					}

					if(lg_nb_num > 1){
						regions_array_(ii,jj,kk) = lg_nb;
					}

				}

			}
		}
	}

	cout << "binyton_number " << binyton_number << endl;


}


void remove_doubletonsr(short regions_array[], parameters param){

	short random_integer;
		long doubleton_number;
	doubleton_number = 0;

	short neighbor_region[300];
	short nb_num;
	short lg_nb;
	short lg_nb_num;

	for(long kk=1; kk<(param.size1D_z-1);kk++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long ii=1;ii<(param.size1D_x-1);ii++){

				nb_num=0;
				for (short m=0;m<300;m++){
					neighbor_region[m]=0;
				}

				if(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii+1,jj,kk))]=neighbor_region[(regions_array_(ii+1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii-1,jj,kk))]=neighbor_region[(regions_array_(ii-1,jj,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj+1,kk))]=neighbor_region[(regions_array_(ii,jj+1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj-1,kk))]=neighbor_region[(regions_array_(ii,jj-1,kk))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk+1))]=neighbor_region[(regions_array_(ii,jj,kk+1))]+1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)){
					nb_num = nb_num+1;
				}else{
					neighbor_region[(regions_array_(ii,jj,kk-1))]=neighbor_region[(regions_array_(ii,jj,kk-1))]+1;
				}

				if(nb_num < 3){

					doubleton_number = doubleton_number + 1;
					
					lg_nb_num = neighbor_region[0];
					lg_nb = 0;
					for(short m=0;m<300; m++){
						if(neighbor_region[m] > lg_nb_num){
							lg_nb_num = neighbor_region[m];
							lg_nb = m;
						}
					}

					if(lg_nb_num > 2){
						random_integer = (rand()%2);

						if(random_integer = 1){
							regions_array_(ii,jj,kk) = lg_nb;
						}
					}

				}

			}
		}
	}

	cout << "doubleton_number " << doubleton_number << endl;


}





