#include "stdafx.h"


void get_sizes(char filename_node[], char filename_ele[], short zl, parameters &param){

	long nodes_number;
	long tets_number;

	ifstream in_stream;

	in_stream.open(filename_node);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	in_stream >> nodes_number;

	in_stream.close();


	in_stream.open(filename_ele);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	in_stream >> tets_number;

	in_stream.close();

	param.nodes_number_old[zl] = nodes_number;
	param.tets_number_old[zl] = tets_number;


}



void load_nodes(double nodes[], char filename_node[], short zl, parameters param){

	double blank;

	ifstream in_stream;

	in_stream.open(filename_node);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	//the first number in the file should be the number of nodes;

	in_stream >> param.nodes_number_old[zl];
	in_stream >> blank;


	for(long n=0 ; n< param.nodes_number_old[zl] ; n++){
		in_stream >> blank;
		in_stream >> nodes[3*n+0];
		in_stream >> nodes[3*n+1];
		in_stream >> nodes[3*n+2];
	};

	//cout << nodes_array[0] << " " << nodes_array[1] << " " << nodes_array[2] << endl;
	//cout << nodes_array[3] << " " << nodes_array[4] << " " << nodes_array[5] << endl;
	//exit(1);

	in_stream.close();


}

void load_tets(long tets[], char filename_ele[], short zl, parameters param){

	long blank;

	ifstream in_stream;

	in_stream.open(filename_ele);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	//the first number in the file should be the number of nodes;

	in_stream >> param.tets_number_old[zl];
	in_stream >> blank;
	in_stream >> blank;

	for(long n=0 ; n< param.tets_number_old[zl] ; n++){
		in_stream >> blank;
		in_stream >> tets[5*n+0];
		in_stream >> tets[5*n+1];
		in_stream >> tets[5*n+2];
		in_stream >> tets[5*n+3];
		in_stream >> tets[5*n+4];
		tets[5*n+0]=tets[5*n+0]-1;
		tets[5*n+1]=tets[5*n+1]-1;
		tets[5*n+2]=tets[5*n+2]-1;
		tets[5*n+3]=tets[5*n+3]-1;


	};

	in_stream.close();

}




float signed_dist(float x, float y, float z, float signed_dist_array[], parameters param, short zoom_level){

	long s1Dx, s1Dy, s1Dz;

	if(zoom_level == 1){
		s1Dx = param.size1D_xl;
		s1Dy = param.size1D_yl;
		s1Dz = param.size1D_zl;
		x=x+1.5;
		y=y+1.5;
		z=z+1.5;
	}
	if(zoom_level == 2){
		s1Dx = param.size1D_xl_z2;
		s1Dy = param.size1D_yl_z2;
		s1Dz = param.size1D_zl_z2;
		x=x+1.0;
		y=y+1.0;
		z=z+1.0;
		x=x-8; x=x/2.0; x=x+8.0;
		y=y-8; y=y/2.0; y=y+8.0;
		z=z-8; z=z/2.0; z=z+8.0;
		
	}
	if(zoom_level == 3){
		s1Dx = param.size1D_xl_z3;
		s1Dy = param.size1D_yl_z3;
		s1Dz = param.size1D_zl_z3;
		x=x-8; x=x/4.0; x=x+8.0;
		y=y-8; y=y/4.0; y=y+8.0;
		z=z-8; z=z/4.0; z=z+8.0;
	}


	x = x*2;
	y = y*2;
	z = z*2;

	float val;
	float sd[8];
	long around[8];


	//note the defalut value is sensible only for tetrahedra refinements with conditions to be met at all points

	if( (x < 0) || (x > (s1Dx-1)) || (y < 0) || (y > (s1Dy-1)) || (z < 0) || (z > (s1Dz-1)) ){
		val = 800;
	}else{

	//finding 8 values around point

		around[0] = floor(x) + floor(y)*s1Dx + floor(z)*s1Dx*s1Dy;
		around[1] = ceil(x) + floor(y)*s1Dx + floor(z)*s1Dx*s1Dy;
		around[2] = floor(x) + ceil(y)*s1Dx + floor(z)*s1Dx*s1Dy;
		around[3] = ceil(x) + ceil(y)*s1Dx + floor(z)*s1Dx*s1Dy;
		around[4] = floor(x) + floor(y)*s1Dx + ceil(z)*s1Dx*s1Dy;
		around[5] = ceil(x) + floor(y)*s1Dx + ceil(z)*s1Dx*s1Dy;
		around[6] = floor(x) + ceil(y)*s1Dx + ceil(z)*s1Dx*s1Dy;
		around[7] = ceil(x) + ceil(y)*s1Dx + ceil(z)*s1Dx*s1Dy;

		for(short m=0;m<8;m++){
			sd[m] = signed_dist_array[around[m]];
		};


		
		float d1b = x - float(floor(x));
		float d2b = y - float(floor(y));
		float d3b = z - float(floor(z));
		float d1 = 1.0-d1b;
		float d2 = 1.0-d2b;
		float d3 = 1.0-d3b;

		val = sd[0]*d1*d2*d3 + sd[1]*d1b*d2*d3 + sd[2]*d1*d2b*d3 + sd[3]*d1b*d2b*d3 + sd[4]*d1*d2*d3b + sd[5]*d1b*d2*d3b + sd[6]*d1*d2b*d3b + sd[7]*d1b*d2b*d3b;

		//cout << x << " " << y << " " << z << endl;
		//cout << d1 << " " << d2 << " " << d3 << " " << d1b << " " <<d2b << " " << d3b << endl;
		//cout << sd[0] << " " << sd[1] << " " << sd[2] << " " << sd[3] << " " << sd[4] << " "<< sd[5] <<" "<< sd[6] << " "<< sd[7]<< endl;
		//cout << val << endl;
	};

	return val;



/*
	float val = sqrt( x*x + y*y + z*z) - 10.0; 

	return val;
*/

}






void fix_nodes_and_tets(double nodes_z1_old[], double nodes_z1_undef_old[], double nodes_z2_old[], double nodes_z3_old[], double nodes_z1_new[], double nodes_z1_undef_new[], double nodes_z2_new[], double nodes_z3_new[],
						long tets_z1_old[], long tets_z2_old[], long tets_z3_old[], long tets_z1_new[], long tets_z2_new[], long tets_z3_new[], float ls3[], float ls2[], float ls1[],
						short nodes_ok1[], parameters &param){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
							//////////////////////////////////////////////////////////////////////////////////////////////////


//first, the nodes to be kept need to be marked.  this is done with the nodes_ok[] array, which has entries 1 (keep) or 0 (throw out).  at the highest resolution,
							//we want to keep a node if it belongs to a non-zero tetrahedrah and throw it out outherwise.  


	long m1,m2,m3;
	long p1, p2, p3, p4, r;
	short rem=0;
	float xx, yy, zz;
	float ls_val;
	long p[4];


	

	for(long n=0;n<param.nodes_number_old[1];n++){
		nodes_ok1[n] = 0;
	}


	for(long n=0;n<param.tets_number_old[1]; n++){

		p1=tets_z1_old[5*n+0];
		p2=tets_z1_old[5*n+1];
		p3=tets_z1_old[5*n+2];
		p4=tets_z1_old[5*n+3];
		r=tets_z1_old[5*n+4];

		if(r != rem){
			nodes_ok1[p1] = 1;
			nodes_ok1[p2] = 1;
			nodes_ok1[p3] = 1;
			nodes_ok1[p4] = 1;
		}

	}

	
	cout << "nodes ok filled in" << endl;
	///////////////////////////////////////////////////////////////////////////////////////////////////////




							////////////////////////////////////////////////////////////////////////////////////////////////////
							/////////////////////////////////////////////////////////////////////////////////////////////////////

	//next we get the converter[] array using the nodes_ok[] array.

	long *converter1;
	converter1 = new long[param.nodes_number_old[1]];

	long m=0;
	for(long n=0;n<param.nodes_number_old[1];n++){

		if(nodes_ok1[n] != 0){

			converter1[n] = m;
			m=m+1;

		}else{

			converter1[n] = -1;

		}

	}

	

	cout << "converter made" << endl;



	cout << "old nodes number " << param.nodes_number_old[1] << endl;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//finally, we use the nodes_ok[] and converter[] arrays to make a new tets, nodes and nodes_tbd array

	long new_tets_number1 = 0;
	long new_nodes_number1 = 0;
	long new_tets_number2 = 0;
	long new_nodes_number2 = 0;
	long new_tets_number3 = 0;
	long new_nodes_number3 = 0;
	long new_nodes_number4 = 0;


	m=0;
	for(long n=0;n<param.nodes_number_old[1];n++){
		if(nodes_ok1[n] != 0){

			nodes_z1_new[3*m+0]=nodes_z1_old[3*n+0];
			nodes_z1_new[3*m+1]=nodes_z1_old[3*n+1];
			nodes_z1_new[3*m+2]=nodes_z1_old[3*n+2];

			nodes_z1_undef_new[3*m+0]=nodes_z1_undef_old[3*n+0];
			nodes_z1_undef_new[3*m+1]=nodes_z1_undef_old[3*n+1];
			nodes_z1_undef_new[3*m+2]=nodes_z1_undef_old[3*n+2];

			new_nodes_number1=new_nodes_number1+1;

			m=m+1;

		}
	}

	
	cout << "nodes new filled in" << endl;
	

	
///////////////////////////////////////////////////////////

	if(param.remove_cast == true){

	

	////////////////////////////////////////////////////////

	
	////////////////////////////////////////////////////////////

	m=0;
	for(long n=0;n<param.tets_number_old[1];n++){

		p1=tets_z1_old[5*n+0];
		p2=tets_z1_old[5*n+1];
		p3=tets_z1_old[5*n+2];
		p4=tets_z1_old[5*n+3];
		r=tets_z1_old[5*n+4];


			if(r != rem){

			tets_z1_new[5*m+0]=converter1[p1];
			tets_z1_new[5*m+1]=converter1[p2];
			tets_z1_new[5*m+2]=converter1[p3];
			tets_z1_new[5*m+3]=converter1[p4];
			tets_z1_new[5*m+4]=r;

			m=m+1;
			new_tets_number1 = new_tets_number1 + 1;

			}

		

	}

	}
	
	bool use;

	cout << "tets new filled in" << endl;


	///////////////////////////////////////////////////////////


	param.nodes_number_new[1] = new_nodes_number1;


	param.tets_number_new[1] = new_tets_number1;



}




	

void output(double nodes[], double nodes_undef[], long tets[], parameters param, short zl, char node_file[], char node_file_undef[], char tet_file[]){

	

	ofstream out_stream;

	out_stream.open(node_file);

	out_stream << param.nodes_number_new[zl] << " 3" << endl;

	for(long n=0;n<param.nodes_number_new[zl];n++){

		out_stream << (n+1) << " " << nodes[3*n+0] << " " << nodes[3*n+1] << " " << nodes[3*n+2] << endl;

	}

	out_stream.close();



	out_stream.open(node_file_undef);

	out_stream << param.nodes_number_new[zl] << " 3" << endl;

	for(long n=0;n<param.nodes_number_new[zl];n++){

		out_stream << (n+1) << " " << nodes_undef[3*n+0] << " " << nodes_undef[3*n+1] << " " << nodes_undef[3*n+2] << endl;

	}

	out_stream.close();

	


	

	out_stream.open(tet_file);

	out_stream << param.tets_number_new[zl] << " " << 4 << " " << 1 << endl;

	for(long n=0;n<param.tets_number_new[zl];n++){

		out_stream << (n+1) << " " << tets[n*5+0]+1 << " " << tets[n*5+1]+1 << " " << tets[n*5+2]+1 << " " << tets[n*5+3]+1 << " " << tets[n*5+4] << endl;

	}

	out_stream.close();

}




void load_signed_distance_function(char filename_txt_format[], float signed_dist_array[], parameters param, short zoom_level){

	long s3D;

	if(zoom_level == 1){
		s3D = param.size3Dl;
	}
	if(zoom_level == 2){
		s3D = param.size3Dl_z2;
	}
	if(zoom_level == 3){
		s3D = param.size3Dl_z3;
	}

	ifstream in_stream;

	in_stream.open(filename_txt_format);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<(s3D);n++){
		in_stream >> signed_dist_array[n];
	};

	in_stream.close();




}





