// brain_registration.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <fstream>
#include "sparse_matrix.h"



void get_sizes(char filename_node[], char filename_ele[], long &nodes_number, long &tets_number);

void initialize_parameters(long nodes_number_input, long tets_number_input);

void load_nodes(char filename_node[], parameters &param);
void load_tets(char filename_ele[], parameters &param);

void load_signed_distance_function(char filename_level_set[], float signed_dist_array[], parameters &param);

void load_regions(char filename_regions[], short regions_array[], parameters &param);


void get_node_info(node_info node_class[],  short regions_array[], float signed_dist_array[], parameters &param);



void output( parameters &param, char filename1[], char filename2[]);

//void output2(  parameters &param, char filename1[], char filename2[]);

void print_F(long t, parameters &param);


void pre_compute(  float tet_volumes[], parameters &param);

void calculate_elastic_forces(  float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param);
void calculate_gvf_forces(   short regions_array[],  node_info node_class[], float current_tet_volumes[], long t, face face_class[] ,parameters &param);

void get_tet_volumes(  float current_tet_volumes[], parameters &param);





short region(float x, float y, float z,  short regions_array[], parameters &param);


void get_ls(node_info node_class[], short regions_array[],  float signed_dist_array[], parameters &param);

void update_time_step(  float current_tet_volumes[], node_info node_class[], long t, parameters &param);

void delete_node_info(node_info node_class[], parameters &param);



////////////////////////////////////////////////////////////////////////

void smoothing(  short regions_array[], float signed_dist_array[] ,node_info node_class[], float current_tet_volumes[], long t, face face_class[], parameters &param);


void get_singleton_array(bool singleton_array[], short regions_array[], parameters &param);
void assign_singletons(node_info node_class[],  bool singleton_array[], parameters &param);
void get_fewn_array(bool fewn_array[], short regions_array[], parameters &param);
void assign_fewn(node_info node_class[],  bool fewn_array[], parameters &param);


long get_faces_number( node_info node_class[], parameters &param);
void get_faces( node_info node_class[], face face_class[], parameters &param);

void output_faces( face face_class[], parameters &param, char filename1[]);

void SG(short regions_array[],  node_info node_class[], float current_tet_volumes[], sparse_matrix &A, parameters &param);
void initialize_sparse_matrix(sparse_matrix &A, node_info node_class[], parameters &param);

void SG2(short regions_array[],  node_info node_class[], float current_tet_volumes[], sparse_matrix &A, parameters &param);
void initialize_sparse_matrix2(sparse_matrix &A, node_info node_class[], parameters &param);

void uninvert(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param);

void get_stats(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param);

void test_fnc1(float test_vec[]){

	
}

void test_fnc2(float test_vec[]){

	test_fnc1(test_vec);
	
}

void test_fnc3(float test_vec[]){

	test_fnc2(test_vec);
	
}

void m_const(long size, float input[], float constant, float M[]);
void m(float A[], float B[], float M[]);
void inv3(float input[], float M[], parameters &param);
float det3(float input[], parameters &param);
float trace3(float input[]);
void add(long size, float A[], float B[], float M[]);
void transpose3(float input[], float M[]);
void eye3(float M[]);
void out3(float input[]);
void trace3_alt(){

	//tr = input[0]+input[4]+input[8];

}

void vec_trans_vec(float vec1[], float vec2[], long &size, float &val);

void sparse_matrix_m_vec(sparse_matrix &A, float vec_in[], float vec_out[]);

int main( int argc, char *argv[])
{

	


//int main(int argc, _TCHAR* argv[]){

///////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//first, the parameters are set, the   initial vector fields and initial region are loaded

	/*
	if( argc < 27 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " segmentation_file_initial segmentation_file_final level_set_file_initial size_x size_y size_z node_file ele_file jagged_compression(0-false, 1-true) time_step_number eps E alpha zeta final_ele final_node file_F final_face node_file_undef zoom_level beta node_file_elast0 min_angle max_angle min_timestep inflation" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }
	*/

	if( argc < 7 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " region_file ls_file node_in_file ele_file node_out_file parameters_file " << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }
	

	parameters param;

	param.get_names(argv[1],argv[2],argv[3],argv[4],argv[5], argv[6]);

	//param.get_names(argv[1],argv[2],argv[3],argv[7],argv[8], argv[15], argv[16], argv[17], argv[18], argv[19], argv[22]);


	long nodes_number = 0;
	long tets_number = 0;		
	get_sizes(param.filename_node, param.filename_ele, nodes_number, tets_number);

	//param.initialize_parameters(nodes_number, tets_number, std::atoi(argv[4]),std::atoi(argv[5]),std::atoi(argv[6]),std::atoi(argv[9]), std::atoi(argv[10]),std::atoi(argv[11]),std::atoi(argv[12]),std::atoi(argv[13]),std::atoi(argv[14]),std::atoi(argv[20]),std::atoi(argv[21]),std::atoi(argv[23]),std::atoi(argv[24]),std::atoi(argv[25]),std::atoi(argv[26]));
	param.initialize_parameters(nodes_number, tets_number);
		
	
	
	
	long s3D;

	if(param.zoom_level == 1){
		s3D = param.size3D;
	}
	if(param.zoom_level == 2){
		s3D = param.size3D_z2;
	}
	if(param.zoom_level == 3){
		s3D = param.size3D_z3;
	}

	float *signed_dist_array; signed_dist_array = new float[8*s3D];
	load_signed_distance_function(param.filename_level_set, signed_dist_array, param);
	cout << "signed distance function loaded" << endl;
	
	short *regions_array; regions_array = new short[s3D];
	load_regions(param.filename_initial_region, regions_array, param);
	cout << "initial region loaded" <<endl;



	load_nodes( param.node_file_undef, param);
	cout << "nodes loaded" << endl;

	load_tets( param.filename_ele, param);
	cout << "tets loaded" << endl;

	


	node_info *node_class; node_class = new node_info[param.nodes_number];

	get_node_info(node_class,  regions_array,  signed_dist_array, param);

	cout << "node info found" << endl;

	////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////




	delete [] signed_dist_array;
	


	delete [] regions_array;


	sparse_matrix A;
	if(param.SG == true){
		if(param.jagged_compression == true){
			initialize_sparse_matrix2(A, node_class, param);
		}else{
			initialize_sparse_matrix2(A, node_class, param);
		}
	}


	param.faces_number = get_faces_number( node_class, param);

	face *face_class; face_class = new face[param.faces_number];

	get_faces( node_class, face_class, param);

	cout << "face info found" << endl;

	

	

			//some stuff needs to be computed from the original tetrahedral mesh. this is used in the elasticity calculations

	load_nodes( param.node_file_elast0, param);
	cout << "nodes loaded" << endl;

	float *tet_volumes; tet_volumes = new float[param.tets_number];


	
	param.dX_array_0=new float[param.tets_number];
	param.dX_array_3=new float[param.tets_number];
	param.dX_array_6=new float[param.tets_number];
	param.dX_array_1=new float[param.tets_number];
	param.dX_array_4=new float[param.tets_number];
	param.dX_array_7=new float[param.tets_number];
	param.dX_array_2=new float[param.tets_number];
	param.dX_array_5=new float[param.tets_number];
	param.dX_array_8=new float[param.tets_number];

	if(param.tets_number < param.tet_mem_lim ){

	param.inv3_dX_array_0=new float[param.tets_number];
	param.inv3_dX_array_3=new float[param.tets_number];
	param.inv3_dX_array_6=new float[param.tets_number];
	param.inv3_dX_array_1=new float[param.tets_number];
	param.inv3_dX_array_4=new float[param.tets_number];
	param.inv3_dX_array_7=new float[param.tets_number];
	param.inv3_dX_array_2=new float[param.tets_number];
	param.inv3_dX_array_5=new float[param.tets_number];
	param.inv3_dX_array_8=new float[param.tets_number];

	param.inv3_dx_array_0=new float[param.tets_number];
	param.inv3_dx_array_3=new float[param.tets_number];
	param.inv3_dx_array_6=new float[param.tets_number];
	param.inv3_dx_array_1=new float[param.tets_number];
	param.inv3_dx_array_4=new float[param.tets_number];
	param.inv3_dx_array_7=new float[param.tets_number];
	param.inv3_dx_array_2=new float[param.tets_number];
	param.inv3_dx_array_5=new float[param.tets_number];
	param.inv3_dx_array_8=new float[param.tets_number];

	}

	param.enf_x=new float[param.nodes_number];
	param.enf_y=new float[param.nodes_number];
	param.enf_z=new float[param.nodes_number];
	param.lsnf_x=new float[param.nodes_number];
	param.lsnf_y=new float[param.nodes_number];
	param.lsnf_z=new float[param.nodes_number];
	//param.snf_x=new float[param.nodes_number];
	//param.snf_y=new float[param.nodes_number];
	//param.snf_z=new float[param.nodes_number];

	param.tet_dls_dx = new float[param.tets_number];
	param.tet_dls_dy = new float[param.tets_number];
	param.tet_dls_dz = new float[param.tets_number];

	
	param.vec_b_xu = new float[param.nodes_number];
	param.vec_b_yu = new float[param.nodes_number];
	param.vec_b_zu = new float[param.nodes_number];

	param.vec_b_x = new float[param.nodes_number];
	param.vec_b_y = new float[param.nodes_number];
	param.vec_b_z = new float[param.nodes_number];



	float *current_tet_volumes; current_tet_volumes = new float[param.tets_number];
	for(long n=0;n<param.tets_number;n++){
		current_tet_volumes[n]=1000;
	}





	cout << "precompute start" << endl;
	pre_compute(tet_volumes, param);
	cout << "precompute finish" << endl;


	if(param.jagged_compression == false){
		load_nodes( param.filename_node, param);
		cout << "nodes loaded" << endl;
	}


	
	

	/////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	//once the stuff related to the initial vector field and initial region is computed, the final region and final vector field is loaded

	if(param.jagged_compression == false){
		regions_array = new short[s3D];
		load_regions(param.filename_final_region, regions_array, param);
		cout << "final region loaded" <<endl;
	}

	if(param.jagged_compression == true){
		regions_array = new short[s3D];
		load_regions(param.filename_initial_region, regions_array, param);
		cout << "initial region loaded" <<endl;
	}

	param.get_target_image_size(regions_array);

	


	/////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	




	

	
	


	

	float total_tet_vol;
	float sum_rec_20;
	float sum_prev_20;


//	morphing_accuracy(node_class, regions_array,  param);
	
	param.done_timestepping = false;

	bool done;
	param.first_SG = true;

	for(long t=0;t<param.time_step_number;t++){

		param.t = t;

		/*
		if(param.jagged_compression == true){
			if(t==0){
				param.delta_t = param.delta_t/40.0;
				param.SG = false;
				cout << "starting out with no SG" << endl;
			}
		}

		if(param.jagged_compression == true){
			if(t==100){
				param.delta_t = param.delta_t*40.0;
				param.SG = true;
				cout << "starting SG" << endl;
			}
		}
		*/
		
		


		//if(t < 5){
		//param.alpha = 30;
		//}else{
		//param.alpha = 0;
		//}

		

		if(t==param.constrain_time_step){	
			param.constrain = true;
		}


	

		
/*
		if(param.jagged_compression == true){
			get_tet_volumes(current_tet_volumes, param);
			update_time_step(current_tet_volumes, node_class, t, param);
		}
*/		


		calculate_elastic_forces(tet_volumes, node_class, current_tet_volumes, param);
		cout << "elastic forces " << t << endl;
		/*if(param.constrain == true){
			for(long n=0;n<param.nodes_number;n++){
				param.enf_x[n]=0;
				param.enf_y[n]=0;
				param.enf_z[n]=0;
			}
		}
*/

		if(param.inverted_count > 0){
			cout << "uninverting tets" << endl;
			uninvert(tet_volumes, node_class, current_tet_volumes, param);
			
			if(param.inverted_count > 0){
				cout << "uninverting tets" << endl;
				uninvert(tet_volumes, node_class, current_tet_volumes, param);
				
				if(param.inverted_count > 0){
					cout << "uninverting tets" << endl;
					uninvert(tet_volumes, node_class, current_tet_volumes, param);
							
					if(param.inverted_count > 0){
						cout << "uninverting tets" << endl;
						uninvert(tet_volumes, node_class, current_tet_volumes, param);
						
						if(param.inverted_count > 0){
							cout << "uninverting tets" << endl;
							uninvert(tet_volumes, node_class, current_tet_volumes, param);
							
						}

					}
				}
			}

			calculate_elastic_forces(tet_volumes, node_class, current_tet_volumes, param);
			cout << "elastic forces " << t << endl;

		}



		

		
		if(param.jagged_compression == false){
			calculate_gvf_forces( regions_array, node_class, current_tet_volumes, t, face_class, param);
			cout << "gvf_forces "  <<  t << endl;
		}


		if( (param.jagged_compression == true) ){
				smoothing(regions_array, signed_dist_array, node_class, current_tet_volumes, t, face_class, param);
				cout << "smoothing "  <<  t << endl;
			//if(param.fix == true){
			//	for(long n=0;n<param.nodes_number;n++){
			//		param.snf_x[n]=0;
			//		param.snf_y[n]=0;
			//		param.snf_z[n]=0;
			//	}
			//}
		}

		/*
		if( (t % 1) == 0){
			//param.update_time_step(  current_tet_volumes, node_class, t);
			update_time_step(  current_tet_volumes, node_class, t, param);
		}
		*/

		
		//constrain velocities
		

		
		if( (t == 0) ){

			/*
			if(param.jagged_compression==true){
				update_time_step(current_tet_volumes, node_class, t, param);
			}
*/

			total_tet_vol = 0;
			for(long n=0;n<param.tets_number;n++){
				if(param.t_r[n] !=0){
					total_tet_vol = total_tet_vol + current_tet_volumes[n];
				}
			}

			cout << "total tet volume = " << total_tet_vol << endl;


		}


		if(param.SG == true){

			if(param.jagged_compression == true){
				SG2(regions_array, node_class, current_tet_volumes, A, param);
			}else{
				SG2(regions_array, node_class, current_tet_volumes, A, param);
			}
		
		}else{


		if(param.jagged_compression == false){
			for(long n=0;n<(param.nodes_number);n++){

				
			
			//node_forces[n] = level_set_node_forces[n] + elastic_node_forces[n];
				param.n_x[n]=param.n_x[n]+param.delta_t*(param.lsnf_x[n]+param.enf_x[n]);
				param.n_y[n]=param.n_y[n]+param.delta_t*(param.lsnf_y[n]+param.enf_y[n]);
				param.n_z[n]=param.n_z[n]+param.delta_t*(param.lsnf_z[n]+param.enf_z[n]);

			}

		}

		if(param.jagged_compression == true){
			for(long n=0;n<(param.nodes_number);n++){

				//cout <<  param.n_x[n] << " " << param.n_y[n] << " " << param.n_z[n] << endl;

				//cout << " ls " << param.lsnf_x[n] << " " << param.lsnf_y[n] << " " << param.lsnf_z[n] << endl;
				//cout << " elast " << param.enf_x[n] << " " << param.enf_y[n] << " " << param.enf_z[n] << endl;

				param.n_x[n]=param.n_x[n]+param.delta_t*(param.lsnf_x[n]+param.enf_x[n]);
				param.n_y[n]=param.n_y[n]+param.delta_t*(param.lsnf_y[n]+param.enf_y[n]);
				param.n_z[n]=param.n_z[n]+param.delta_t*(param.lsnf_z[n]+param.enf_z[n]);



			}
		}

		}

		//if(param.jagged_compression == true){

		//	if(t==(param.time_step_number-50)){

		//		param.delta_t=param.delta_t/10.0;
		//		cout << "time step size reduced to " << param.delta_t << endl;

		//	}

		//}

		
		done = false;

		if(param.jagged_compression == false){

			if(t>50){

			sum_rec_20 = 0;
			sum_prev_20 = 0;

			for(short m=0;m<20;m++){

				sum_rec_20 = sum_rec_20 + param.G[t-m];
				sum_prev_20 = sum_prev_20 + param.G[t-m-20];

			}

			sum_rec_20=sum_rec_20/20.0;
			sum_prev_20=sum_prev_20/20.0;

			if( (sum_rec_20/sum_prev_20) > param.stop){
				done = true;
			}else{
				done = false;
			}

		}

		if(done == true){

			//break;

		}

		}





		}

		


/*
		if(t==100){
		char filename1[] = "t100.node";
		char filename2[] = "t100.ele";
		output( tets, param, filename1, filename2);
		char filename13[] = "t100b.node";
		char filename14[] = "t100b.ele";
		output2( tets, param, filename13, filename14);
		print_F(t, param);
		//morphing_accuracy(node_class, regions_array,  param);
		}

		if(t==200){
		char filename3[] = "t200.node";
		char filename4[] = "t200.ele";
		output( tets, param, filename3, filename4);
		char filename15[] = "t200b.node";
		char filename16[] = "t200b.ele";
		output2( tets, param, filename15, filename16);
		print_F(t, param);
		//morphing_accuracy(node_class, regions_array,  param);
		}

		

		if(t==300){
		char filename5[] = "t300.node";
		char filename6[] = "t300.ele";
		output( tets, param, filename5, filename6);
		char filename17[] = "t300b.node";
		char filename18[] = "t300b.ele";
		output2( tets, param, filename17, filename18);
		print_F(t, param);
		//morphing_accuracy(node_class, regions_array,  param);
		}

		
		if(t==500){
		char filename7[] = "t500.node";
		char filename8[] = "t500.ele";
		output(  param, filename7, filename8);
		char filename19[] = "t500b.node";
		char filename20[] = "t500b.ele";
		output2(  param, filename19, filename20);
		print_F(t, param);
		//morphing_accuracy(node_class, regions_array,  param);
		}
		

		if(t==50){
		char filename77[] = "t50.node";
		char filename78[] = "t50.ele";
		output(  param, filename77, filename78);
		char filename190[] = "t50b.node";
		char filename200[] = "t50b.ele";
		output2(  param, filename190, filename200);
		print_F(t, param);
		//morphing_accuracy(node_class, regions_array,  param);
		}
*/
		//cout << param.delta_t << endl;

		

	

	param.done_timestepping = true;

	get_stats(tet_volumes, node_class, current_tet_volumes, param);


	float largest_tet= .001;
	float smallest_tet = 1000000;

	total_tet_vol = 0;
			for(long n=0;n<param.tets_number;n++){
				if(param.t_r[n] !=0){

					total_tet_vol = total_tet_vol + current_tet_volumes[n];

					if(current_tet_volumes[n] > largest_tet){
						largest_tet = current_tet_volumes[n];
					}
					if(current_tet_volumes[n] < smallest_tet){
						smallest_tet = current_tet_volumes[n];
					}
				}
			}

			cout << "total tet volume = " << total_tet_vol << endl;
			cout << "smallest tet volume = " << smallest_tet << endl;
			cout << "largest tet volume = " << largest_tet << endl;

	ofstream out;




//and finally


	//char filename11[] = "final.node";
	//char filename12[] = "final.ele";
	//output(  param, param.final_node, param.final_ele);
	/*
	char filename21[] = "finalb.node";
	char filename22[] = "finalb.ele";
	output2(  param, filename21, filename22);
	print_F(param.time_step_number, param);
	//morphing_accuracy(node_class, regions_array,  param);
*/

	//output(  param, param.final_node, param.final_ele);

	//output_faces( face_class, param, param.final_face);

	


		//print corrected
		
		//char filename111[] = "initial_corrected.node";
		//char filename112[] = "initial_corrected.ele";

	/*
	for(long ii=0;ii<param.tets_number;ii++){

		if(param.inverted[ii] == false){

			param.t_1[ii]=1;
			param.t_2[ii]=1;
			param.t_3[ii]=1;
			param.t_4[ii]=1;

		}

	}
	*/

		output(  param, param.final_node, param.final_ele);

		//output_faces( face_class, param, param.final_face);

		if(param.jagged_compression == false){
			print_F(param.time_step_number, param);
		}
		

		cout << "corrected nodes/test printed" << endl;

	

}

