#include "stdafx.h"
#include <iostream>
#include <fstream>



void get_singleton_array(bool singleton_array[], short regions_array[], parameters &param){

	for(long ii=1;ii<(param.size1D_x-1);ii++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long kk=1;kk<(param.size1D_z-1);kk++){

				if( (regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)) ||
					(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)) ||
					(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)) ||
					(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)) ||
					(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)) ||
					(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)) ){

					singleton_array_(ii,jj,kk) = false;
				}else{
					singleton_array_(ii,jj,kk) = true;
				}

			}
		}
	}

}

bool singleton_region(float xx, float yy,float zz, bool singleton_array[], parameters &param){

	bool val = false;

	if( (xx < 1) || (xx > (param.size1D_x-2)) || (yy < 1) || (yy > (param.size1D_y-2)) || (zz < 1) || (zz > (param.size1D_z-2)) ){
		val = false;
	}else{


	float one = 1.0;
	float rx, ry, rz;
	long roundx, roundy, roundz;
	long roundx2, roundy2, roundz2;

	rx = fmod(xx, one);
	ry = fmod(yy, one);
	rz = fmod(zz, one);

	if(rx > .5){
		roundx = ceil(xx);
		roundx2 = roundx;
	}
	if(rx < .5){
		roundx = floor(xx);
		roundx2 = roundx;
	}
	if(ry > .5){
		roundy = ceil(yy);
		roundy2 = roundy;
	}
	if(ry < .5){
		roundy = floor(yy);
		roundy2 = roundy;
	}
	if(rz > .5){
		roundz = ceil(zz);
		roundz2 = roundz;
	}
	if(rz < .5){
		roundz = floor(zz);
		roundz2 = roundz;
	}

	if(rx == .5){
		roundx = floor(xx);
		roundx2 = ceil(xx);
	}
	if(ry == .5){
		roundy = floor(yy);
		roundy2 = ceil(yy);
	}
	if(rz == .5){
		roundz = floor(zz);
		roundz2 = ceil(zz);
	}

	if(singleton_array_(roundx, roundy, roundz) == true){
		val = true;
	}
	if(singleton_array_(roundx2, roundy, roundz) == true){
		val = true;
	}
	if(singleton_array_(roundx, roundy2, roundz) == true){
		val = true;
	}
	if(singleton_array_(roundx2, roundy2, roundz) == true){
		val = true;
	}
	if(singleton_array_(roundx, roundy, roundz2) == true){
		val = true;
	}
	if(singleton_array_(roundx2, roundy, roundz2) == true){
		val = true;
	}
	if(singleton_array_(roundx, roundy2, roundz2) == true){
		val = true;
	}
	if(singleton_array_(roundx2, roundy2, roundz2) == true){
		val = true;
	}

	}

	return val;

}

/*
void assign_singletons(node_info node_class[],  bool singleton_array[], parameters &param){

	float xx, yy, zz;

	for(long n=0;n<param.nodes_number;n++){

		xx = param.n_x[n];
		yy = param.n_y[n];
		zz = param.n_z[n];

		node_class[n].singleton = singleton_region(xx,yy,zz,singleton_array,param);

	}

}
*/



void get_fewn_array(bool fewn_array[], short regions_array[], parameters &param){

	short neighb_num;

	for(long ii=1;ii<(param.size1D_x-1);ii++){
		for(long jj=1;jj<(param.size1D_y-1);jj++){
			for(long kk=1;kk<(param.size1D_z-1);kk++){

				neighb_num = 0;

				if(regions_array_(ii,jj,kk) == regions_array_(ii-1,jj,kk)){
					neighb_num = neighb_num +1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii+1,jj,kk)){
					neighb_num = neighb_num +1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj-1,kk)){
					neighb_num = neighb_num +1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj+1,kk)){
					neighb_num = neighb_num +1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk-1)){
					neighb_num = neighb_num +1;
				}
				if(regions_array_(ii,jj,kk) == regions_array_(ii,jj,kk+1)){
					neighb_num = neighb_num +1;
				}
				if(neighb_num > 2){
					fewn_array_(ii,jj,kk) = false;
				}else{
					fewn_array_(ii,jj,kk) = true;
				}

			}
		}
	}

}

/*
void assign_fewn(node_info node_class[],  bool fewn_array[], parameters &param){

	float xx, yy, zz;

	for(long n=0;n<param.nodes_number;n++){

		xx = param.n_x[n];
		yy = param.n_y[n];
		zz = param.n_z[n];

		node_class[n].fewn = singleton_region(xx,yy,zz,fewn_array,param);

	}

}
*/







	


