#include "stdafx.h"


#include "hexa.h"
#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"



/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


void initialize_node_class_array(float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[], 
								 float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[],
								 long node_array_grid1[], long node_array_grid2[], node node_class_array[],parameters &param){

	
	for( long n=0; n < (param.nodes_grid1_number); n++){

		node_class_array[n].initialize_node1(n, x_coordinate_array_grid1, y_coordinate_array_grid1, z_coordinate_array_grid1, node_array_grid1);

	};

	for( long n= param.nodes_grid1_number; n < (param.nodes_grid1_number + param.nodes_grid2_number); n++){

		node_class_array[n].initialize_node2(n - param.nodes_grid1_number, x_coordinate_array_grid2, y_coordinate_array_grid2, z_coordinate_array_grid2, node_array_grid2, param);

	};

}


////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////





/////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void initialize_tet_class_array(long node_array_grid1[], long node_array_grid2[], long tet_array_initial[], tet tet_class_array[], node node_class_array[],parameters &param){


	//Here, the nodes of the all the initial tetrahedra are entered.  



	//Between every connection in grid2, there are 4 triangles wrapped around it.
	//I am associating each point in grid2 with 12 triangles.  4  forward,
	//4 right, and 4 above.   

	//I am not not associating any tetrahedra with points on the front, top and right edge
	//of grid2.  

	//The tets formed here will be rough around the edges.  The object that is being meshed
	//needs to be well inside the grids.

	//note that the nodes being pointed to are 0 to nodes_grid1_number-1 for grid 1 and 0 to nodes_grid2_number-1
	//for grid2. (even though the values of nodes_grid2_number are larger)

	long move_forward = 1;
	long move_right = param.x_nodes;
	long move_up = (param.x_nodes)*(param.y_nodes);

	long index;
	long index12;
	
	long u,v,w;
	long index_fru;

	for (long k=0; k < (param.z_nodes - 1); k++){
	for (long j=0; j < (param.y_nodes - 1); j++){
	for (long i=0; i < (param.x_nodes - 1); i++){


		///////////////////////////////////////////////////////////////////////////////////////////////
		//this code sets the nodes that are attached to a tetrahedra to not be removed
		
		u=i+1;
		v=j+1;
		w=k+1;

		index_fru = u*move_forward + move_right*v + move_up*w;

		node_class_array[index_fru].set_remove_false ();

		index = i*move_forward + move_right*j + move_up*k;

		node_class_array[index_fru + param.nodes_grid1_number].set_remove_false ();
		node_class_array[index + param.nodes_grid1_number].set_remove_false ();


		////////////////////////////////////////////////////////////////////////////////////////////////
		//for the tets	

		index = i*move_forward + move_right*j + move_up*k;

		
		index12 = 12*index;


		//four tets around forward backward connection on grid2

		tet_class_array[index12+0].initialize_tet(index12+0, index, index + move_forward, index + move_forward + move_right, index + move_forward + move_right + move_up, tet_array_initial, node_array_grid1, node_array_grid2, param);   
		tet_class_array[index12+1].initialize_tet(index12+1, index, index + move_forward, index + move_forward, index + move_forward + move_right, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+2].initialize_tet(index12+2, index, index + move_forward, index + move_forward + move_up, index + move_forward, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+3].initialize_tet(index12+3, index, index + move_forward, index + move_forward + move_right + move_up, index + move_forward + move_up, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
	


		//four tets around left right connection on grid2
		tet_class_array[index12+4].initialize_tet(index12+4, index, index + move_right, index + move_right + move_forward, index + move_right + move_forward + move_up, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+5].initialize_tet(index12+5, index, index + move_right, index + move_right, index + move_right + move_forward, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+6].initialize_tet(index12+6, index, index + move_right, index + move_right + move_up, index + move_right, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+7].initialize_tet(index12+7, index, index + move_right, index + move_right + move_forward + move_up, index + move_right + move_up, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
	

		//four tets around up down connection on grid2

		tet_class_array[index12+8].initialize_tet(index12+8, index, index + move_up, index + move_up + move_forward + move_right, index + move_up + move_right, tet_array_initial, node_array_grid1, node_array_grid2,  param);
		tet_class_array[index12+9].initialize_tet(index12+9, index, index + move_up, index + move_up + move_right, index + move_up, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+10].initialize_tet(index12+10, index, index + move_up, index + move_up, index + move_up + move_forward, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		tet_class_array[index12+11].initialize_tet(index12+11, index, index + move_up, index + move_up + move_forward, index + move_up + move_forward + move_right, tet_array_initial, node_array_grid1, node_array_grid2,  param);   
		

	};
	};
	};



}

///////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////


void pre_initialize(node node_class_array[], tet tet_class_array[],parameters &param){

	long n;

	for(n=0; n< param.initial_node_number; n++){

		node_class_array[n].set_remove_true ();

	};

	for(n=0; n< param.initial_tet_number; n++){

		//note that all of the tets created at first are used

		tet_class_array[n].set_remove_true ();
		tet_class_array[n].set_tet_color (no_color);
		tet_class_array[n].set_edge_number ();
		tet_class_array[n].set_totally_remove_true ();

	};

}

void pre_initialize_face(face face_class_array[], long face_array[], long face_class_array_size){

	for(long n=0; n< face_class_array_size; n++){

		face_class_array[n].set_remove_true ();
//		face_class_array[n].set_tet_color (no_color);
		face_class_array[n].set_face_number(n, face_array, face_class_array_size);
		face_class_array[n].set_edge_number ();

	};

}

void pre_initialize_edge(edge edge_class_array[], long edge_array[], long edge_class_array_size){

	for(long n=0; n< edge_class_array_size; n++){

		edge_class_array[n].set_use_split_true ();
		edge_class_array[n].set_no_split ();
		edge_class_array[n].set_edge_number(n, edge_array, edge_class_array_size);

	};

}


void new_node_class_array(node new_node_class_array[], long new_node_class_array_size, long node_class_array_size, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[]){

	for(long n=0; n<new_node_class_array_size; n++){

		new_node_class_array[n].new_node(n, new_node_array, new_x_coordinate_array, new_y_coordinate_array, new_z_coordinate_array);

	};

}



void pre_initialize_hexa(hexa hexa_class_array[], node node_class_array[], long hexa_size, long node_size){

	for(long n=0; n< hexa_size; n++){

		hexa_class_array[n].pre_initialize();

	};

	
	for(long n=0; n< node_size; n++){

		node_class_array[n].empty_hexa();

	};
	

}

void pre_initialize_node_for_hexa(node node_class_array[], long node_size){

	for(long n=0; n< node_size; n++){

		node_class_array[n].empty_hexa();

	};

}

long hex_entered(long node1, long node2, node node_class_array[]){

	long hexa_val = -1;

	for(short n=0;n<8;n++){
		for(short m=0;m<8;m++){
			if( (node_class_array[node1].hexa_belong[n] == node_class_array[node2].hexa_belong[m]) && ( node_class_array[node1].hexa_belong[n] != -1) ){
				hexa_val = node_class_array[node1].hexa_belong[n];
			}
		}
	}

	/*
	for (short m=0;m<8;m++){
		cout << node_class_array[node1].hexa_belong[m] << endl;
	}
	cout << " " << endl;
	*/
	return hexa_val;

}
	









