#include "stdafx.h"

#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"
#include "hexa.h"


void hexa::pre_initialize(){

	tet1 = -1;
	tet2 = -1;
	tet3 = -1;
	tet4 = -1;

	main_node[0]=-1;
	main_node[1]=-1;
	main_region[0]=-1;
	main_region[1]=-1;

	other_node[0]=-1;
	other_node[1]=-1;
	other_node[2]=-1;
	other_node[3]=-1;
	other_region[0]=-1;
	other_region[1]=-1;
	other_region[2]=-1;
	other_region[3]=-1;

	diag = 0;

	removed = true;

}





void hexa::add_tet(long tet_num, long main1_input,long main2_input, long other1_input, long other2_input, short main1r_input, short main2r_input, short other1r_input, short other2r_input){

	//cout << tet1 << " " << tet2 << " " << tet3 << " " << tet4 << " " << tet_num << endl;

	if(tet1 == -1){
		tet1 = tet_num;
	}else{
		if(tet2 == -1){
			tet2 = tet_num;
		}else{
			if(tet3 == -1){
				tet3 = tet_num;
			}else{
				if(tet4 == -1){
					tet4 = tet_num;
				}else{
					cout << tet1 << " " << tet2 << " " << tet3 << " " << tet4 << " " << tet_num << endl;
					cout << "tried to enter more than 4 tets into a hexa " << endl;
					exit(1);
				}
			}
		}
	}

	//cout << " tets " << tet1 << " " << tet2 << " " << tet3 << " " << tet4 << endl;


	bool get_diag = false;
	bool other_entered1 = false;
	bool other_entered2 = false;


	main_node[0]=main1_input;
	main_region[0]=main1r_input;
	main_node[1]=main2_input;
	main_region[1]=main2r_input;

	if(other_node[0] == -1){
		other_node[0]=other1_input;
		other_region[0]=other1r_input;
		other_node[1]=other2_input;
		other_region[1]=other2r_input;
	}else{

		short first_empty_slot;

		first_empty_slot = 4;
		if(other_node[3] == -1){
			first_empty_slot = 3;
		}
		if(other_node[2] == -1){
			first_empty_slot = 2;
		}

		if( (other_node[0] != other1_input) && (other_node[1] != other1_input) && (other_node[2] != other1_input) && (other_node[3] != other1_input) ){
			other_node[first_empty_slot]=other1_input;
			other_region[first_empty_slot]=other1r_input;
			first_empty_slot = first_empty_slot+1;
			other_entered1 = true;
		}
		if( (other_node[0] != other2_input) && (other_node[1] != other2_input) && (other_node[2] != other2_input) && (other_node[3] != other2_input) ){
			other_node[first_empty_slot]=other2_input;
			other_region[first_empty_slot]=other2r_input;
			first_empty_slot = first_empty_slot+1;
			other_entered2 = true;
		}

		if(first_empty_slot == 4){
			removed = false;

			//cout << "nodes " << main_node[0] << " " << main_node[1] << " " << other_node[0] << " " << other_node[1] << " " << other_node[2] << " " << other_node[3] << " " << endl;
		}

		//corner

		if(first_empty_slot == 3){
			if(other_entered1 == true){
				if(other2_input == other_node[0]){
					diag = 12;
				}
				if(other2_input == other_node[1]){
					diag = 02;
				}
			}
			if(other_entered2 == true){
				if(other1_input == other_node[0]){
					diag = 12;
				}
				if(other1_input == other_node[1]){
					diag = 02;
				}
			}

			//cout << other_node[0] << " " << other_node[1] << " " << other_node[2] << " " << other_node[3] << endl; 
			//cout << "diag " << diag << endl;
		}

		//4 already entered

		if( (first_empty_slot == 4) && (other_entered1 == false) && (other_entered2 == false) ){

			//if( (other1_input != other_node[0]) && (other1_input != other_node[1]) ){
			if(other1_input == other_node[2]){
				if(other2_input == other_node[0]){
					diag = 12;
				}
				if(other2_input == other_node[1]){
					diag = 02;
				}
			}
			if(other1_input == other_node[3]){
				if(other2_input == other_node[0]){
					diag = 13;
				}
				if(other2_input == other_node[1]){
					diag = 03;
				}
			}
			if(other2_input == other_node[2]){
				if(other1_input == other_node[0]){
					diag = 12;
				}
				if(other1_input == other_node[1]){
					diag = 02;
				}
			}
			if(other2_input == other_node[3]){
				if(other2_input == other_node[0]){
					diag = 13;
				}
				if(other2_input == other_node[1]){
					diag = 03;
				}
			}
		}


	}

}









void hexa::remake_4_tets(bool use_02, bool use_03, bool use_12, bool use_13){


	if( (diag == 03) || (diag == 12) ){

		t1[0] = main_node[0];
		t1[1] = other_node[0];
		t1[2] = other_node[3];
		t1[3] = other_node[2];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[0];
		t2[2] = other_node[3];
		t2[3] = other_node[1];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[0];
		t3[2] = other_node[3];
		t3[3] = other_node[2];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[0];
		t4[2] = other_node[3];
		t4[3] = other_node[1];
		r4 = main_region[1];

		diag_node_1 = other_node[0];
		diag_node_2 = other_node[3];

	}

	if( (diag == 02) || (diag == 13) ){

		t1[0] = main_node[0];
		t1[1] = other_node[0];
		t1[2] = other_node[2];
		t1[3] = other_node[1];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[0];
		t2[2] = other_node[2];
		t2[3] = other_node[3];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[0];
		t3[2] = other_node[2];
		t3[3] = other_node[1];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[0];
		t4[2] = other_node[2];
		t4[3] = other_node[3];
		r4 = main_region[1];

		diag_node_1 = other_node[0];
		diag_node_2 = other_node[2];

	}

	if(use_02 == true){

		t1[0] = main_node[0];
		t1[1] = other_node[0];
		t1[2] = other_node[2];
		t1[3] = other_node[1];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[0];
		t2[2] = other_node[2];
		t2[3] = other_node[3];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[0];
		t3[2] = other_node[2];
		t3[3] = other_node[1];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[0];
		t4[2] = other_node[2];
		t4[3] = other_node[3];
		r4 = main_region[1];

		diag_node_1 = other_node[0];
		diag_node_2 = other_node[2];

	}

	if(use_03 == true){

		t1[0] = main_node[0];
		t1[1] = other_node[0];
		t1[2] = other_node[3];
		t1[3] = other_node[2];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[0];
		t2[2] = other_node[3];
		t2[3] = other_node[1];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[0];
		t3[2] = other_node[3];
		t3[3] = other_node[2];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[0];
		t4[2] = other_node[3];
		t4[3] = other_node[1];
		r4 = main_region[1];

		diag_node_1 = other_node[0];
		diag_node_2 = other_node[3];

	}

	if(use_12 == true){

		t1[0] = main_node[0];
		t1[1] = other_node[1];
		t1[2] = other_node[2];
		t1[3] = other_node[0];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[1];
		t2[2] = other_node[2];
		t2[3] = other_node[3];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[1];
		t3[2] = other_node[2];
		t3[3] = other_node[0];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[1];
		t4[2] = other_node[2];
		t4[3] = other_node[3];
		r4 = main_region[1];

		diag_node_1 = other_node[1];
		diag_node_2 = other_node[2];

	}

	if(use_13 == true){

		t1[0] = main_node[0];
		t1[1] = other_node[1];
		t1[2] = other_node[3];
		t1[3] = other_node[0];
		r1 = main_region[0];

		t2[0] = main_node[0];
		t2[1] = other_node[1];
		t2[2] = other_node[3];
		t2[3] = other_node[2];
		r2 = main_region[0];

		t3[0] = main_node[1];
		t3[1] = other_node[1];
		t3[2] = other_node[3];
		t3[3] = other_node[0];
		r3 = main_region[1];

		t4[0] = main_node[1];
		t4[1] = other_node[1];
		t4[2] = other_node[3];
		t4[3] = other_node[2];
		r4 = main_region[1];

		diag_node_1 = other_node[1];
		diag_node_2 = other_node[3];

	}





/*
	tet_class_array[tet_input1].node1 = node_class_array[t1[0]].node_number;
	tet_class_array[tet_input1].node2 = node_class_array[t1[1]].node_number;
	tet_class_array[tet_input1].node3 = node_class_array[t1[2]].node_number;
	tet_class_array[tet_input1].node4 = node_class_array[t1[3]].node_number;
	tet_class_array[tet_input1].region = r1;

	tet_class_array[tet_input2].node1 = node_class_array[t2[0]].node_number;
	tet_class_array[tet_input2].node2 = node_class_array[t2[1]].node_number;
	tet_class_array[tet_input2].node3 = node_class_array[t2[2]].node_number;
	tet_class_array[tet_input2].node4 = node_class_array[t2[3]].node_number;
	tet_class_array[tet_input2].region = r2;

	tet_class_array[tet_input3].node1 = node_class_array[t3[0]].node_number;
	tet_class_array[tet_input3].node2 = node_class_array[t3[1]].node_number;
	tet_class_array[tet_input3].node3 = node_class_array[t3[2]].node_number;
	tet_class_array[tet_input3].node4 = node_class_array[t3[3]].node_number;
	tet_class_array[tet_input3].region = r3;

	tet_class_array[tet_input4].node1 = node_class_array[t4[0]].node_number;
	tet_class_array[tet_input4].node2 = node_class_array[t4[1]].node_number;
	tet_class_array[tet_input4].node3 = node_class_array[t4[2]].node_number;
	tet_class_array[tet_input4].node4 = node_class_array[t4[3]].node_number;
	tet_class_array[tet_input4].region = r4;
*/
}




	