// TET.cpp : Defines the entry point for the console application.
//  


//  


#include "stdafx.h"
#include <fstream>
using namespace std;





#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"
#include "hexa.h"


///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////
void load_signed_distance_function(char filename_txt_format[], float signed_dist_array[],parameters &param, short zoom_level);

//////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////


void initialize_coordinate_array(float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[],
								 float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[],parameters &param);
void initialize_node_array(long node_array_grid1[], long node_array_grid2[],parameters &param);
void initialize_tet_array(long tet_array_initial[],parameters &param);
void pre_initialize(node node_class_array[], tet tet_class_array[],parameters &param);
void initialize_node_class_array(float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[], 
								 float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[],
								 long node_array_grid1[], long node_array_grid2[], node node_class_array[],parameters &param);
void initialize_tet_class_array(long node_array_grid1[], long node_array_grid2[], long tet_array_initial[], tet tet_class_array[], node node_class_array[],parameters &param);
///////////////////////////////////////////////////////////////////////////////////////////////////////////	
void remove(node node_class_array[], long node_number, edge edge_class_array[], long edge_number, tet tet_class_array[], long tet_number);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void remove_node_belongings(node node_class_array[], long node_class_array_size);
//long count_face(tet tet_class_array[], long tet_class_array_size);
void new_face_array(long new_face_array[], long new_face_array_size, long previous_face_array_size);
void pre_initialize_face(face face_class_array[], long face_array[], long face_class_array_size);
void insert_previous_faces(face previous_face_class_array[], long previous_face_class_array_size, face face_class_array[]);
void set_face_class_array(tet tet_class_array[], long tet_class_array_size, face face_class_array[], long &face_class_array_size, node node_class_array[]);
void resize_face_class_array(face face_class_array[], long face_class_array_size);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//long count_edge(tet tet_class_array[], long tet_class_array_size);
void new_edge_array(long edge_array[], long edge_array_size, long previous_edge_array_size);
void pre_initialize_edge(edge edge_class_array[], long edge_array[], long edge_class_array_size);
void insert_previous_edges(edge previous_edge_class_array[], long previous_edge_class_array_size, edge edge_class_array[]);
void set_edge_class_array(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[], long &edge_class_array_size, node node_class_array[], face face_class_array[]);
void resize_edge_class_array(edge edge_class_array[], long edge_class_array_size);



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void pre_red_refine(node node_class_array[], edge edge_class_array[], tet tet_class_array[], long tet_class_array_size,  face face_class_array[],  float signed_dist_array[], float signed_dist_array2[], float signed_dist_array3[],parameters &param, short level_input);
void mark_green_edge_splits(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[]);
long calc_tet_class_array_red_size(tet tet_class_array[], long tet_class_array_size);
long calc_new_node_class_array_size (edge edge_class_array[], long edge_class_array_size);
void new_node_array(long node_array_size, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[], node node_class_array_input[], edge edge_class_array[], long edge_class_array_size, tet tet_class_array[], long tet_class_array_size);
void new_node_class_array(node new_node_class_array[], long new_node_class_array_size, long node_class_array_size, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[]);
//void assign_split_nodes_to_green_tets(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[]);
void new_tet_array(long new_tet_array[], long new_tet_array_size, long tet_array_size);
void red_refine(node node_class_array[], node new_node_class_array[],  long node_array_size, edge edge_class_array[], tet tet_class_array[], long new_tet_array[], long tet_class_array_size, tet new_tet_class_array[], short level_input, parameters &param);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void pre_green(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[], face face_class_array[]);
long green_tet_size (tet tet_class_array[], long tet_class_array_size, long tet_class_array_size_total);
void new_tet_array(long new_tet_array[], long new_tet_array_size, long tet_array_size);
void green_refine(tet tet_class_array[], tet new_tet_class_array[], long tet_class_array_size, long new_tet_array[], edge edge_class_array[], short level_input, parameters &param);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void compile_node_class_arrays( node node_class_array_input[], long node_class_array_input_size, node node_class_array_red_input[], long node_class_array_red_input_size, node node_class_array_output[]);
void compile_tet_class_arrays( tet tet_class_array_input[], long tet_class_array_input_size, tet tet_class_array_red_input[], long tet_class_array_red_input_size, tet tet_class_array_green_input[], long tet_class_array_green_input_size, tet tet_class_array_output[]);



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//float signed_dist(float x, float y, float z, float signed_dist_array[],parameters &param);
void load_regions_function(char filename_txt_format[],  short regions_array[],parameters &param, short zoom_level);
void pre_process_regions(short regions_array[],parameters &param);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void pre_initialize_hexa(hexa hexa_class_array[], node node_class_array[], long hexa_size, long node_size);
void pre_initialize_node_for_hexa(node node_class_array[], long node_size);
long hex_entered(long node1, long node2, node node_class_array[]);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void get_regions(tet tet_class_array[],long tet_class_array_size, tet tet_class_array_red[], long tet_class_array_red_size, tet tet_class_array_green[], long tet_class_array_green_size, node node_class_array[], short regions_array[],parameters &param, short zoom_level);
void hexagonize(tet tet_class_array_red[], long tet_class_array_red_size, node node_class_array[], long node_class_array_size, short regions_array[],parameters &param, short zoom_level);
void output(tet tet_class_array[], long tet_class_array_size, tet tet_class_array_red[], long tet_class_array_red_size, tet tet_class_array_green[], long tet_class_array_green_size, node node_class_array[], long node_class_array_size,parameters &param, char node_file[], char ele_file[]);

void output_tbd_nodes(long node_array_red_size, long node_array_size, edge edge_class_array[], long edge_class_array_size,parameters &param, char node_tbd_file[]);

void make_ls_list(node node_class_array[], float signed_dist_array[], float signed_dist_array2[], float signed_dist_array3[], long node_size, parameters param);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

 short region(float x, float y, float z,  short region_array[],parameters &param);

float vec_length(float vec[]){

	float length;
	length = sqrt(vec[0]*vec[0]+vec[1]*vec[1]+vec[2]*vec[2]);

	return length;

}

int main( int argc, char *argv[])
{

	/*
if( argc < 21 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " segmentation_text_file level_set_file size_x size_y size_z largest_grid_space number_of_refinements (max 5) filename_ele filename_node region_file_z2 ls_file_z2 region_file_z3 ls_file_z3 output_ele_file_z2 output_node_file_z2 output_ele_file_z3 output_node_file_z3 output_node_tbd_z1 output_node_tbd_z2 output_node_tbd_z3" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }
	*/


	if( argc < 6 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " region_file ls_file ele node parameters" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }






	parameters param;
	param.initialize_parameters(argv[1],argv[2],argv[4],argv[3],argv[5]);




	//param.initialize_parameters(argv[1],argv[2],std::atoi(argv[3]),std::atoi(argv[4]),std::atoi(argv[5]),std::atoi(argv[6]),std::atoi(argv[7]), argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14],argv[15] ,argv[16] ,argv[17] ,argv[18], argv[19], argv[20]);

	param.use_lite = false;
	param.use_list = false;

	////////////////////////////////////////////////////
/*
	cout << "make test tets" << endl;
	long tval = 15000000;

	tet_lite *test_tet1; test_tet1 = new tet_lite[tval];
	cout << "1" << endl;

	tet_lite *test_tet2; test_tet2 = new tet_lite[tval];
	cout << "2" << endl;

	tet_lite *test_tet3; test_tet3 = new tet_lite[tval];
	cout << "3" << endl;

	tet_lite *test_tet4; test_tet4 = new tet_lite[tval];
	cout << "4" << endl;

	tet_lite *test_tet5; test_tet5 = new tet_lite[tval];
	cout << "5" << endl;

	tet_lite *test_tet6; test_tet6 = new tet_lite[tval];
	cout << "6" << endl;

	exit(1);

*/
	////////////////////////////////////////////////////


//load signed distance function

	
	float *signed_dist_array; signed_dist_array = new float[param.size3Dl];
	float *signed_dist_array2; signed_dist_array2 = new float[param.size3Dl_z2];
	float *signed_dist_array3; signed_dist_array3 = new float[param.size3Dl_z3];
	load_signed_distance_function(param.filename_ls, signed_dist_array, param, 1);
	//load_signed_distance_function(param.ls_file_z2, signed_dist_array2, param, 2);
	//load_signed_distance_function(param.ls_file_z3, signed_dist_array3, param, 3);



//initializes the largest tetrahedra and associated nodes

	float *x_coordinate_array_grid1;
	x_coordinate_array_grid1 = new float[param.nodes_grid1_number];
	float *y_coordinate_array_grid1;
	y_coordinate_array_grid1 = new float[param.nodes_grid1_number];
	float *z_coordinate_array_grid1;
	z_coordinate_array_grid1 = new float[param.nodes_grid1_number];
	float *x_coordinate_array_grid2;
	x_coordinate_array_grid2 = new float[param.nodes_grid2_number];
	float *y_coordinate_array_grid2;
	y_coordinate_array_grid2 = new float[param.nodes_grid2_number];
	float *z_coordinate_array_grid2;
	z_coordinate_array_grid2 = new float[param.nodes_grid2_number];
	long *node_array_grid1;
	node_array_grid1 = new long[param.nodes_grid1_number];
	long *node_array_grid2;
	node_array_grid2 = new long[param.nodes_grid2_number];
	long *tet_array_initial;
	tet_array_initial = new long[param.initial_tet_number];

	node *node_class_array;
	node_class_array = new node[param.initial_node_number];
	tet *tet_class_array;
	tet_class_array = new tet[param.initial_tet_number];

	initialize_coordinate_array(x_coordinate_array_grid1, y_coordinate_array_grid1, z_coordinate_array_grid1,
								 x_coordinate_array_grid2, y_coordinate_array_grid2, z_coordinate_array_grid2, param);

	initialize_node_array(node_array_grid1, node_array_grid2, param);

	initialize_tet_array(tet_array_initial, param);

	pre_initialize(node_class_array, tet_class_array, param);

	initialize_node_class_array(x_coordinate_array_grid1, y_coordinate_array_grid1, z_coordinate_array_grid1, 
								 x_coordinate_array_grid2, y_coordinate_array_grid2, z_coordinate_array_grid2,
								 node_array_grid1, node_array_grid2, node_class_array, param);

	initialize_tet_class_array(node_array_grid1, node_array_grid2, tet_array_initial, tet_class_array, node_class_array, param);


cout << "1st Tets and Nodes initialized" << endl;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//finds the first set of edges and faces


//faces
long tet_class_array_size = param.initial_tet_number;

long face_class_array_size = 4*tet_class_array_size;
long face_array_size = face_class_array_size;

long *face_array;
face_array = new long[face_array_size];
long previous_face_array_size = 0;

new_face_array( face_array, face_array_size, previous_face_array_size);

face *face_class_array;
face_class_array = new face[face_class_array_size];

pre_initialize_face(face_class_array, face_array, face_class_array_size);
set_face_class_array(tet_class_array, tet_class_array_size, face_class_array, face_class_array_size, node_class_array);
////////////////////////////////////
//resize_face_class_array(face_class_array, face_class_array_size);
	face *temp_class_array_f1;
	temp_class_array_f1 = new face[face_class_array_size];

	for(long n=0;n<face_class_array_size;n++){
		temp_class_array_f1[n] = face_class_array[n];
	};

	delete [] face_class_array;
	face_class_array = new face[face_class_array_size];

	for(long n=0;n<face_class_array_size;n++){
		face_class_array[n] = temp_class_array_f1[n];
	};

	delete [] temp_class_array_f1;



///////////////////////////////////

cout << "1st Faces found" << endl;

//////////////////////////////////////////////////////////////////////////////
//edges


long edge_class_array_size = 6*tet_class_array_size;
long edge_array_size = edge_class_array_size;

long *edge_array;
edge_array = new long[edge_array_size];
long previous_edge_array_size = 0;

new_edge_array(edge_array, edge_array_size, previous_edge_array_size);

edge *edge_class_array;
edge_class_array = new edge[edge_class_array_size];

pre_initialize_edge( edge_class_array, edge_array, edge_class_array_size);
set_edge_class_array(tet_class_array, tet_class_array_size, edge_class_array, edge_class_array_size, node_class_array, face_class_array);
//////////////////////////////////////////////
//resize_edge_class_array(edge_class_array, edge_class_array_size);
	edge *temp_class_array_e1;
	temp_class_array_e1 = new edge[edge_class_array_size];

	for(long n=0;n<edge_class_array_size;n++){
		temp_class_array_e1[n] = edge_class_array[n];
	};

	delete [] edge_class_array;
	edge_class_array = new edge[edge_class_array_size];

	for(long n=0;n<edge_class_array_size;n++){
		edge_class_array[n] = temp_class_array_e1[n];
	};

	delete [] temp_class_array_e1;


//////////////////////////////////////////////

cout << "1st Edges found" << endl;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//red refine

//some tets that need to be red refined are done so because of their position relative to the signed distance function.
//other tets are red refined because a neighboring tet that needs to be green refined, but doesn't fit into one of the three
//allowable green refined tets.  hence all the edges are marked and that tet is red refined.


	long node_array_size = param.initial_node_number;
	long node_class_array_size = node_array_size;
	long tet_array_size = param.initial_tet_number;
	
	pre_red_refine(node_class_array, edge_class_array, tet_class_array, tet_class_array_size, face_class_array, signed_dist_array, signed_dist_array2, signed_dist_array3, param, 0);

	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);
	pre_green(tet_class_array, tet_class_array_size, edge_class_array, face_class_array);

	mark_green_edge_splits(tet_class_array, tet_class_array_size, edge_class_array);
	long tet_class_array_red1_size = calc_tet_class_array_red_size(tet_class_array, tet_class_array_size);
	long node_class_array_red1_size = calc_new_node_class_array_size (edge_class_array, edge_class_array_size);

	node *node_class_array_red1;
	node_class_array_red1 = new node[node_class_array_red1_size];
	tet *tet_class_array_red1;
	tet_class_array_red1 = new tet[tet_class_array_red1_size];

	long tet_array_red1_size = tet_class_array_red1_size;

	long *tet_array_red1;
	tet_array_red1 = new long[tet_array_red1_size];

	long node_array_red1_size = node_class_array_red1_size;

	long *node_array_red1;
	node_array_red1 = new long[node_array_red1_size];
	float *x_coordinate_array_red1;
	x_coordinate_array_red1 = new float[node_array_red1_size];
	float *y_coordinate_array_red1;
	y_coordinate_array_red1 = new float[node_array_red1_size];
	float *z_coordinate_array_red1;
	z_coordinate_array_red1 = new float[node_array_red1_size];



	new_node_array(node_array_size, node_array_red1, x_coordinate_array_red1, y_coordinate_array_red1, z_coordinate_array_red1, node_class_array, edge_class_array, edge_class_array_size, tet_class_array, tet_class_array_size);
	new_node_class_array(node_class_array_red1, node_class_array_red1_size, node_class_array_size, node_array_red1, x_coordinate_array_red1,y_coordinate_array_red1, z_coordinate_array_red1);
	//assign_split_nodes_to_green_tets(tet_class_array, tet_class_array_size, edge_class_array);
	new_tet_array(tet_array_red1,tet_array_red1_size, tet_array_size);


	red_refine(node_class_array, node_class_array_red1,  node_array_size, edge_class_array, tet_class_array, tet_array_red1, tet_class_array_size, tet_class_array_red1, 1, param);




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//green refinement


long tet_class_array_green1_size = green_tet_size (tet_class_array, tet_class_array_size, tet_class_array_size + tet_class_array_red1_size);

long tet_array_green1_size = tet_class_array_green1_size;

long *tet_array_green1;
tet_array_green1 = new long[tet_array_green1_size];

new_tet_array(tet_array_green1, tet_array_green1_size, tet_array_size + tet_array_red1_size);

tet *tet_class_array_green1;
tet_class_array_green1 = new tet[tet_class_array_green1_size];

green_refine(tet_class_array, tet_class_array_green1, tet_class_array_size, tet_array_green1, edge_class_array, 1, param);

cout << "1st Red/Green Refinement" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//compiling

long node_class_array2_size = node_class_array_size + node_class_array_red1_size;
long node_array2_size = node_class_array2_size;
node *node_class_array2;
node_class_array2 = new node[node_class_array2_size];
compile_node_class_arrays( node_class_array, node_class_array_size, node_class_array_red1, node_class_array_red1_size, node_class_array2);

delete [] node_class_array;
delete [] node_class_array_red1;

long tet_class_array2_size = tet_class_array_size + tet_class_array_red1_size + tet_class_array_green1_size;
long tet_array2_size = tet_class_array2_size;
tet *tet_class_array2;
tet_class_array2 = new tet[tet_class_array2_size];
compile_tet_class_arrays( tet_class_array, tet_class_array_size, tet_class_array_red1, tet_class_array_red1_size, tet_class_array_green1, tet_class_array_green1_size, tet_class_array2);


delete [] tet_class_array;
delete [] tet_class_array_red1;
delete [] tet_class_array_green1;



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//for(long n=0 ; n<tet_class_array2_size; n++){

//		cout << n << " " << tet_class_array2[n].totally_removed  << endl; 

//}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//round 2.  finds faces and edges again

remove_node_belongings(node_class_array2, node_class_array2_size);

//faces

long face_class_array2_size = 4*tet_class_array2_size;
long face_array2_size = face_class_array2_size;

long *face_array2;
face_array2 = new long[face_array2_size];
previous_face_array_size = 0;

new_face_array( face_array2, face_array2_size, previous_face_array_size);

face *face_class_array2;
face_class_array2 = new face[face_class_array2_size];

pre_initialize_face(face_class_array2, face_array2, face_class_array2_size);
insert_previous_faces(face_class_array, face_class_array_size, face_class_array2);
set_face_class_array(tet_class_array2, tet_class_array2_size, face_class_array2, face_class_array2_size, node_class_array2);
/////////////////////////////////////////////
//resize_face_class_array(face_class_array2, face_class_array2_size);
	face *temp_class_array_f2;
	temp_class_array_f2 = new face[face_class_array2_size];

	for(long n=0;n<face_class_array2_size;n++){
		temp_class_array_f2[n] = face_class_array2[n];
	};

	delete [] face_class_array2;
	face_class_array2 = new face[face_class_array2_size];

	for(long n=0;n<face_class_array2_size;n++){
		face_class_array2[n] = temp_class_array_f2[n];
	};

	delete [] temp_class_array_f2;


//////////////////////////////////////////

cout << "2nd Faces found" << endl;

//////////////////////////////////////////////////////////////////////////////
//edges


long edge_class_array2_size = 6*tet_class_array2_size;
long edge_array2_size = edge_class_array2_size;

long *edge_array2;
edge_array2 = new long[edge_array2_size];
previous_edge_array_size = 0;

new_edge_array(edge_array2, edge_array2_size, previous_edge_array_size);

edge *edge_class_array2;
edge_class_array2 = new edge[edge_class_array2_size];

pre_initialize_edge( edge_class_array2, edge_array2, edge_class_array2_size);
insert_previous_edges(edge_class_array, edge_class_array_size, edge_class_array2);
set_edge_class_array(tet_class_array2, tet_class_array2_size, edge_class_array2, edge_class_array2_size, node_class_array2, face_class_array2);
///////////////////////////////////////
//resize_edge_class_array(edge_class_array2, edge_class_array2_size);
	edge *temp_class_array_e2;
	temp_class_array_e2 = new edge[edge_class_array2_size];

	for(long n=0;n<edge_class_array2_size;n++){
		temp_class_array_e2[n] = edge_class_array2[n];
	};

	delete [] edge_class_array2;
	edge_class_array2 = new edge[edge_class_array2_size];

	for(long n=0;n<edge_class_array2_size;n++){
		edge_class_array2[n] = temp_class_array_e2[n];
	};

	delete [] temp_class_array_e2;



/////////////////////////////////////////

delete [] edge_class_array;
delete [] face_class_array;

cout << "2nd Edges found" << endl;








////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//red refine

//some tets that need to be red refined are done so because of their position relative to the signed distance function.
//other tets are red refined because a neighboring tet that needs to be green refined, but doesn't fit into one of the three
//allowable green refined tets.  hence all the edges are marked and that tet is red refined.


	
	pre_red_refine(node_class_array2, edge_class_array2, tet_class_array2, tet_class_array2_size, face_class_array2, signed_dist_array, signed_dist_array2, signed_dist_array3, param, 1);

	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);
	pre_green(tet_class_array2, tet_class_array2_size, edge_class_array2, face_class_array2);

	mark_green_edge_splits(tet_class_array2, tet_class_array2_size, edge_class_array2);
	long tet_class_array_red2_size = calc_tet_class_array_red_size(tet_class_array2, tet_class_array2_size);
	long node_class_array_red2_size = calc_new_node_class_array_size (edge_class_array2, edge_class_array2_size);


	node *node_class_array_red2;
	node_class_array_red2 = new node[node_class_array_red2_size];
	tet *tet_class_array_red2;
	tet_class_array_red2 = new tet[tet_class_array_red2_size];



	long tet_array_red2_size = tet_class_array_red2_size;

	long *tet_array_red2;
	tet_array_red2 = new long[tet_array_red2_size];

	long node_array_red2_size = node_class_array_red2_size;

	long *node_array_red2;
	node_array_red2 = new long[node_array_red2_size];
	float *x_coordinate_array_red2;
	x_coordinate_array_red2 = new float[node_array_red2_size];
	float *y_coordinate_array_red2;
	y_coordinate_array_red2 = new float[node_array_red2_size];
	float *z_coordinate_array_red2;
	z_coordinate_array_red2 = new float[node_array_red2_size];
	

	new_node_array(node_array2_size, node_array_red2, x_coordinate_array_red2, y_coordinate_array_red2, z_coordinate_array_red2, node_class_array2, edge_class_array2, edge_class_array2_size, tet_class_array, tet_class_array_size);
	new_node_class_array(node_class_array_red2, node_class_array_red2_size, node_class_array2_size, node_array_red2, x_coordinate_array_red2,y_coordinate_array_red2, z_coordinate_array_red2);
	//assign_split_nodes_to_green_tets(tet_class_array2, tet_class_array2_size, edge_class_array2);
	new_tet_array(tet_array_red2,tet_array_red2_size, tet_array2_size);


	red_refine(node_class_array2, node_class_array_red2,  node_array2_size, edge_class_array2, tet_class_array2, tet_array_red2, tet_class_array2_size, tet_class_array_red2, 2, param);






///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//green refinement


long tet_class_array_green2_size = green_tet_size (tet_class_array2, tet_class_array2_size, tet_class_array2_size + tet_class_array_red2_size);

long tet_array_green2_size = tet_class_array_green2_size;

long *tet_array_green2;
tet_array_green2 = new long[tet_array_green2_size];

new_tet_array(tet_array_green2, tet_array_green2_size, tet_array2_size + tet_array_red2_size);

tet *tet_class_array_green2;
tet_class_array_green2 = new tet[tet_class_array_green2_size];

green_refine(tet_class_array2, tet_class_array_green2, tet_class_array2_size, tet_array_green2, edge_class_array2, 2, param);


cout << "2nd Red/Green Refinement" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//compiling

long node_class_array3_size = node_class_array2_size + node_class_array_red2_size;
long node_array3_size = node_class_array3_size;
node *node_class_array3;
node_class_array3 = new node[node_class_array3_size];
compile_node_class_arrays( node_class_array2, node_class_array2_size, node_class_array_red2, node_class_array_red2_size, node_class_array3);

delete [] node_class_array2;
delete [] node_class_array_red2;

long tet_class_array3_size = tet_class_array2_size + tet_class_array_red2_size + tet_class_array_green2_size;
long tet_array3_size = tet_class_array3_size;
tet *tet_class_array3;
tet_class_array3 = new tet[tet_class_array3_size];
compile_tet_class_arrays( tet_class_array2, tet_class_array2_size, tet_class_array_red2, tet_class_array_red2_size, tet_class_array_green2, tet_class_array_green2_size, tet_class_array3);





delete [] tet_class_array2;
delete [] tet_class_array_red2;
delete [] tet_class_array_green2;



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//round 3.  finds faces and edges again

remove_node_belongings(node_class_array3, node_class_array3_size);

//faces


long face_class_array3_size = 4*tet_class_array3_size;
long face_array3_size = face_class_array3_size;

long *face_array3;
face_array3 = new long[face_array3_size];
previous_face_array_size = 0;

new_face_array( face_array3, face_array3_size, previous_face_array_size);

face *face_class_array3;
face_class_array3 = new face[face_class_array3_size];

pre_initialize_face(face_class_array3, face_array3, face_class_array3_size);
insert_previous_faces(face_class_array2, face_class_array2_size, face_class_array3);
set_face_class_array(tet_class_array3, tet_class_array3_size, face_class_array3, face_class_array3_size, node_class_array3);
///////////////////////////////////////////
//resize_face_class_array(face_class_array3, face_class_array3_size);
	face *temp_class_array_f3;
	temp_class_array_f3 = new face[face_class_array3_size];

	for(long n=0;n<face_class_array3_size;n++){
		temp_class_array_f3[n] = face_class_array3[n];
	};

	delete [] face_class_array3;
	face_class_array3 = new face[face_class_array3_size];

	for(long n=0;n<face_class_array3_size;n++){
		face_class_array3[n] = temp_class_array_f3[n];
	};

	delete [] temp_class_array_f3;



//////////////////////////////////////////

cout << "3rd Faces found" << endl;

//////////////////////////////////////////////////////////////////////////////
//edges


long edge_class_array3_size = 6*tet_class_array3_size;
long edge_array3_size = edge_class_array3_size;

long *edge_array3;
edge_array3 = new long[edge_array3_size];
previous_edge_array_size = 0;

new_edge_array(edge_array3, edge_array3_size, previous_edge_array_size);

edge *edge_class_array3;
edge_class_array3 = new edge[edge_class_array3_size];

pre_initialize_edge( edge_class_array3, edge_array3, edge_class_array3_size);
insert_previous_edges(edge_class_array2, edge_class_array2_size, edge_class_array3);
set_edge_class_array(tet_class_array3, tet_class_array3_size, edge_class_array3, edge_class_array3_size, node_class_array3, face_class_array3);
//////////////////////////////////////
//resize_edge_class_array(edge_class_array3, edge_class_array3_size);
	edge *temp_class_array_e3;
	temp_class_array_e3 = new edge[edge_class_array3_size];

	for(long n=0;n<edge_class_array3_size;n++){
		temp_class_array_e3[n] = edge_class_array3[n];
	};

	delete [] edge_class_array3;
	edge_class_array3 = new edge[edge_class_array3_size];

	for(long n=0;n<edge_class_array3_size;n++){
		edge_class_array3[n] = temp_class_array_e3[n];
	};

	delete [] temp_class_array_e3;



///////////////////////////////////


delete [] edge_class_array2;
delete [] face_class_array2;

cout << "3rd Edges Found" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//red refine

//some tets that need to be red refined are done so because of their position relative to the signed distance function.
//other tets are red refined because a neighboring tet that needs to be green refined, but doesn't fit into one of the three
//allowable green refined tets.  hence all the edges are marked and that tet is red refined.


	
	pre_red_refine(node_class_array3, edge_class_array3, tet_class_array3, tet_class_array3_size, face_class_array3, signed_dist_array, signed_dist_array2, signed_dist_array3, param, 2);

	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);
	pre_green(tet_class_array3, tet_class_array3_size, edge_class_array3, face_class_array3);

	mark_green_edge_splits(tet_class_array3, tet_class_array3_size, edge_class_array3);
	long tet_class_array_red3_size = calc_tet_class_array_red_size(tet_class_array3, tet_class_array3_size);
	long node_class_array_red3_size = calc_new_node_class_array_size (edge_class_array3, edge_class_array3_size);

	node *node_class_array_red3;
	node_class_array_red3 = new node[node_class_array_red3_size];
	tet *tet_class_array_red3;
	tet_class_array_red3 = new tet[tet_class_array_red3_size];

	long tet_array_red3_size = tet_class_array_red3_size;

	long *tet_array_red3;
	tet_array_red3 = new long[tet_array_red3_size];

	long node_array_red3_size = node_class_array_red3_size;

	long *node_array_red3;
	node_array_red3 = new long[node_array_red3_size];
	float *x_coordinate_array_red3;
	x_coordinate_array_red3 = new float[node_array_red3_size];
	float *y_coordinate_array_red3;
	y_coordinate_array_red3 = new float[node_array_red3_size];
	float *z_coordinate_array_red3;
	z_coordinate_array_red3 = new float[node_array_red3_size];

	//output_tbd_nodes(node_array_red3_size, node_array3_size, edge_class_array3, edge_class_array3_size, param, param.output_node_tbd_z3);
	

	new_node_array(node_array3_size, node_array_red3, x_coordinate_array_red3, y_coordinate_array_red3, z_coordinate_array_red3, node_class_array3, edge_class_array3, edge_class_array3_size, tet_class_array, tet_class_array_size);
	new_node_class_array(node_class_array_red3, node_class_array_red3_size, node_class_array3_size, node_array_red3, x_coordinate_array_red3,y_coordinate_array_red3, z_coordinate_array_red3);
	//assign_split_nodes_to_green_tets(tet_class_array3, tet_class_array3_size, edge_class_array3);
	new_tet_array(tet_array_red3,tet_array_red3_size, tet_array3_size);


	red_refine(node_class_array3, node_class_array_red3,  node_array3_size, edge_class_array3, tet_class_array3, tet_array_red3, tet_class_array3_size, tet_class_array_red3, 3, param);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//green refinement


long tet_class_array_green3_size = green_tet_size (tet_class_array3, tet_class_array3_size, tet_class_array3_size + tet_class_array_red3_size);

long tet_array_green3_size = tet_class_array_green3_size;

long *tet_array_green3;
tet_array_green3 = new long[tet_array_green3_size];

new_tet_array(tet_array_green3, tet_array_green3_size, tet_array3_size + tet_array_red3_size);

tet *tet_class_array_green3;
tet_class_array_green3 = new tet[tet_class_array_green3_size];

green_refine(tet_class_array3, tet_class_array_green3, tet_class_array3_size, tet_array_green3, edge_class_array3, 3, param);



cout << "3rd Red/Green Refinement" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//compiling

long node_class_array4_size = node_class_array3_size + node_class_array_red3_size;
long node_array4_size = node_class_array4_size;
node *node_class_array4;
node_class_array4 = new node[node_class_array4_size];
compile_node_class_arrays( node_class_array3, node_class_array3_size, node_class_array_red3, node_class_array_red3_size, node_class_array4);

delete [] node_class_array3;
delete [] node_class_array_red3;

long tet_class_array4_size = tet_class_array3_size + tet_class_array_red3_size + tet_class_array_green3_size;
long tet_array4_size = tet_class_array4_size;
tet *tet_class_array4;
tet_class_array4 = new tet[tet_class_array4_size];
compile_tet_class_arrays( tet_class_array3, tet_class_array3_size, tet_class_array_red3, tet_class_array_red3_size, tet_class_array_green3, tet_class_array_green3_size, tet_class_array4);



//delete [] edge_class_array3;
//delete [] face_class_array3;

/////////////////////////////////
//load the regions function
	
	short *regions_array3;
	regions_array3 = new short[param.size3D_z3];
	//load_regions_function(param.region_file_z3, regions_array3, param, 3);


	cout << "Regions Function Loaded" << endl;

/////////////////////////////

//////////////////////////////

	tet *tet_class_array_red_for_hex3; tet_class_array_red_for_hex3 = new tet[tet_class_array_red3_size];
	for(long n=0;n<tet_class_array_red3_size; n++){
		tet_class_array_red_for_hex3[n] = tet_class_array_red3[n];
	}



	//get_regions(tet_class_array3, tet_class_array3_size, tet_class_array_red_for_hex3, tet_class_array_red3_size, tet_class_array_green3, tet_class_array_green3_size, node_class_array4, regions_array3, param, 3);
	
		//output(tet_class_array3, tet_class_array3_size, tet_class_array_red_for_hex3, tet_class_array_red3_size, tet_class_array_green3, tet_class_array_green3_size, node_class_array4, node_class_array4_size, param, param.output_node_file_z3, param.output_ele_file_z3);
	//exit(1);
	//for(long n=0;n<node_class_array4_size;n++){
	//	for(short m=0;m<8;m++){
	//		node_class_array4[n].diag_bdry_share[m] = -1;
	//	}
	//}

	//hexagonize(tet_class_array_red_for_hex3, tet_class_array_red3_size, node_class_array4, node_class_array4_size, regions_array3, param, 3);
	//output(tet_class_array3, tet_class_array3_size, tet_class_array_red_for_hex3, tet_class_array_red3_size, tet_class_array_green3, tet_class_array_green3_size, node_class_array4, node_class_array4_size, param, param.output_node_file_z3, param.output_ele_file_z3);

	delete [] tet_class_array_red_for_hex3;
	delete [] regions_array3;

/////////////////////////////////////

delete [] tet_class_array3;
delete [] tet_class_array_red3;
delete [] tet_class_array_green3;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//round 4


remove_node_belongings(node_class_array4, node_class_array4_size);

//faces


long face_class_array4_size = 4*tet_class_array4_size;
long face_array4_size = face_class_array4_size;

long *face_array4;
face_array4 = new long[face_array4_size];
previous_face_array_size = 0;

new_face_array( face_array4, face_array4_size, previous_face_array_size);

face *face_class_array4;
face_class_array4 = new face[face_class_array4_size];

pre_initialize_face(face_class_array4, face_array4, face_class_array4_size);
insert_previous_faces(face_class_array3, face_class_array3_size, face_class_array4);
set_face_class_array(tet_class_array4, tet_class_array4_size, face_class_array4, face_class_array4_size, node_class_array4);
///////////////////////////////////////////
//resize_face_class_array(face_class_array4, face_class_array4_size);
	face *temp_class_array_f4;
	temp_class_array_f4 = new face[face_class_array4_size];

	for(long n=0;n<face_class_array4_size;n++){
		temp_class_array_f4[n] = face_class_array4[n];
	};

	delete [] face_class_array4;
	face_class_array4 = new face[face_class_array4_size];

	for(long n=0;n<face_class_array4_size;n++){
		face_class_array4[n] = temp_class_array_f4[n];
	};

	delete [] temp_class_array_f4;



//////////////////////////////////////////


cout << "4rd Faces found" << endl;

//////////////////////////////////////////////////////////////////////////////
//edges


long edge_class_array4_size = 6*tet_class_array4_size;
long edge_array4_size = edge_class_array4_size;

long *edge_array4;
edge_array4 = new long[edge_array4_size];
previous_edge_array_size = 0;

new_edge_array(edge_array4, edge_array4_size, previous_edge_array_size);

edge *edge_class_array4;
edge_class_array4 = new edge[edge_class_array4_size];

pre_initialize_edge( edge_class_array4, edge_array4, edge_class_array4_size);
insert_previous_edges(edge_class_array3, edge_class_array3_size, edge_class_array4);
set_edge_class_array(tet_class_array4, tet_class_array4_size, edge_class_array4, edge_class_array4_size, node_class_array4, face_class_array4);
//////////////////////////////////////////
//resize_edge_class_array(edge_class_array4, edge_class_array4_size);
	edge *temp_class_array_e4;
	temp_class_array_e4 = new edge[edge_class_array4_size];

	for(long n=0;n<edge_class_array4_size;n++){
		temp_class_array_e4[n] = edge_class_array4[n];
	};

	delete [] edge_class_array4;
	edge_class_array4 = new edge[edge_class_array4_size];

	for(long n=0;n<edge_class_array4_size;n++){
		edge_class_array4[n] = temp_class_array_e4[n];
	};

	delete [] temp_class_array_e4;



////////////////////////////////////

delete [] edge_class_array3;
delete [] face_class_array3;

cout << "4rd Edges Found" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//red refine

//some tets that need to be red refined are done so because of their position relative to the signed distance function.
//other tets are red refined because a neighboring tet that needs to be green refined, but doesn't fit into one of the three
//allowable green refined tets.  hence all the edges are marked and that tet is red refined.


	
	pre_red_refine(node_class_array4, edge_class_array4, tet_class_array4, tet_class_array4_size, face_class_array4, signed_dist_array, signed_dist_array2, signed_dist_array3, param, 3);


	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);
	pre_green(tet_class_array4, tet_class_array4_size, edge_class_array4, face_class_array4);

	mark_green_edge_splits(tet_class_array4, tet_class_array4_size, edge_class_array4);
	long tet_class_array_red4_size = calc_tet_class_array_red_size(tet_class_array4, tet_class_array4_size);
	long node_class_array_red4_size = calc_new_node_class_array_size (edge_class_array4, edge_class_array4_size);

	node *node_class_array_red4;
	node_class_array_red4 = new node[node_class_array_red4_size];
	tet *tet_class_array_red4;
	tet_class_array_red4 = new tet[tet_class_array_red4_size];

	long tet_array_red4_size = tet_class_array_red4_size;

	long *tet_array_red4;
	tet_array_red4 = new long[tet_array_red4_size];

	long node_array_red4_size = node_class_array_red4_size;

	long *node_array_red4;
	node_array_red4 = new long[node_array_red4_size];
	float *x_coordinate_array_red4;
	x_coordinate_array_red4 = new float[node_array_red4_size];
	float *y_coordinate_array_red4;
	y_coordinate_array_red4 = new float[node_array_red4_size];
	float *z_coordinate_array_red4;
	z_coordinate_array_red4 = new float[node_array_red4_size];

	//multi-res
	//output_tbd_nodes(node_array_red4_size, node_array4_size, edge_class_array4, edge_class_array4_size, param, param.output_node_tbd_z2);
	

	new_node_array(node_array4_size, node_array_red4, x_coordinate_array_red4, y_coordinate_array_red4, z_coordinate_array_red4, node_class_array4, edge_class_array4, edge_class_array4_size, tet_class_array, tet_class_array_size);
	new_node_class_array(node_class_array_red4, node_class_array_red4_size, node_class_array4_size, node_array_red4, x_coordinate_array_red4,y_coordinate_array_red4, z_coordinate_array_red4);
	//assign_split_nodes_to_green_tets(tet_class_array4, tet_class_array4_size, edge_class_array4);
	new_tet_array(tet_array_red4,tet_array_red4_size, tet_array4_size);


	red_refine(node_class_array4, node_class_array_red4,  node_array4_size, edge_class_array4, tet_class_array4, tet_array_red4, tet_class_array4_size, tet_class_array_red4, 4, param);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//green refinement


long tet_class_array_green4_size = green_tet_size (tet_class_array4, tet_class_array4_size, tet_class_array4_size + tet_class_array_red4_size);

long tet_array_green4_size = tet_class_array_green4_size;

long *tet_array_green4;
tet_array_green4 = new long[tet_array_green4_size];

new_tet_array(tet_array_green4, tet_array_green4_size, tet_array4_size + tet_array_red4_size);

tet *tet_class_array_green4;
tet_class_array_green4 = new tet[tet_class_array_green4_size];

green_refine(tet_class_array4, tet_class_array_green4, tet_class_array4_size, tet_array_green4, edge_class_array4, 4, param);



cout << "4rd Red/Green Refinement" << endl;






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//compiling

long node_class_array5_size = node_class_array4_size + node_class_array_red4_size;
long node_array5_size = node_class_array5_size;
node *node_class_array5;
node_class_array5 = new node[node_class_array5_size];
compile_node_class_arrays( node_class_array4, node_class_array4_size, node_class_array_red4, node_class_array_red4_size, node_class_array5);

delete [] node_class_array4;
delete [] node_class_array_red4;



long tet_class_array5_size = tet_class_array4_size + tet_class_array_red4_size + tet_class_array_green4_size;
long tet_array5_size = tet_class_array5_size;
tet *tet_class_array5;
tet_class_array5 = new tet[tet_class_array5_size];
compile_tet_class_arrays( tet_class_array4, tet_class_array4_size, tet_class_array_red4, tet_class_array_red4_size, tet_class_array_green4, tet_class_array_green4_size, tet_class_array5);



/////////////////////////////////
//load the regions function
	
	short *regions_array2;
	regions_array2 = new short[param.size3D_z2];
	//load_regions_function(param.region_file_z2, regions_array2, param, 2);


	cout << "Regions Function Loaded" << endl;

/////////////////////////////

//////////////////////////////

	tet *tet_class_array_red_for_hex2; tet_class_array_red_for_hex2 = new tet[tet_class_array_red4_size];
	for(long n=0;n<tet_class_array_red4_size; n++){
		tet_class_array_red_for_hex2[n] = tet_class_array_red4[n];
	}

	//get_regions(tet_class_array4, tet_class_array4_size, tet_class_array_red_for_hex2, tet_class_array_red4_size, tet_class_array_green4, tet_class_array_green4_size, node_class_array5, regions_array2, param, 2);
	//hexagonize(tet_class_array_red_for_hex2, tet_class_array_red4_size, node_class_array5, node_class_array5_size, regions_array2, param, 2);
	//output(tet_class_array4, tet_class_array4_size, tet_class_array_red_for_hex2, tet_class_array_red4_size, tet_class_array_green4, tet_class_array_green4_size, node_class_array5, node_class_array5_size, param, param.output_node_file_z2, param.output_ele_file_z2);

	delete [] tet_class_array_red_for_hex2;
	delete [] regions_array2;


/////////////////////////////////////

delete [] tet_class_array4;
delete [] tet_class_array_red4;
delete [] tet_class_array_green4;


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//round 5


param.ls_list = new float[node_class_array5_size];

make_ls_list(node_class_array5, signed_dist_array, signed_dist_array2, signed_dist_array3, node_class_array5_size, param);

param.use_list = true;
cout << "ls_list made" << endl;


delete [] signed_dist_array;
delete [] signed_dist_array2;
delete [] signed_dist_array3;

////////////////////////////////////////////////////


remove_node_belongings(node_class_array5, node_class_array5_size);

//faces


long face_class_array5_size = 4*tet_class_array5_size;
long face_array5_size = face_class_array5_size;

long *face_array5;
face_array5 = new long[face_array5_size];
previous_face_array_size = 0;

new_face_array( face_array5, face_array5_size, previous_face_array_size);

face *face_class_array5;
face_class_array5 = new face[face_class_array5_size];

pre_initialize_face(face_class_array5, face_array5, face_class_array5_size);
insert_previous_faces(face_class_array4, face_class_array4_size, face_class_array5);
set_face_class_array(tet_class_array5, tet_class_array5_size, face_class_array5, face_class_array5_size, node_class_array5);

delete [] face_class_array4;
/////////////////////////////////////
//resize_face_class_array(face_class_array5, face_class_array5_size);
	face *temp_class_array_f5;
	temp_class_array_f5 = new face[face_class_array5_size];

	for(long n=0;n<face_class_array5_size;n++){
		temp_class_array_f5[n] = face_class_array5[n];
	};

	delete [] face_class_array5;
	face_class_array5 = new face[face_class_array5_size];

	for(long n=0;n<face_class_array5_size;n++){
		face_class_array5[n] = temp_class_array_f5[n];
	};

	delete [] temp_class_array_f5;



///////////////////////////////////

cout << "5rd Faces found" << endl;

//////////////////////////////////////////////////////////////////////////////
//edges


long edge_class_array5_size = 6*tet_class_array5_size;
long edge_array5_size = edge_class_array5_size;

long *edge_array5;
edge_array5 = new long[edge_array5_size];
previous_edge_array_size = 0;

new_edge_array(edge_array5, edge_array5_size, previous_edge_array_size);

edge *edge_class_array5;
edge_class_array5 = new edge[edge_class_array5_size];

pre_initialize_edge( edge_class_array5, edge_array5, edge_class_array5_size);
insert_previous_edges(edge_class_array4, edge_class_array4_size, edge_class_array5);
set_edge_class_array(tet_class_array5, tet_class_array5_size, edge_class_array5, edge_class_array5_size, node_class_array5, face_class_array5);

delete [] edge_class_array4;
////////////////////////////////
//resize_edge_class_array(edge_class_array5, edge_class_array5_size);
	edge *temp_class_array_e5;
	temp_class_array_e5 = new edge[edge_class_array5_size];

	for(long n=0;n<edge_class_array5_size;n++){
		temp_class_array_e5[n] = edge_class_array5[n];
	};

	delete [] edge_class_array5;
	edge_class_array5 = new edge[edge_class_array5_size];

	for(long n=0;n<edge_class_array5_size;n++){
		edge_class_array5[n] = temp_class_array_e5[n];
	};

	delete [] temp_class_array_e5;



///////////////////////////////



cout << "5rd Edges Found" << endl;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//red refine

//some tets that need to be red refined are done so because of their position relative to the signed distance function.
//other tets are red refined because a neighboring tet that needs to be green refined, but doesn't fit into one of the three
//allowable green refined tets.  hence all the edges are marked and that tet is red refined.

	
	
	pre_red_refine(node_class_array5, edge_class_array5, tet_class_array5, tet_class_array5_size, face_class_array5, signed_dist_array, signed_dist_array2, signed_dist_array3, param, 4);

	
	delete [] param.ls_list;


	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);
	pre_green(tet_class_array5, tet_class_array5_size, edge_class_array5, face_class_array5);

	delete [] face_class_array5;
	delete [] face_array;
	delete [] face_array2;
	delete [] face_array3;
	delete [] face_array4;
	delete [] face_array5;

	mark_green_edge_splits(tet_class_array5, tet_class_array5_size, edge_class_array5);
	long tet_class_array_red5_size = calc_tet_class_array_red_size(tet_class_array5, tet_class_array5_size);
	long node_class_array_red5_size = calc_new_node_class_array_size (edge_class_array5, edge_class_array5_size);

	cout <<"tet number is " << tet_class_array5_size + tet_class_array_red5_size << endl;

	node *node_class_array_red5;
	node_class_array_red5 = new node[node_class_array_red5_size];

	
	cout << "use lite tets set to true" << endl;
	param.use_lite = true;
	param.tet_class_array_red5 = new tet_lite[tet_class_array_red5_size];

	tet *tet_class_array_red5;
	tet_class_array_red5 = new tet[1];

	long tet_array_red5_size = tet_class_array_red5_size;

	long *tet_array_red5;
	tet_array_red5 = new long[tet_array_red5_size];

	long node_array_red5_size = node_class_array_red5_size;

	long *node_array_red5;
	node_array_red5 = new long[node_array_red5_size];
	float *x_coordinate_array_red5;
	x_coordinate_array_red5 = new float[node_array_red5_size];
	float *y_coordinate_array_red5;
	y_coordinate_array_red5 = new float[node_array_red5_size];
	float *z_coordinate_array_red5;
	z_coordinate_array_red5 = new float[node_array_red5_size];

	//multi-res
	//output_tbd_nodes(node_array_red5_size, node_array5_size, edge_class_array5, edge_class_array5_size, param, param.output_node_tbd_z1);
	

	new_node_array(node_array5_size, node_array_red5, x_coordinate_array_red5, y_coordinate_array_red5, z_coordinate_array_red5, node_class_array5, edge_class_array5, edge_class_array5_size, tet_class_array, tet_class_array_size);
	new_node_class_array(node_class_array_red5, node_class_array_red5_size, node_class_array5_size, node_array_red5, x_coordinate_array_red5,y_coordinate_array_red5, z_coordinate_array_red5);
	//assign_split_nodes_to_green_tets(tet_class_array5, tet_class_array5_size, edge_class_array5);
	new_tet_array(tet_array_red5,tet_array_red5_size, tet_array5_size);


	red_refine(node_class_array5, node_class_array_red5,  node_array5_size, edge_class_array5, tet_class_array5, tet_array_red5, tet_class_array5_size, tet_class_array_red5, 5, param);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//green refinement


long tet_class_array_green5_size = green_tet_size (tet_class_array5, tet_class_array5_size, tet_class_array5_size + tet_class_array_red5_size);

long tet_array_green5_size = tet_class_array_green5_size;

long *tet_array_green5;
tet_array_green5 = new long[tet_array_green5_size];

new_tet_array(tet_array_green5, tet_array_green5_size, tet_array5_size + tet_array_red5_size);


param.tet_class_array_green5 = new tet_lite[tet_class_array_green5_size];

tet *tet_class_array_green5;
tet_class_array_green5 = new tet[1];

green_refine(tet_class_array5, tet_class_array_green5, tet_class_array5_size, tet_array_green5, edge_class_array5, 5, param);



cout << "5rd Red/Green Refinement" << endl;


//freeing up memory
delete [] edge_class_array5;
delete [] edge_array;
delete [] edge_array2;
delete [] edge_array3;
delete [] edge_array4;
delete [] edge_array5;






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//compiling

long node_class_array6_size = node_class_array5_size + node_class_array_red5_size;
long node_array6_size = node_class_array6_size;
node *node_class_array6;
node_class_array6 = new node[node_class_array6_size];
compile_node_class_arrays( node_class_array5, node_class_array5_size, node_class_array_red5, node_class_array_red5_size, node_class_array6);

delete [] node_class_array5;
delete [] node_class_array_red5;











/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//the face and edge arrays are no longer necessary






//the signed distance array is no longer necessary








/////////////////////////////////
//load the regions function
	
	short *regions_array;
	regions_array = new  short[param.size3D];
	load_regions_function(param.filename_region, regions_array, param, 1);


	cout << "Regions Function Loaded" << endl;

/////////////////////////////
	//pre_process_regions(regions_array, param);

	//cout << "regions pre-processed" << endl;

	
//////////////////////////////



	get_regions(tet_class_array5, tet_class_array5_size, tet_class_array_red5, tet_class_array_red5_size, tet_class_array_green5, tet_class_array_green5_size, node_class_array6, regions_array, param, 1);
	hexagonize(tet_class_array_red5, tet_class_array_red5_size, node_class_array6, node_class_array6_size, regions_array, param, 1);
	output(tet_class_array5, tet_class_array5_size, tet_class_array_red5, tet_class_array_red5_size, tet_class_array_green5, tet_class_array_green5_size, node_class_array6, node_class_array6_size, param, param.output_node, param.output_ele);



/////////////////////////////////////
/*
;
delete [] tet_array_red2;
delete [] tet_array_red3;
delete [] tet_array_red4;
delete [] tet_array_red5;


delete [] tet_array_green2;
delete [] tet_array_green3;
delete [] tet_array_green4;
delete [] tet_array_green5;


delete [] node_array2;
delete [] node_array3;
delete [] node_array4;
delete [] node_array5;
*/


}











