#include "stdafx.h"
#include <iostream>
#include <fstream>
#include "sparse_matrix.h"

//the 3 by 3 matrices are stored as length 9 array
// [0] (0,0)
// [1] (1,0)
// [2] 2,0
// [3] 0,1
// [4] 1,1
// [5] 2,1
// [6] 0,2
// [7] 1,2
// [8] 2,2

//the 2by2 matrices are storae

//[0] 0,0
//[1] 1,0
//[2] 0,1
//[3] 1,1

void set_zero(long size, float input[]);
void add(long size, float A[], float B[], float M[]);
void m_const(long size, float input[], float constant, float M[]);
float det3(float input[], parameters &param);
void inv3(float input[], float M[], parameters &param);
void transpose3(float input[], float M[]);
void eye3(float M[]);
float trace3(float input[]);
void m(float A[], float B[], float M[]);

void cross_product(float a[], float b[], float vec_out[]);
float vec_length(float vec[]);

void out3(float input[]);

float dot3(float v1[3], float v2[3]);

void psd_inv3(float input[], float M[], parameters &param);
void psd_inv3_2(float input[], float M[], parameters &param);

void get_normal(face face_class[], long &nn, parameters &param);




void get_nodes_current_voxel_region(node_info node_class[], short regions_array[],  parameters &param);
void get_M( node_info node_class[], float current_tet_volumes[], long t, parameters &param);

void conj_grad(float vec_x[], float vec_b[], sparse_matrix &A, float &stop_cri, parameters &param);
void sparse_matrix_m_vec(sparse_matrix &A, float vec_in[], float vec_out[]);

void matrix_m_vec(float matrix[], float vec[], float out[]);

void get_tet_volumes(  float current_tet_volumes[], parameters &param){

	long p1,p2,p3,p4;
	float x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4;
	float asv;
	float v_calc_matrix[9];

	for(long ii=0;ii<param.tets_number;ii++){

	p1=param.t_1[ii];
	p2=param.t_2[ii];
	p3=param.t_3[ii];
	p4=param.t_4[ii];

	x1 = param.n_x[p1];
	x2 = param.n_x[p2];
	x3 = param.n_x[p3];
	x4 = param.n_x[p4];
	y1 = param.n_y[p1];
	y2 = param.n_y[p2];
	y3 = param.n_y[p3];
	y4 = param.n_y[p4];
	z1 = param.n_z[p1];
	z2 = param.n_z[p2];
	z3 = param.n_z[p3];
	z4 = param.n_z[p4];

	v_calc_matrix[0]=x1-x2;
	v_calc_matrix[3]=x2-x3;
	v_calc_matrix[6]=x3-x4;
	v_calc_matrix[1]=y1-y2;
	v_calc_matrix[4]=y2-y3;
	v_calc_matrix[7]=y3-y4;
	v_calc_matrix[2]=z1-z2;
	v_calc_matrix[5]=z2-z3;
	v_calc_matrix[8]=z3-z4;
		
	asv = (1.0/6.0)*det3(v_calc_matrix, param);
	if(asv > 0){
		current_tet_volumes[ii] =  asv;
	}else{
		current_tet_volumes[ii] =  -1.0*asv;
	}



	}

}



bool comp(float v1, float v2){
	bool comp_val;
	if(v1 < v2){
		comp_val = true;
	}else{
		comp_val = false;
	}
	return comp_val;
}


		



void pre_compute(  float tet_volumes[], parameters &param){

	float asv;
	float dX[9];
	float inv3_dX[9];
	float v_calc_matrix[9];

	float n1[3],n2[3],n3[3],n4[3];
	float n1_length,n2_length,n3_length,n4_length;
	float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
	float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
	float alt1[3], alt2[3], alt3[3], alt4[3];
	float alt_length1, alt_length2, alt_length3, alt_length4;
	float v[3];

	for(long ii=0;ii<param.tets_number; ii++){

		float X1,X2,X3,X4,Y1,Y2,Y3,Y4,Z1,Z2,Z3,Z4;
		long p1,p2,p3,p4;

			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];

			//r=param.t_r[ii];


			X1 = param.n_x[p1];
			X2 = param.n_x[p2];
			X3 = param.n_x[p3];
			X4 = param.n_x[p4];
			Y1 = param.n_y[p1];
			Y2 = param.n_y[p2];
			Y3 = param.n_y[p3];
			Y4 = param.n_y[p4];
			Z1 = param.n_z[p1];
			Z2 = param.n_z[p2];
			Z3 = param.n_z[p3];
			Z4 = param.n_z[p4];

		/*
		X1 = nodes_(param.t_1[ii], 0);
		X2 = nodes_(param.t_2[ii], 0);
		X3 = nodes_(param.t_3[ii], 0);
		X4 = nodes_(param.t_4[ii], 0);
		Y1 = nodes_(param.t_1[ii], 1);
		Y2 = nodes_(param.t_2[ii], 1);
		Y3 = nodes_(param.t_3[ii], 1);
		Y4 = nodes_(param.t_4[ii], 1);
		Z1 = nodes_(param.t_1[ii], 2);
		Z2 = nodes_(param.t_2[ii], 2);
		Z3 = nodes_(param.t_3[ii], 2);
		Z4 = nodes_(param.t_4[ii], 2);
		*/


		dX[0] = X2-X1;
		dX_(0,1) = X3-X1;
		dX_(0,2) = X4-X1;
		dX_(1,0) = Y2-Y1;
		dX_(1,1) = Y3-Y1;
		dX_(1,2) = Y4-Y1;
		dX_(2,0) = Z2-Z1;
		dX_(2,1) = Z3-Z1;
		dX_(2,2) = Z4-Z1;

		/*
		param.dX_array[9*ii+0]=dX[0];
		param.dX_array[9*ii+1]=dX_(0,1);
		param.dX_array[9*ii+2]=dX_(0,2);
		param.dX_array[9*ii+3]=dX_(1,0);
		param.dX_array[9*ii+4]=dX_(1,1);
		param.dX_array[9*ii+5]=dX_(1,2);
		param.dX_array[9*ii+6]=dX_(2,0);
		param.dX_array[9*ii+7]=dX_(2,1);
		param.dX_array[9*ii+8]=dX_(2,2);
		*/
		

		param.dX_array_0[ii]=dX[0];
		param.dX_array_3[ii]=dX_(0,1);
		param.dX_array_6[ii]=dX_(0,2);
		param.dX_array_1[ii]=dX_(1,0);
		param.dX_array_4[ii]=dX_(1,1);
		param.dX_array_7[ii]=dX_(1,2);
		param.dX_array_2[ii]=dX_(2,0);
		param.dX_array_5[ii]=dX_(2,1);
		param.dX_array_8[ii]=dX_(2,2);
		
		if(param.tets_number < param.tet_mem_lim ){

		inv3(dX, inv3_dX, param);

		/*
		inv3_dX_array[9*ii+0]=inv3_dX[0];
		inv3_dX_array[9*ii+1]=inv3_dX_(0,1);
		inv3_dX_array[9*ii+2]=inv3_dX_(0,2);
		inv3_dX_array[9*ii+3]=inv3_dX_(1,0);
		inv3_dX_array[9*ii+4]=inv3_dX_(1,1);
		inv3_dX_array[9*ii+5]=inv3_dX_(1,2);
		inv3_dX_array[9*ii+6]=inv3_dX_(2,0);
		inv3_dX_array[9*ii+7]=inv3_dX_(2,1);
		inv3_dX_array[9*ii+8]=inv3_dX_(2,2);
		*/


		param.inv3_dX_array_0[ii]=inv3_dX[0];
		param.inv3_dX_array_3[ii]=inv3_dX_(0,1);
		param.inv3_dX_array_6[ii]=inv3_dX_(0,2);
		param.inv3_dX_array_1[ii]=inv3_dX_(1,0);
		param.inv3_dX_array_4[ii]=inv3_dX_(1,1);
		param.inv3_dX_array_7[ii]=inv3_dX_(1,2);
		param.inv3_dX_array_2[ii]=inv3_dX_(2,0);
		param.inv3_dX_array_5[ii]=inv3_dX_(2,1);
		param.inv3_dX_array_8[ii]=inv3_dX_(2,2);

		}

		v_calc_matrix[0]=X1-X2;
		v_calc_matrix_(0,1)=X2-X3;
		v_calc_matrix_(0,2)=X3-X4;
		v_calc_matrix_(1,0)=Y1-Y2;
		v_calc_matrix_(1,1)=Y2-Y3;
		v_calc_matrix_(1,2)=Y3-Y4;
		v_calc_matrix_(2,0)=Z1-Z2;
		v_calc_matrix_(2,1)=Z2-Z3;
		v_calc_matrix_(2,2)=Z3-Z4;
		

		asv = (1.0/6.0)*det3(v_calc_matrix, param);
		if(asv > 0){
			tet_volumes[ii] =  asv;
		}else{
			tet_volumes[ii] =  -1.0*asv;

		}

		//calculating initial altitude lengths

		//if(param.jagged_compression==true){

		/*
			vec1[0]=dX[0];
				vec1[1]=dX_(1,0);
				vec1[2]=dX_(2,0);

				vec2[0]=dX_(0,1);
				vec2[1]=dX_(1,1);
				vec2[2]=dX_(2,1);

				vec3[0]=dX_(0,2);
				vec3[1]=dX_(1,2);
				vec3[2]=dX_(2,2);

				vec4[0]=X3-X2;
				vec4[1]=Y3-Y2;
				vec4[2]=Z3-Z2;

				vec5[0]=X4-X2;
				vec5[1]=Y4-Y2;
				vec5[2]=Z4-Z2;

				//vec6[0]=x4-x3;
				//vec6[1]=y4-y3;
				//vec6[2]=z4-z3;

	
				cross_product(vec2,vec1,n4);
				cross_product(vec1,vec3,n3);
				cross_product(vec3,vec2,n2);
				cross_product(vec4,vec5,n1);

				n1_length=vec_length(n1);
				n2_length=vec_length(n2);
				n3_length=vec_length(n3);
				n4_length=vec_length(n4);

				for(short bb=0;bb<3;bb++){

					n1[bb]=n1[bb]/n1_length;
					n2[bb]=n2[bb]/n2_length;
					n3[bb]=n3[bb]/n3_length;
					n4[bb]=n4[bb]/n4_length;

				}

				//cout << n1[0] << " " << n1[1] << " " << n1[2] << endl;
				//cout << n2[0] << " " << n2[1] << " " << n2[2] << endl;
				//cout << n3[0] << " " << n3[1] << " " << n3[2] << endl;
				//cout << n4[0] << " " << n4[1] << " " << n4[2] << endl;

				//cout << vec_length(n1) << endl;
				//cout << vec_length(n2) << endl;
				//cout << vec_length(n3) << endl;
				//cout << vec_length(n4) << endl;


				for(short bb=0;bb<3;bb++){
					v[bb]=-vec1[bb];
				}

				alt_p1[0]=n1[0]*n1[0]*v[0] + n1[0]*n1[1]*v[1] + n1[0]*n1[2]*v[2];
				alt_p1[1]=n1[0]*n1[1]*v[0] + n1[1]*n1[1]*v[1] + n1[1]*n1[2]*v[2];
				alt_p1[2]=n1[0]*n1[2]*v[0] + n1[1]*n1[2]*v[1] + n1[2]*n1[2]*v[2];

				alt_length1 = vec_length(alt_p1);
				
				for(short bb=0;bb<3;bb++){
					v[bb]=vec1[bb];
				}

				alt_p2[0]=n2[0]*n2[0]*v[0] + n2[0]*n2[1]*v[1] + n2[0]*n2[2]*v[2];
				alt_p2[1]=n2[0]*n2[1]*v[0] + n2[1]*n2[1]*v[1] + n2[1]*n2[2]*v[2];
				alt_p2[2]=n2[0]*n2[2]*v[0] + n2[1]*n2[2]*v[1] + n2[2]*n2[2]*v[2];

				alt_length2 = vec_length(alt_p2);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec4[bb];
				}

				alt_p3[0]=n3[0]*n3[0]*v[0] + n3[0]*n3[1]*v[1] + n3[0]*n3[2]*v[2];
				alt_p3[1]=n3[0]*n3[1]*v[0] + n3[1]*n3[1]*v[1] + n3[1]*n3[2]*v[2];
				alt_p3[2]=n3[0]*n3[2]*v[0] + n3[1]*n3[2]*v[1] + n3[2]*n3[2]*v[2];

				alt_length3 = vec_length(alt_p3);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec3[bb];
				}

				alt_p4[0]=n4[0]*n4[0]*v[0] + n4[0]*n4[1]*v[1] + n4[0]*n4[2]*v[2];
				alt_p4[1]=n4[0]*n4[1]*v[0] + n4[1]*n4[1]*v[1] + n4[1]*n4[2]*v[2];
				alt_p4[2]=n4[0]*n4[2]*v[0] + n4[1]*n4[2]*v[1] + n4[2]*n4[2]*v[2];

				alt_length4 = vec_length(alt_p4);

				
				

				

				initial_alt_lengths[4*ii+0]=alt_length1;
				initial_alt_lengths[4*ii+1]=alt_length2;
				initial_alt_lengths[4*ii+2]=alt_length3;
				initial_alt_lengths[4*ii+3]=alt_length4;

				//cout << alt_length1 << endl;
				//cout << alt_length2 << endl;
				//cout << alt_length3 << endl;
				//cout << alt_length4 << endl;

*/


		//}








	}




}




void calculate_elastic_forces(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param){









	//set_zero(3*param.nodes_number, elastic_node_forces);

	for(long n=0;n<param.nodes_number;n++){

		param.enf_x[n]=0;
		param.enf_y[n]=0;
		param.enf_z[n]=0;

	}


	//X is the underformed configuration, x is the deformed config
	//going through all the triangles and finding the cauchy 
	//stress and using that to find the force



		long p1, p2, p3, p4;
		float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
		//float prev_x1, prev_x2, prev_x3, prev_x4, prev_y1, prev_y2, prev_y3, prev_y4, prev_z1, prev_z2, prev_z3, prev_z4;


		//E is young's modulus and p us the poisson ratio

		float p=param.p;
		float E= param.E;
		float d=1.0;

		float lambda = (E*p)/((1.0+p)*(1.0-2.0*p));
		float mu = E/(2.0*(1.0+p));
		float alpha;
		alpha = lambda * d;
		float beta;
		beta = mu* d;

		float I[9];
		

		float dx[9];
		float dX[9];
		float inv3_dX[9];
		float inv3_dx[9];
		float det_dX;
		float det_dx;
		float F[9];
		//float b[9];
		float trans3_F[9];
		float J;
		//float sigma[9];
		float val1;
		float val2;
		float val3;
		float J1, J2, J3;
		float M1[9];
		float M2[9];
		float M3[9];
		float M4[9];
		float M5[9];
		float M6[9];
		float P[9];
		float ftwo_fthree_ffour[9];
		float fone[3];

		//float G[9];
		//float S[9];

		//float A1,A2,A3,A4;
		//float n1[3],n2[3],n3[3],n4[3];
		//float n1_length,n2_length,n3_length,n4_length;
		//float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
		//float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
		//float alt1[3], alt2[3], alt3[3], alt4[3];
		//float alt_length1, alt_length2, alt_length3, alt_length4;
		//float rest_alt1, rest_alt2, rest_alt3, rest_alt4;
		//float f1,f2,f3,f4;
		//float v[3];
		//float k;
		//k = 3.0*alpha*2.0;
		//float boundary_number;
		//float e_fnc;
		//float ls1, ls2, ls3, ls4, ls_avg;
		short r;

		//short comp12,comp13,comp14,comp23,comp24,comp34;
		//short smallest_alt;
		//float min_alt, max_alt, ratio;

		//float d_ang, max_d_ang, min_d_ang;
		//float this_max_d_ang, this_min_d_ang;
		//float largest_edge;
		//float smallest_edge;
		//float edge_ratio;
		//float largest_edge_ratio;
		//float vec1_l,vec2_l,vec3_l,vec4_l,vec5_l,vec6_l;
		//largest_edge_ratio = 1;

		//float alt_rest_change;

		float detC;
		float detC_m1;
		float detF;
		float detF_m1;
		float trace_C;

		float asv;
		float ev1;
		float ev2;
		float power;
		float bd;

		param.inverted_count=0;
		float C[9];
		float C_inv[9];
		float temp_val1;
		float temp_val2;
		float temp_val;

		//min_d_ang = 2*param.pi;
		//max_d_ang = 0;

		//cout << "elastic started" << endl;

		//float *inflation_x;
		//float *inflation_y;
		//float *inflation_z;

		/*
		if(param.jagged_compression == true){


		 inflation_x = new float[param.nodes_number];
		 inflation_y = new float[param.nodes_number];
		 inflation_z = new float[param.nodes_number];

		//cout << "xyz made" << endl;

			for(long n=0;n<param.nodes_number;n++){

				inflation_x[n] = 0.0;
				inflation_y[n] = 0.0;
				inflation_z[n] = 0.0;


			}

		}
		*/

		

		param.G[param.t] = 0;
		//float log_b;

		/*
		for(long n=0;n<param.nodes_number;n++){
			node_class[n].singleton = false;
			//node_class[n].singleton = true;
		}
		*/

		//mu =mu*2.0;

		for(long ii=0;ii<param.tets_number;ii++){   

			//cout << " ii " << endl;

			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];

			//r=param.t_r[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];

			

			dx[0] = x2-x1;
			dx[3] = x3-x1;
			dx[6] = x4-x1;
			dx[1] = y2-y1;
			dx[4] = y3-y1;
			dx[7] = y4-y1;
			dx[2] = z2-z1;
			dx[5] = z3-z1;
			dx[8] = z4-z1;

			dX[0]=param.dX_array_0[ii];
			dX[3]=param.dX_array_3[ii];
			dX[6]=param.dX_array_6[ii];
			dX[1]=param.dX_array_1[ii];
			dX[4]=param.dX_array_4[ii];
			dX[7]=param.dX_array_7[ii];
			dX[2]=param.dX_array_2[ii];
			dX[5]=param.dX_array_5[ii];
			dX[8]=param.dX_array_8[ii];


			if(param.tets_number < param.tet_mem_lim ){


			inv3_dX[0]=param.inv3_dX_array_0[ii];
			inv3_dX[3]=param.inv3_dX_array_3[ii];
			inv3_dX[6]=param.inv3_dX_array_6[ii];
			inv3_dX[1]=param.inv3_dX_array_1[ii];
			inv3_dX[4]=param.inv3_dX_array_4[ii];
			inv3_dX[7]=param.inv3_dX_array_7[ii];
			inv3_dX[2]=param.inv3_dX_array_2[ii];
			inv3_dX[5]=param.inv3_dX_array_5[ii];
			inv3_dX[8]=param.inv3_dX_array_8[ii];

			}else{

			//inv3(dX,inv3_dX, param);
			//inv3_(dX,inv3_dX,param);
			det3_(dX,det_dX,param);
			inv3_(dX,det_dX,inv3_dX,param);

			}

			
			
			//m(dx, inv3_dX, F);
			m3_(dx,inv3_dX,F);

			///

			//inv3(dx,inv3_dx, param);

			//inv3_(dx,inv3_dx,param);
			det3_(dx,det_dx,param);
			inv3_(dx,det_dx,inv3_dx,param);


			if(param.tets_number < param.tet_mem_lim ){

			param.inv3_dx_array_0[ii]=inv3_dx[0];
			param.inv3_dx_array_3[ii]=inv3_dx[3];
			param.inv3_dx_array_6[ii]=inv3_dx[6];
			param.inv3_dx_array_1[ii]=inv3_dx[1];
			param.inv3_dx_array_4[ii]=inv3_dx[4];
			param.inv3_dx_array_7[ii]=inv3_dx[7];
			param.inv3_dx_array_2[ii]=inv3_dx[2];
			param.inv3_dx_array_5[ii]=inv3_dx[5];
			param.inv3_dx_array_8[ii]=inv3_dx[8];

			}

			////
			//det3_(dx,det_dx,param);

			//asv = (1.0/6.0)*det3(dx, param);
			asv = (1.0/6.0)*det_dx;
			if(asv > 0){
				current_tet_volumes[ii] =  asv;
			}else{
				current_tet_volumes[ii] =  -1.0*asv;
			}
			

			

		////
			

			
			
			

	
			if( param.jagged_compression == true){

				

				//
				/*
				
				
				vec1[0]=dx_(0,0);
			vec1[1]=dx_(1,0);
			vec1[2]=dx_(2,0);

			vec2[0]=dx_(0,1);
			vec2[1]=dx_(1,1);
			vec2[2]=dx_(2,1);

			vec3[0]=dx_(0,2);
			vec3[1]=dx_(1,2);
			vec3[2]=dx_(2,2);

			vec4[0]=x3-x2;
			vec4[1]=y3-y2;
			vec4[2]=z3-z2;

			vec5[0]=x4-x2;
			vec5[1]=y4-y2;
			vec5[2]=z4-z2;

			vec6[0]=x4-x3;
			vec6[1]=y4-y3;
			vec6[2]=z4-z3;

			cross_product(vec2,vec1,n4);
			cross_product(vec1,vec3,n3);
			cross_product(vec3,vec2,n2);
			cross_product(vec4,vec5,n1);

			n1_length=vec_length(n1);
			n2_length=vec_length(n2);
			n3_length=vec_length(n3);
			n4_length=vec_length(n4);

				

				


				

				for(short ww=0;ww<3;ww++){

					n1[ww]=n1[ww]/n1_length;
					n2[ww]=n2[ww]/n2_length;
					n3[ww]=n3[ww]/n3_length;
					n4[ww]=n4[ww]/n4_length;

				}


				//computing dihedral angles

				//if(param.done_timestepping == true){
				//if(r!=0){

				if(param.min_angle != 0){

				this_min_d_ang = 2*param.pi;
				this_max_d_ang = 0;

				

					d_ang = acos(-dot3(n1,n2));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n1,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n1,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n2,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n2,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n3,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}


				}

				//}


				this_min_d_ang = this_min_d_ang*180/param.pi;
				this_max_d_ang = this_max_d_ang*180/param.pi;

				*/
				
				//

				
				




				////////////////////////////////////////////////////////////////////
				//new elasticity

				

				//detF = det3(F, param);
				det3_(F,detF,param);

				//m(dX,inv3_dx, M2);
				m3_(dX,inv3_dx,M2);

				//transpose3(M2,M3);
				transpose3_(M2,M3);

				//m(M2,M3,C_inv);
				//m3_(M2,M3,C_inv);

				m3_AAT_(M2,C_inv);

				//transpose3(F, trans3_F);
				//transpose3_(F,trans3_F);

				//m(trans3_F, F, C);
				//m3_(trans3_F,F,C);

				m3_ATA_(F,C);

				J3 = detF*detF;

				//detC = det3(C);
				//detC_m1 = detC - 1.0;

				temp_val = detF-(1-param.e3);

				if(detF < (1-param.e3)){

				//val3 = 1.0*(detF-.9)*(detF-.9)*(detF-.9)*detF;
					val3 = param.k3*temp_val*detF;//*temp_val*temp_val*detF;


				}else{
					//if(detF > 1.3){
						//val3 =1.0*(detF-1.1)*(detF-1.1)*(detF-1.1)*detF;
						//val3 = 324.0*(detF-1.3)*(detF-1.3)*(detF-1.3)*detF;
					//	val3 = 0;

					//}else{

						val3 = 0;


					//}
				}

				power = 1.33333333;
				ev2 = pow(detF,power);
				
				power = .66666666;
				ev1 = pow(detF, power);

				//J2 = J3*trace3(C_inv);
				J2 = J3*trace3_(C_inv);

				//J1 = trace3(C);
				J1 = trace3_(C);

				bd = 3+param.e2;

				temp_val=J2-(bd*ev2);

				//if(J2 < 2.28){
					//val2 = 16.0*(J2-2.28)*(J2-2.28)*(J2-2.28);
				//	val2=0;
				//}else{
					if(J2 > (bd*ev2) ){
						//val2 = 1.0*(J2-3.42)*(J2-3.42)*(J2-3.42);
						val2 = param.k2*temp_val;//*temp_val*temp_val;

						val3 = val3 + val2*(-bd*.6666666*ev2);

					}else{
						val2 = 0;
					}
				//}

					

					

					bd = 3+param.e1;

					temp_val=J1-(bd*ev1);

				//if(J1 < 2.64){
				//	val1=0;
					//val1 = 16.0*(J1-2.64)*(J1-2.64)*(J1-2.64);
				//}else{
					if(J1 > (bd*ev1) ){
						//val1 = 1.0*(J1-3.21)*(J1-3.21)*(J1-3.21);
						val1 = param.k1*temp_val;//*temp_val*temp_val;

						val3 = val3 + val1*(-bd*.33333333*ev1);

					}else{
						val1 = 0;
					}
				//}

				//cout << val1 << " " << val2 << " " << val3 << " ";
				
				//THE EQUATION BELOW IS:
					//	val3*F^(-T) + val1*F + F*(temp_val1*I+temp_val2*C)
					// some matrices like C get overwritten in the process for compuatational efficeincy
				



				m_const3_(M3,val3);

				

				eye3_(I);
				temp_val1=val2*J1;
				m_const3_(I,temp_val1);


				temp_val2=val2*(-1.0);
				m_const3_(C,temp_val2);

				add3_(I,C);
				
				m3_(F,I,P);

				m_const3_(F,val1);
				add3_(P,F);

				add3_(P,M3);

				
/*

				//m_const(9, M3, val3, M4);
				m_const3_(M3,val3,M4);

				//m_const(9, F, val1, M1);
				m_const3_(F,val1,M1);

				//add(9, M1, M4, M5);
				add3_(M1,M4,M5);
				
				//eye3(I);
				eye3_(I);

				temp_val=val2*J1;

				//m_const(9,I,val2*trace_C,M1);
				m_const3_(I,temp_val,M1);

				temp_val=val2*(-1.0);

				//m_const(9,C,val2*(-1.0),M2);
				m_const3_(C,temp_val,M2);

				//add(9,M1,M2,M3);
				add3_(M1,M2,M3);

				//m(F,M3,M4);
				m3_(F,M3,M4);


				//add(9,M4,M5,P);
				add3_(M4,M5,P);
*/


				if( detF < 0.0){
					cout << "tet inverted" << endl;
					exit(1);
				}







				//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace_C-3.0) + mu/2.0*(detF*detF*trace3(C_inv)-3.0) + 4*lambda*detF_m1*detF_m1*detF_m1*detF_m1 + 2*mu*( (detF - 1)*(detF-2) ) ) ;

			
			
				

				//eye3(P);
				//P_(0,0)=0;
				//P_(1,1)=0;
				//P_(2,2)=0;

				//////////////////////////////////////////////////////////////












			}

			



			











			

			//end

			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			
			
		if( param.jagged_compression == false){

		
				detF = det3(F, param);

				if( (detF > .0000001) || (detF < -.0000001) ){

					

					//param.inverted[ii] = true;
					//cout << "inverted" << endl;

					//node_class[p1].inverted = true;
					//node_class[p2].inverted = true;
					//node_class[p3].inverted = true;
					//node_class[p4].inverted = true;

				


				//m_const(9, F, mu, M1);

				//psd_inv3(dx, inv3_dx, param);

				

				//psd_inv3_2(dx, inv3_dx, param);

				m(dX,inv3_dx, M2);

				transpose3(M2,M3);

				m(M2,M3,C_inv);

				

				detF_m1=detF-1;

				transpose3(F, trans3_F);
				m(trans3_F, F, C);

				//detC = det3(C);
				//detC_m1 = detC - 1.0;

				if(detF < 1.0){

				//if(detC < 1.5){

				//val1 = 32.0*lambda*detF_m1*detF_m1*detF_m1*detF + mu*(2*detF-3)*detF;
					//val1 = 32.0*lambda*detC_m1*detC_m1*detC_m1*detC + mu*(2*detC - 3)*detC;
				val1 = 16.0*lambda*detF_m1*detF_m1*detF_m1*detF + 3*mu*(2*detF - 3)*detF;
				//val1 = 32.0*lambda*detF_m1*detF_m1*detF_m1*detF + -1.0*mu;
				//val1 = 32.0*lambda*detF_m1*detF_m1*detF_m1*detF;

					//val1 = 0;


				}else{

					val1 = 3*mu*(2*detF - 3)*detF;

				//	val1 = 32.0*lambda*detC_m1*detC_m1*detC_m1*detC ;

				//	val1 = (lambda/2.0)*detF - mu*detF;

				}

				m_const(9, M3, val1, M4);
				//m_const(9, M3, val1, P);


				m_const(9, F, mu, M1);
				//m_const(9, F, mu, P);
				//for(short rrr = 0;rrr<9;rrr++){
				//	M1[rrr]=0;
				//}


				add(9, M1, M4, M5);


				
				eye3(I);

				trace_C = trace3(C);

				

				m_const(9,I,mu*trace_C,M1);

				m_const(9,C,mu*(-1.0),M2);

				add(9,M1,M2,M3);

				m(F,M3,M4);

				//if(ii<100){
				//out3(M2);
				//cout << " " << endl;
				//}
				//for(short rrr = 0;rrr<9;rrr++){
				//	M1[rrr]=0;
				//}

				add(9,M4,M5,P);

				}else{

					eye3(P);

					}

/*
			//St. Venant-Kirchhoff

			//G = .5*(transpose(F)*F - I) 

			//transpose3(F, trans3_F);

			m(trans3_F, F, M1);
			m_const(9,I,-1.0,M2);
			add(9,M1,M2,M3);
			m_const(9,M3,0.5,G);
			

			//S=lambda*trace(G)*I + 2*mu*G

			m_const(9,I,alpha*trace3(G),M1);
			m_const(9,G,2*beta,M2);
			add(9,M1,M2,S);

			m(F,S,P);	
			*/

				


				
				

					//param.inverted[ii] = false;

				

				//}else{

				//	eye3(P);
				

				//}

				//P_(0,0) = P_(0,0)+mu;
				//P_(1,1) = P_(1,1)+mu;
				//P_(2,2) = P_(2,2)+mu;

				



					//W = mu/2*(tr(F_T*F)-3)+8*lambda*(detF-1)^4 if detF < 1.333333333333
					//W= mu/2*(tr(F_T*F)-3)+lambda/2*(detF-.5432) otherwise ---- incorrect

					

					if(detF < 1.0){
				//if(detC < 1.5){
							
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*((trace3(C)-3.0) + (detF*detF*trace3(C_inv)-3.0)) + 8*lambda*detF_m1*detF_m1*detF_m1*detF_m1 - mu*(detF - 1) ) ;
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0) + 8*lambda*detF_m1*detF_m1*detF_m1*detF_m1 - .5*mu*( log(det3(C)) ) ) ;
						param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace_C-3.0) + mu/2.0*(detF*detF*trace3(C_inv)-3.0) + 4*lambda*detF_m1*detF_m1*detF_m1*detF_m1 + 2*mu*( (detF - 1)*(detF-2) ) ) ;
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0) + mu*( (detF - 1)*(detF-2) ) ) ;
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0) + 8*lambda*detF_m1*detF_m1*detF_m1*detF_m1 + mu*(detF*detF-3*detF+2) ) ;
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*(  8*lambda*detF_m1*detF_m1*detF_m1*detF_m1 );
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0)  ) ;

						
				}else{
				//	}else{

					param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace_C-3.0) + mu/2.0*(detF*detF*trace3(C_inv)-3.0)  + 2*mu*( (detF - 1)*(detF-2) ) )  ;


				//		param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*((trace3(C)-3.0) + (detF*detF*trace3(C_inv)-3.0)) + lambda/2.0*(detF-1.1875) - mu*(detF - 1) ) ;
						//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0) + lambda/2.0*(detF-1.1875) - .5*mu*(detF - 1) ) ;

					}

					//param.G[param.t] = param.G[param.t] + tet_volumes[ii]*( mu/2.0*(trace3(C)-3.0) + 8*lambda*detF_m1*detF_m1*detF_m1*detF_m1 + .5*mu*( (detF*detF - 1)*(detF*detF-2) ) ) ;


				//}


				//}else{
				//	eye3(P);
				//}
						

					if(detF < 0){
						param.inverted_count = param.inverted_count + 1;
						param.inverted[ii] = true;
							
					}else{

						param.inverted[ii] = false;

					}

					

		}

			
			

			

			
			




			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


			//ftwo_fthree_ffour = -1.0*tet_volumes(i)* P * transpose3(inv3_dX) ;

			//transpose3(inv3_dX, M1);
			transpose3_(inv3_dX,M1);

			temp_val=-1.0*tet_volumes[ii];

			//m_const(9, P, -1.0*tet_volumes[ii], M2);
			m_const3_(P,temp_val);

			//m(M2,M1,ftwo_fthree_ffour);
			m3_(P,M1,ftwo_fthree_ffour);

			//cout << "fs" << endl;
			//out3(ftwo_fthree_ffour);


			fone[0] = -1.0*ftwo_fthree_ffour[0] -1.0*ftwo_fthree_ffour[3] -1.0*ftwo_fthree_ffour[6];
			fone[1] = -1.0*ftwo_fthree_ffour[1] -1.0*ftwo_fthree_ffour[4] -1.0*ftwo_fthree_ffour[7];
			fone[2] = -1.0*ftwo_fthree_ffour[2] -1.0*ftwo_fthree_ffour[5] -1.0*ftwo_fthree_ffour[8];


			param.enf_x[p1] +=  fone[0];
			param.enf_y[p1] +=  fone[1];
			param.enf_z[p1] +=  fone[2];

			param.enf_x[p2] +=  ftwo_fthree_ffour[0];
			param.enf_y[p2] +=  ftwo_fthree_ffour[1];
			param.enf_z[p2] +=  ftwo_fthree_ffour[2];

			param.enf_x[p3] +=  ftwo_fthree_ffour[3];
			param.enf_y[p3] +=  ftwo_fthree_ffour[4];
			param.enf_z[p3] +=  ftwo_fthree_ffour[5];

			param.enf_x[p4] +=  ftwo_fthree_ffour[6];
			param.enf_y[p4] +=  ftwo_fthree_ffour[7];
			param.enf_z[p4] +=  ftwo_fthree_ffour[8];



			/////////////////////////////////////////////////////////////////////////////////////////////////
			/*
			if(param.jagged_compression == true){

				if(param.boundary_tet[ii] == true){

			S[0]=-0.02;
			S[1]=0.0;
			S[2]=0.0;
			S[3]=0.0;
			S[4]=-0.02;
			S[5]=0.0;
			S[6]=0.0;
			S[7]=0.0;
			S[8]=-0.02;

			transpose3(inv3_dx, M1);
			m_const(9, S, -1.0*current_tet_volumes[ii], M2);
			m(M2,M1,ftwo_fthree_ffour);

			//cout << "fs" << endl;
			//out3(ftwo_fthree_ffour);


			fone[0] = -1.0*ftwo_fthree_ffour[0] -1.0*ftwo_fthree_ffour[3] -1.0*ftwo_fthree_ffour[6];
			fone[1] = -1.0*ftwo_fthree_ffour[1] -1.0*ftwo_fthree_ffour[4] -1.0*ftwo_fthree_ffour[7];
			fone[2] = -1.0*ftwo_fthree_ffour[2] -1.0*ftwo_fthree_ffour[5] -1.0*ftwo_fthree_ffour[8];


			param.enf_x[p1] = param.enf_x[p1] + fone[0];
			param.enf_y[p1] = param.enf_y[p1] + fone[1];
			param.enf_z[p1] = param.enf_z[p1] + fone[2];

			param.enf_x[p2] = param.enf_x[p2] + ftwo_fthree_ffour[0];
			param.enf_y[p2] = param.enf_y[p2] + ftwo_fthree_ffour[1];
			param.enf_z[p2] = param.enf_z[p2] + ftwo_fthree_ffour[2];

			param.enf_x[p3] = param.enf_x[p3] + ftwo_fthree_ffour[3];
			param.enf_y[p3] = param.enf_y[p3] + ftwo_fthree_ffour[4];
			param.enf_z[p3] = param.enf_z[p3] + ftwo_fthree_ffour[5];

			param.enf_x[p4] = param.enf_x[p4] + ftwo_fthree_ffour[6];
			param.enf_y[p4] = param.enf_y[p4] + ftwo_fthree_ffour[7];
			param.enf_z[p4] = param.enf_z[p4] + ftwo_fthree_ffour[8];

				}

			}
			*/
			



			/////////////////////////////////////////////////////////////////////////////////////////////////




			/*
			if(param.jagged_compression == true){
			if(param.inflation > 0 ){
				if(param.inflate[ii] == true){

					inflation_x[p1] = inflation_x[p1] + fone[0];
					inflation_y[p1] = inflation_y[p1] + fone[1];
					inflation_z[p1] = inflation_z[p1] + fone[2];

					inflation_x[p2] = inflation_x[p2] + ftwo_fthree_ffour_(0,0);
					inflation_y[p2] = inflation_y[p2] + ftwo_fthree_ffour_(1,0);
					inflation_z[p2] = inflation_z[p2] + ftwo_fthree_ffour_(2,0);

					inflation_x[p3] = inflation_x[p3] + ftwo_fthree_ffour_(0,1);
					inflation_y[p3] = inflation_y[p3] + ftwo_fthree_ffour_(1,1);
					inflation_z[p3] = inflation_z[p3] + ftwo_fthree_ffour_(2,1);

					inflation_x[p4] = inflation_x[p4] + ftwo_fthree_ffour_(0,2);
					inflation_y[p4] = inflation_y[p4] + ftwo_fthree_ffour_(1,2);
					inflation_z[p4] = inflation_z[p4] + ftwo_fthree_ffour_(2,2);

				}
			}
			}
			*/



		}

		/*
		if(param.jagged_compression == true){
		for(long n=0;n<param.nodes_number;n++){

			if(param.inflation > 0 ){
				if(node_class[n].singleton == true){

					param.enf_x[n] = param.inflation*param.enf_x[n] + inflation_x[n];
					param.enf_y[n] = param.inflation*param.enf_y[n] + inflation_y[n];
					param.enf_z[n] = param.inflation*param.enf_z[n] + inflation_z[n];

					if(node_class[n].hard_limit == true){

						param.enf_x[n] = .1*param.enf_x[n];
						param.enf_y[n] = .1*param.enf_y[n];
						param.enf_z[n] = .1*param.enf_z[n];

					}


				}
			}


		}
		


			
		//	cout << " largest edge ratio " << largest_edge_ratio <<  endl;


			
			delete [] inflation_x;
			delete [] inflation_y;
			delete [] inflation_z;






		}
		*/

		
		//if(param.jagged_compression == true){
		//cout << "min/max dihedral angle " << min_d_ang*180/param.pi << " " << max_d_ang*180/param.pi << endl;
		//}

		//if(param.t > 1){
		//if( (min_d_ang*180/param.pi) < 1.0){
		//	cout << "min angle too small" << endl;
		//	exit(1);
		//}
		//}
		//}



		//if(param.done_timestepping == true){
		//if(param.jagged_compression == true){

			
		//}
		//}

		if(param.inverted_count > 0){
			cout << "inverted count " << param.inverted_count << endl;
		}

		//cout << lambda << endl;
		//cout << mu << endl;

		
	
}







long roundb(float val){

	float one = 1.0;
	float rem;
	rem = fmod(val,one);
	if(rem < .5){
		val = val - rem;
	}else{
		val = val - rem + 1;
	}

	return long(val);

}



short region(float x, float y, float z,  short regions_array[], parameters &param){

	//cout << x-8 << " " << y-8 << " " << z-8 << endl;

	short val;

	if( (x < 4.0) || (x > (param.size1D_x-5.0)) || (y < 4.0) || (y > (param.size1D_y-5.0)) || (z < 4.0) || (z > (param.size1D_z-5.0)) ){
		val = 0;
		//cout << "hit outside image" << endl;
	}else{
	
	long s1Dx, s1Dy, s1Dz;

	if(param.zoom_level == 1){
		s1Dx = param.size1D_x;
		s1Dy = param.size1D_y;
		s1Dz = param.size1D_z;
		x=x+1.5;
		y=y+1.5;
		z=z+1.5;
	}
	if(param.zoom_level == 2){
		s1Dx = param.size1D_x_z2;
		s1Dy = param.size1D_y_z2;
		s1Dz = param.size1D_z_z2;
		x=x+1.0;
		y=y+1.0;
		z=z+1.0;
		x=x-8; x=x/2.0; x=x+8;
		y=y-8; y=y/2.0; y=y+8;
		z=z-8; z=z/2.0; z=z+8;
	}
	if(param.zoom_level == 3){
		s1Dx = param.size1D_x_z3;
		s1Dy = param.size1D_y_z3;
		s1Dz = param.size1D_z_z3;
		x=x-8; x=x/4.0; x=x+8;
		y=y-8; y=y/4.0; y=y+8;
		z=z-8; z=z/4.0; z=z+8;
	}


	
	long index;
	long r_x, r_y, r_z;

	

		
		r_x = roundb(x);
		r_y = roundb(y);
		r_z = roundb(z);

		//cout << x << " " << y << " " << z << endl;
		//cout << r_x << " " << r_y << " " << r_z << endl;

		index = r_x + s1Dx*r_y + s1Dx*s1Dy*r_z;

		val = regions_array[index];

	}

	//finding 8 values around point
/*
		long around[8];

		around[0] = long(floor(x) + floor(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y);
		around[1] = long(ceil(x) + floor(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y);
		around[2] = long(floor(x) + ceil(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y);
		around[3] = long(ceil(x) + ceil(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y);
		around[4] = long(floor(x) + floor(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y);
		around[5] = long(ceil(x) + floor(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y);
		around[6] = long(floor(x) + ceil(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y);
		around[7] = long(ceil(x) + ceil(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y);

	//picking the maximimum region number to be the assigned region

		val = regions_array[around[0]];
		for(short m=1;m<8;m++){
			if(regions_array[around[m]]>regions_array[around[m-1]]){
				val = regions_array[around[m]];
			};
		};
	};

*/

	//cout << val << endl;

	return val;


}






//set use_only_this region to true for now

float level_set_value(float x, float y, float z, float signed_dist_array[], parameters &param, short this_region_number, bool use_only_this_region, short regions_array[]){



	float ls_val;

	if( (region(x,y,z,regions_array,param) == this_region_number) || (use_only_this_region == false) ){

		if( (x < 4.0) || (x > float(param.size1D_x-5.0)) || (y < 4.0) || (y > float(param.size1D_y-5.0)) || (z < 4.0) || (z > float(param.size1D_z-5.0)) ){

			ls_val = 800;

			//cout << "bad ls value used.  region too close to boundary" << endl;

		}else{





		long s1Dx, s1Dy, s1Dz;

	if(param.zoom_level == 1){
		s1Dx = param.size1D_xl;
		s1Dy = param.size1D_yl;
		s1Dz = param.size1D_zl;
		x=x+1.5;
		y=y+1.5;
		z=z+1.5;
	}
	if(param.zoom_level == 2){
		s1Dx = param.size1D_xl_z2;
		s1Dy = param.size1D_yl_z2;
		s1Dz = param.size1D_zl_z2;
		x=x+1.0;
		y=y+1.0;
		z=z+1.0;
		x=x-8; x=x/2.0; x=x+8;
		y=y-8; y=y/2.0; y=y+8;
		z=z-8; z=z/2.0; z=z+8;
	}
	if(param.zoom_level == 3){
		s1Dx = param.size1D_xl_z3;
		s1Dy = param.size1D_yl_z3;
		s1Dz = param.size1D_zl_z3;
		x=x-8; x=x/4.0; x=x+8;
		y=y-8; y=y/4.0; y=y+8;
		z=z-8; z=z/4.0; z=z+8;
	}


		x = x*2.0;
		y = y*2.0;
		z = z*2.0;



		


		float ls_vals[8];
		long around[8];

	

		//finding 8 values around point

		//the final vector field has number of regions+1 vector fields associated with it
		//the initial vector field has only 1 vector field associated with it
	/*
		if(use_only_this_region == false){

			around[0] = long(floor(x) + floor(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[1] = long(ceil(x) + floor(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[2] = long(floor(x) + ceil(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[3] = long(ceil(x) + ceil(y)*param.size1D_x + floor(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[4] = long(floor(x) + floor(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[5] = long(ceil(x) + floor(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[6] = long(floor(x) + ceil(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);
			around[7] = long(ceil(x) + ceil(y)*param.size1D_x + ceil(z)*param.size1D_x*param.size1D_y+param.size3D*this_region_number);

		}
	*/
		//if(use_only_this_region == true){

			around[0] = long(floor(x) + floor(y)*s1Dx + floor(z)*s1Dx*s1Dy);
			around[1] = long(ceil(x) + floor(y)*s1Dx + floor(z)*s1Dx*s1Dy);
			around[2] = long(floor(x) + ceil(y)*s1Dx + floor(z)*s1Dx*s1Dy);
			around[3] = long(ceil(x) + ceil(y)*s1Dx + floor(z)*s1Dx*s1Dy);
			around[4] = long(floor(x) + floor(y)*s1Dx + ceil(z)*s1Dx*s1Dy);
			around[5] = long(ceil(x) + floor(y)*s1Dx + ceil(z)*s1Dx*s1Dy);
			around[6] = long(floor(x) + ceil(y)*s1Dx + ceil(z)*s1Dx*s1Dy);
			around[7] = long(ceil(x) + ceil(y)*s1Dx + ceil(z)*s1Dx*s1Dy);

		//}

		
		
			for(short m=0;m<8;m++){
				ls_vals[m] = signed_dist_array[around[m]];
				//cout<< around[m] << endl;
			};
			//cout << " " << endl;





		
			float d1b = x - float(floor(x));
			float d2b = y - float(floor(y));
			float d3b = z - float(floor(z));
		
			float d1 = 1.0-d1b;
			float d2 = 1.0-d2b;
			float d3 = 1.0-d3b;
		
			/*
			float d1 = float(ceil(x)) - x;
			float d2 = float(ceil(y)) - y;
			float d3 = float(ceil(z)) - z;
			*/

		
		//cout << d1b << " " << d2b << " " << d3b << " " << d1 << " " << d2 << " " << d3 << endl;
		//cout << "x,y,z= "<< x << " " << y << " " << z << endl;

		/*
		x_vals[0] = 2;
		y_vals[0] = 2;
		z_vals[0] = 2;
		for(short m=1;m<8;m++){
			x_vals[m] = 1;
			y_vals[m] = 1;
			z_vals[m] = 1;
			//cout << gradient_field_x[around[m]] << " " << gradient_field_y[around[m]] << " " << gradient_field_z[around[m]] << endl;
		};
		*/


			ls_val = ls_vals[0]*d1*d2*d3 + ls_vals[1]*d1b*d2*d3 + ls_vals[2]*d1*d2b*d3 + ls_vals[3]*d1b*d2b*d3 + ls_vals[4]*d1*d2*d3b + ls_vals[5]*d1b*d2*d3b + ls_vals[6]*d1*d2b*d3b + ls_vals[7]*d1b*d2b*d3b;


		//cout << "interpolated " << endl;
		//cout <<"grad's = " << grad_x << " " << grad_y << " " << grad_z << endl;
		


		//cout << grad_x << " " << grad_y << " " << grad_z << endl;
		//cout << d1 << " " << d2 << " " << d3 << " " << d1b << " " <<d2b << " " << d3b << endl;
		//cout << sd[0] << " " << sd[1] << " " << sd[2] << " " << sd[3] << " " << sd[4] << " "<< sd[5] <<" "<< sd[6] << " "<< sd[7]<< endl;
		//cout << val << endl;
		};
	
	//cout << ls_val << endl;
	//cout << " " << endl;

		}else{

			ls_val = 0;

		}
		return ls_val;


}

//this level set value computation only works if you are outside the region of interest but within a voxel of the region boundary

float level_set_value_m(float x, float y, float z, float signed_dist_array[], parameters &param, short this_region_number, bool use_only_this_region, short regions_array[]){


	long s1Dx, s1Dy, s1Dz;
	float mult;

	if(param.zoom_level == 1){
		s1Dx = param.size1D_x;
		s1Dy = param.size1D_y;
		s1Dz = param.size1D_z;
		x=x+1.5;
		y=y+1.5;
		z=z+1.5;
		mult = 1.0;
	}
	if(param.zoom_level == 2){
		s1Dx = param.size1D_x_z2;
		s1Dy = param.size1D_y_z2;
		s1Dz = param.size1D_z_z2;
		x=x+1.0;
		y=y+1.0;
		z=z+1.0;
		x=x-8; x=x/2.0; x=x+8;
		y=y-8; y=y/2.0; y=y+8;
		z=z-8; z=z/2.0; z=z+8;
		mult = 2.0;
	}
	if(param.zoom_level == 3){
		s1Dx = param.size1D_x_z3;
		s1Dy = param.size1D_y_z3;
		s1Dz = param.size1D_z_z3;
		x=x-8; x=x/4.0; x=x+8;
		y=y-8; y=y/4.0; y=y+8;
		z=z-8; z=z/4.0; z=z+8;
		mult = 4.0;
	}


	float center;
	float r_x, r_y, r_z;
	float x_dis, y_dis, z_dis;



	r_x = float(roundb(x));
	r_y = float(roundb(y));
	r_z = float(roundb(z));

	center = r_x + s1Dx*r_y + s1Dx*s1Dy*r_z;

	//search 8 neighbors;

		long move_forward = 1;
		long move_right =  s1Dx;
		long move_up = s1Dx*s1Dy;
		
		long move_back = -1;
		long move_left = -s1Dx;
		long move_down = - s1Dx*s1Dy;


		long around1[8];
		long around2[12];
		long around3[8];
		float min_dis = 100.0;
		float dis;
		float dis_x, dis_y, dis_z;

		bool hit;
		hit = false;
		float p5 = 0.5;

		if( (fmod(x, p5)  == 0) || (fmod(y, p5)  == 0) || (fmod(z, p5)  == 0) ){
			hit = true;
			min_dis = 0.0;
		}


		if(regions_array[long(center)] == this_region_number){
			hit = true;
			min_dis = 0.0;
		}

		if(hit == false){

		around1[0] = long(center + move_forward);
		around1[1] = long(center + move_back);
		around1[2] = long(center + move_right);
		around1[3] = long(center + move_left);
		around1[4] = long(center + move_up);
		around1[5] = long(center + move_down);

		if(regions_array[around1[0]] == this_region_number){
			hit = true;
			dis = mult*( (r_x + .5) - x);
			if(dis < min_dis){
				min_dis = dis;
			}
		}
		if(regions_array[around1[1]] == this_region_number){
			hit = true;
			dis = mult*( x - (r_x - .5));
			if(dis < min_dis){
				min_dis = dis;
			}
		}

		if(regions_array[around1[2]] == this_region_number){
			hit = true;
			dis = mult*( (r_y + .5) - y);
			if(dis < min_dis){
				min_dis = dis;
			}
		}
		if(regions_array[around1[3]] == this_region_number){
			hit = true;
			dis = mult*( y - (r_y - .5));
			if(dis < min_dis){
				min_dis = dis;
			}
		}

		if(regions_array[around1[4]] == this_region_number){
			hit = true;
			dis = mult*( (r_z + .5) - z);
			if(dis < min_dis){
				min_dis = dis;
			}
		}
		if(regions_array[around1[5]] == this_region_number){
			hit = true;
			dis = mult*( z - (r_z - .5));
			if(dis < min_dis){
				min_dis = dis;
			}
		}


		}

		if(hit == false){

			around2[0] = long(center + move_down + move_forward);
			around2[1] = long(center + move_down + move_back);
			around2[2] = long(center + move_down + move_right);
			around2[3] = long(center + move_down + move_left);
			around2[4] = long(center + move_right + move_forward);
			around2[5] = long(center + move_right + move_back);
			around2[6] = long(center + move_left + move_forward);
			around2[7] = long(center + move_left + move_back);
			around2[8] = long(center + move_up + move_forward);
			around2[9] = long(center + move_up + move_back);
			around2[10] = long(center + move_up + move_right);
			around2[11] = long(center + move_up + move_left);

			if(regions_array[around2[0]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_z = mult*(  z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[1]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5)) ;
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[2]] == this_region_number){
				hit = true;
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_y*dis_y + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[3]] == this_region_number){
				hit = true;
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_y*dis_y + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[4]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( (r_y + .5) - y);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[5]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( (r_y + .5) - y);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[6]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( y - (r_y - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[7]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( y - (r_y - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[8]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_z = mult*( (r_z + .5) - z);
				dis = sqrt( dis_x*dis_x + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[9]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_z = mult*( (r_z + .5) - z);
				dis = sqrt( dis_x*dis_x + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[10]] == this_region_number){
				hit = true;
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( (r_z + .5) - z);
				dis = sqrt( dis_y*dis_y + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around2[11]] == this_region_number){
				hit = true;
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( (r_z + .5) - z);
				dis = sqrt( dis_y*dis_y + dis_z*dis_z );
				if(dis < min_dis){
					min_dis = dis;
				}
			}

		}



		if(hit == false){

			around3[0] = long(center + move_down + move_right + move_forward);
			around3[1] = long(center + move_down + move_right + move_back);
			around3[2] = long(center + move_down + move_left + move_forward);
			around3[3] = long(center + move_down + move_left + move_back);
			around3[4] = long(center + move_up + move_right + move_forward);
			around3[5] = long(center + move_up + move_right + move_back);
			around3[6] = long(center + move_up + move_left + move_forward);
			around3[7] = long(center + move_up + move_left + move_back);

			if(regions_array[around3[0]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[1]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[2]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[3]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( z - (r_z - .5));
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[4]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( (r_z + .5)- z);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[5]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( (r_y + .5) - y);
				dis_z = mult*( (r_z + .5)- z);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[6]] == this_region_number){
				hit = true;
				dis_x = mult*( (r_x + .5) - x);
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( (r_z + .5)- z);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}

			if(regions_array[around3[7]] == this_region_number){
				hit = true;
				dis_x = mult*( x - (r_x - .5));
				dis_y = mult*( y - (r_y - .5));
				dis_z = mult*( (r_z + .5)- z);
				dis = sqrt( dis_x*dis_x + dis_y*dis_y + dis_z*dis_z);
				if(dis < min_dis){
					min_dis = dis;
				}
			}


		}

		if(hit == false){
			min_dis = mult;
		}

		//if(min_dis > 1.0){
		//	cout << "min dis " << min_dis << endl;
		//}

		return min_dis;	




}




void calculate_gvf_forces( short regions_array[], node_info node_class[], float current_tet_volumes[], long t, face face_class[] , parameters &param){

	for(long n=0;n<param.nodes_number;n++){
		if(node_class[n].boundary == true){
			node_class[n].set_vecs_to_0();
			node_class[n].set_associated_node_volumes_to_0();
			node_class[n].set_grad2_to_0();
		}
	}

	float add_to_p1, add_to_p2, add_to_p3, add_to_p4;
	float f1_x,f1_y,f1_z,f2_x,f2_y,f2_z,f3_x,f3_y,f3_z,f4_x,f4_y,f4_z;
	long tet_num;

	float asv;
	long p1, p2, p3, p4;
	float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
	float ls1, ls2, ls3, ls4;
	float dls_dx, dls_dy, dls_dz;
	short r, region_number;
	short r1,r2,r3,r4;

	float k;
	float v1,v2,v3;
	float g1, g2, g3;

	//float *tet_dls_dx; 
	//float *tet_dls_dy;
	//float *tet_dls_dz; 

	//if(param.beta != 0){

		//tet_dls_dx = new float[param.tets_number];
		// tet_dls_dy = new float[param.tets_number];
		 //tet_dls_dz = new float[param.tets_number];

	//}


	float inv3_dx[9];

	float v_calc_matrix[9];
	float dx[9];
	float dX[9];
	float inv3_dX[9];

	//float *zero_vec_x; zero_vec_x = new float[param.nodes_number];
	//float *zero_vec_y; zero_vec_y = new float[param.nodes_number];
	//float *zero_vec_z; zero_vec_z = new float[param.nodes_number];
	float this_zero_vec[3];
	float tzvl;

	//float delta;  (1/(param.pi*param.eps))/(1+(0)/(param.eps*param.eps));
	//needs to be fixed at some point
	float delta = 1/param.pi;

	float vol_sum;

	float det_dx;

	/*
	for(long n=0;n<param.nodes_number;n++){

		zero_vec_x[n] = 0;
		zero_vec_y[n] = 0;
		zero_vec_z[n] = 0;

	}
	*/

	for(long ii=0;ii<param.tets_number;ii++){
		if(param.boundary_tet[ii] == true){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];
		region_number=param.t_r[ii];

		//getting r



		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}


		//cout << node_class[p1].regions_belong[r1] <<  " " << node_class[p2].regions_belong[r2] << " " << node_class[p3].regions_belong[r3] << " " << node_class[p4].regions_belong[r4] << endl;
		//cout << region_number << endl;
		//cout << " " << endl;

		ls1 = node_class[p1].ls_val[r1];
		ls2 = node_class[p2].ls_val[r2];
		ls3 = node_class[p3].ls_val[r3];
		ls4 = node_class[p4].ls_val[r4];


		x1 = param.n_x[p1];
		x2 = param.n_x[p2];
		x3 = param.n_x[p3];
		x4 = param.n_x[p4];
		y1 = param.n_y[p1];
		y2 = param.n_y[p2];
		y3 = param.n_y[p3];
		y4 = param.n_y[p4];
		z1 = param.n_z[p1];
		z2 = param.n_z[p2];
		z3 = param.n_z[p3];
		z4 = param.n_z[p4];

		dx[0] = x2-x1;
		dx[3] = x3-x1;
		dx[6] = x4-x1;
		dx[1] = y2-y1;
		dx[4] = y3-y1;
		dx[7] = y4-y1;
		dx[2] = z2-z1;
		dx[5] = z3-z1;
		dx[8] = z4-z1;



		//inv3(dx, inv3_dx);
		psd_inv3(dx, inv3_dx, param);

		

		dls_dx = inv3_dx[0]*(ls2-ls1)+inv3_dx[1]*(ls3-ls1)+inv3_dx[2]*(ls4-ls1);
		dls_dy = inv3_dx[3]*(ls2-ls1)+inv3_dx[4]*(ls3-ls1)+inv3_dx[5]*(ls4-ls1);
		dls_dz = inv3_dx[6]*(ls2-ls1)+inv3_dx[7]*(ls3-ls1)+inv3_dx[8]*(ls4-ls1);

		/*
		if(param.inverted[ii] == true){

		dls_dx = -1.0*dls_dx;
		dls_dy = -1.0*dls_dy;
		dls_dz = -1.0*dls_dz;

		}
		*/
		

		if(param.beta != 0){

			if(param.tets_number < param.tet_mem_lim ){

		inv3_dx[0]=param.inv3_dx_array_0[ii];
		inv3_dx[3]=param.inv3_dx_array_3[ii];
		inv3_dx[6]=param.inv3_dx_array_6[ii];
		inv3_dx[1]=param.inv3_dx_array_1[ii];
		inv3_dx[4]=param.inv3_dx_array_4[ii];
		inv3_dx[7]=param.inv3_dx_array_7[ii];
		inv3_dx[2]=param.inv3_dx_array_2[ii];
		inv3_dx[5]=param.inv3_dx_array_5[ii];
		inv3_dx[8]=param.inv3_dx_array_8[ii];

			}else{

			inv3(dx,inv3_dx, param);

			}



		param.tet_dls_dx[ii] = inv3_dx[0]*(ls2-ls1)+inv3_dx[1]*(ls3-ls1)+inv3_dx[2]*(ls4-ls1);
		param.tet_dls_dy[ii] = inv3_dx[3]*(ls2-ls1)+inv3_dx[4]*(ls3-ls1)+inv3_dx[5]*(ls4-ls1);
		param.tet_dls_dz[ii] = inv3_dx[6]*(ls2-ls1)+inv3_dx[7]*(ls3-ls1)+inv3_dx[8]*(ls4-ls1);


		
		//////////////////////////////////
		//finding basis function derivative on tet

		f1_x = inv3_dx[0]*(-1)-inv3_dx[1]-inv3_dx[2];
		f1_y = inv3_dx[3]*(-1)-inv3_dx[4]-inv3_dx[5];
		f1_z = inv3_dx[6]*(-1)-inv3_dx[7]-inv3_dx[8];

		f2_x = inv3_dx[0];
		f2_y = inv3_dx[3];
		f2_z = inv3_dx[6];

		f3_x = inv3_dx[1];
		f3_y = inv3_dx[4];
		f3_z = inv3_dx[7];

		f4_x = inv3_dx[2];
		f4_y = inv3_dx[5];
		f4_z = inv3_dx[8];

		//laplacian phi * grad phi * tet_volume

		//laplacian phi * grad phi * tet_volume

		add_to_p1 = -(f1_x*param.tet_dls_dx[ii]+f1_y*param.tet_dls_dy[ii]+f1_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p2 = -(f2_x*param.tet_dls_dx[ii]+f2_y*param.tet_dls_dy[ii]+f2_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p3 = -(f3_x*param.tet_dls_dx[ii]+f3_y*param.tet_dls_dy[ii]+f3_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p4 = -(f4_x*param.tet_dls_dx[ii]+f4_y*param.tet_dls_dy[ii]+f4_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];


		}
		/////////////////////////////////


		
		if( (ls1 != 800) && (ls2 != 800) && (ls3 != 800) && (ls4 != 800) ){

			node_class[p1].add_associated_node_volumes(r1, current_tet_volumes[ii]);
			node_class[p2].add_associated_node_volumes(r2, current_tet_volumes[ii]);
			node_class[p3].add_associated_node_volumes(r3, current_tet_volumes[ii]);
			node_class[p4].add_associated_node_volumes(r4, current_tet_volumes[ii]);

			//cout << node_class[p1].associated_node_volumes[r1] << " " << node_class[p2].associated_node_volumes[r2] << " " << node_class[p3].associated_node_volumes[r3] << " " << node_class[p4].associated_node_volumes[r4] << endl;

			node_class[p1].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r1);
			node_class[p2].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r2);
			node_class[p3].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r3);
			node_class[p4].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r4);

			if(param.beta != 0){

			node_class[p1].add_to_grad2(add_to_p1, r1);
			node_class[p2].add_to_grad2(add_to_p2, r2);
			node_class[p3].add_to_grad2(add_to_p3, r3);
			node_class[p4].add_to_grad2(add_to_p4, r4);

			//param.G[param.t] = param.G[param.t] + param.beta*current_tet_volumes[ii]*(dls_dx*dls_dx + dls_dy*dls_dy + dls_dz*dls_dz);

			}


		}

		
	}
	}

	if(param.beta != 0){

		for(long n=0;n<param.faces_number;n++){


		//face_class[n].get_normal(nodes);
		get_normal(face_class, n, param);

		tet_num = face_class[n].tet1;
		p1 = face_class[n].node1;
		p2 = face_class[n].node2;
		p3 = face_class[n].node3;

		//region_number=tets_(tet_num,4);
		region_number=param.t_r[tet_num];

		//getting r

		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}


		add_to_p1 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p2 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p3 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);

		//cout << add_to_p1 << " " <<add_to_p2<< " " <<add_to_p3 << endl;
		//cout << face_class[n].normal1[0] << " " << face_class[n].normal1[1] << " " << face_class[n].normal1[2] << endl;
		//cout << tet_dls_dx[tet_num] << " " << tet_dls_dy[tet_num] << " " << tet_dls_dz[tet_num] << endl;
		//cout << face_class[n].area << endl;


		node_class[p1].add_to_grad2_bdry(add_to_p1, r1);
		node_class[p2].add_to_grad2_bdry(add_to_p2, r2);
		node_class[p3].add_to_grad2_bdry(add_to_p3, r3);

	}



	}



	get_nodes_current_voxel_region(node_class, regions_array,  param);
	if(param.jagged_compression == false){
		get_M( node_class, current_tet_volumes, t, param);
	}else{
		cout << "all M's set to 1" << endl;
		for(short m=1;m<param.max_number_of_regions;m++){	
			param.M[m]=1.0;
		}
	}

	//cout << param.M[1] << " " << param.M[2] << endl;



	for(long n=0;n<param.nodes_number;n++){
		if(node_class[n].boundary == true) {

		//param.lsnf_x[n] = 0;
		//param.lsnf_y[n] = 0;
		//param.lsnf_z[n] = 0;


		for(short r=0;r<node_class[n].number_of_regions_belong;r++){
			

			//cout << node_class[n].associated_node_volumes[r] << endl;

			//if(node_class[n].associated_node_volumes[r] > 0.000001){
			//	k=1/node_class[n].associated_node_volumes[r];
			//}else{
			//	k=0;
		//	}

			region_number = node_class[n].regions_belong[r];

			/*
			if(node_class[n].number_of_regions_belong >1){
				cout << k*node_class[n].grad2_val[r] <<" "<< node_class[n].grad2_bdry_val[r] <<" " << region_number << endl;
			}*/

			

			
			//delta = delta_n0;
			

			if(node_class[n].associated_node_volumes[r] > .000001){
				k=param.alpha*delta/node_class[n].associated_node_volumes[r];
			}else{
				k=0;
				//cout << "node vols small" << endl;
			}

			if( (param.alpha == 0) || (param.beta == 0) ){

				g1=0;
				g2=0;
				g3=0;
			}else{

			node_class[n].grad2_val[r]=k*(node_class[n].grad2_val[r]+node_class[n].grad2_bdry_val[r]);


			g1 = -k*(param.beta/(param.alpha*param.alpha*delta))*node_class[n].vec_x[r]*node_class[n].grad2_val[r];
			g2 = -k*(param.beta/(param.alpha*param.alpha*delta))*node_class[n].vec_y[r]*node_class[n].grad2_val[r];
			g3 = -k*(param.beta/(param.alpha*param.alpha*delta))*node_class[n].vec_z[r]*node_class[n].grad2_val[r];

			}




			/*			
			if((region_number == 0) && (node_class[n].number_of_regions_belong >1) ){

				g1=3.0*g1;
				g2=3.0*g2;
				g3=3.0*g3;

			}
			*/
			

			//cout << node_class[n].current_voxel_region << endl;

			

			if( region_number == node_class[n].current_voxel_region ){

				//vec_x,vec_y,vec_z valuse are overwritten here 

					//v1 = -1.0*k*node_class[n].vec_x[r];
					//v2 = -1.0*k*node_class[n].vec_y[r];
					//v3 = -1.0*k*node_class[n].vec_z[r];

					v1 = -1.0*k*node_class[n].vec_x[r];
					v2 = -1.0*k*node_class[n].vec_y[r];
					v3 = -1.0*k*node_class[n].vec_z[r];



				//param.lsnf_x[n] = param.lsnf_x[n] - k*node_class[n].vec_x[r];
				//param.lsnf_y[n] = param.lsnf_y[n] - k*node_class[n].vec_y[r];
				//param.lsnf_z[n] = param.lsnf_z[n] - k*node_class[n].vec_z[r];

			}
			if( region_number != node_class[n].current_voxel_region ){


					v1 = (-1.0+2.0*param.M[region_number])*k*node_class[n].vec_x[r];
					v2 = (-1.0+2.0*param.M[region_number])*k*node_class[n].vec_y[r];
					v3 = (-1.0+2.0*param.M[region_number])*k*node_class[n].vec_z[r];






				//cout << node_class[n].vec_x[r] << " " << node_class[n].vec_y[r] << " " << node_class[n].vec_z[r] << endl;

			

			}

			//if( region_number == 0 ){
			//	if(  node_class[n].current_voxel_region != 0){

			//		v1 = 1.0*k*node_class[n].vec_x[r];
			//		v2 = 1.0*k*node_class[n].vec_y[r];
			//		v3 = 1.0*k*node_class[n].vec_z[r];

			//	}
			//}

			

			node_class[n].vec_x[r] = v1+g1;
			node_class[n].vec_y[r] = v2+g2;
			node_class[n].vec_z[r] = v3+g3;

			//cout << node_class[n].vec_x[r] << " " << node_class[n].vec_y[r] << " " << node_class[n].vec_z[r] << endl;




		}

	}
	}

	//

		//

	float sum_x, sum_y, sum_z;





		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].boundary == true){

			//cout << node_class[n].number_of_regions_belong << endl;

			sum_x = 0;
			sum_y = 0;
			sum_z = 0;

			param.lsnf_x[n] = 0;
			param.lsnf_y[n] = 0;
			param.lsnf_z[n] = 0;

			for(short r=0;r<node_class[n].number_of_regions_belong;r++){


				sum_x = sum_x + node_class[n].vec_x[r];
				sum_y = sum_y + node_class[n].vec_y[r];
				sum_z = sum_z + node_class[n].vec_z[r];

			}

			param.lsnf_x[n] = sum_x;
			param.lsnf_y[n] = sum_y;
			param.lsnf_z[n] = sum_z;



			//if(node_class[n].singleton == true){

			//	param.lsnf_x[n] = param.lsnf_x[n]/10.0;
			//	param.lsnf_y[n] = param.lsnf_y[n]/10.0;
			//	param.lsnf_z[n] = param.lsnf_z[n]/10.0;

			

			//	if(node_class[n].hard_limit == true){

			//		param.lsnf_x[n] = 0;
			//		param.lsnf_y[n] = 0;
			//		param.lsnf_z[n] = 0;

			//	}


			//}



			//cout << param.lsnf_x[n] << " " << param.lsnf_y[n] << " " <<param.lsnf_z[n] << endl;



			}else{

			param.lsnf_x[n] =0;
			param.lsnf_y[n] = 0;
			param.lsnf_z[n] = 0;



			//if(node_class[n].current_voxel_region == 0){
						//}


			}
		}

	

	for(long n=0;n<param.nodes_number;n++){
		if(node_class[n].boundary == true){
		node_class[n].set_vecs_to_0();
		node_class[n].set_associated_node_volumes_to_0();
		}
	}



	

}









////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void smoothing( short regions_array[], float signed_dist_array[] ,node_info node_class[], float current_tet_volumes[], long t, face face_class[], parameters &param){


	for(long n=0;n<param.nodes_number;n++){
		node_class[n].set_vecs_to_0();
		node_class[n].set_associated_node_volumes_to_0();
		//node_class[n].set_associated_node_areas_to_0();
		node_class[n].set_grad2_to_0();
		//node_class[n].set_biharm_to_0();
	}

	float add_to_p1, add_to_p2, add_to_p3, add_to_p4;
	float f1_x,f1_y,f1_z,f2_x,f2_y,f2_z,f3_x,f3_y,f3_z,f4_x,f4_y,f4_z;
	float this_length, max_length;
	max_length=0;

	float asv;
	long p1, p2, p3, p4;
	float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
	float ls1, ls2, ls3, ls4;
	float dls_dx, dls_dy, dls_dz;
	short r, region_number;
	short r1,r2,r3,r4;
	float k;
	float v1,v2,v3;
	float e[3], f[3], g[3], h[3];
	float g_length, h_length;
	float dot;
	float f_length;
	float xx,yy,zz,ls_val;
	float xx_p1, xx_m1, yy_p1, yy_m1, zz_p1, zz_m1;
	short r_test;
	bool r_near;
	float ls_val_m;
	float lap1,lap2,lap3,lap4;
	float delta;

	float det_dx;
	float inv3_dx[9];

	float v_calc_matrix[9];
	float dx[9];
	float trans3_dx[9];
	float inv3_trans3_dx[9];
	float ls_vec[3];
	float derivec[3];
	float test1,test2,test3;
	float limit;
	float vol;


	//float move[3];

	//float dPhi[9];

	//float *tet_dls_dx; tet_dls_dx = new float[param.tets_number];
	//float *tet_dls_dy; tet_dls_dy = new float[param.tets_number];
	//float *tet_dls_dz; tet_dls_dz = new float[param.tets_number];
	//float *tet_areas; tet_areas = new float[param.tets_number];

	long tet_num;


	float lsle;
	if(param.zoom_level == 1){
		lsle = 0.0;
		limit = 1.0;
	}
	if(param.zoom_level == 2){
		lsle = 1.0;
		limit = 2.0;
	}
	if(param.zoom_level == 3){
		lsle = 2.0;
		limit = 4.0;
	}


	get_nodes_current_voxel_region(node_class, regions_array,  param);


	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// getting the derivative at every point and the laplacian and the associated node volumes
	
	


	for(long ii=0;ii<param.tets_number;ii++){
		//if(param.boundary_tet[ii] == true){


		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];
		region_number=param.t_r[ii];

		//getting r

		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}

		//node_class[p1].add_associated_node_volumes(r1, current_tet_volumes[ii]);
		//node_class[p2].add_associated_node_volumes(r2, current_tet_volumes[ii]);
		//node_class[p3].add_associated_node_volumes(r3, current_tet_volumes[ii]);
		//node_class[p4].add_associated_node_volumes(r4, current_tet_volumes[ii]);
		node_class[p1].associated_node_volumes[r1] += current_tet_volumes[ii];
		node_class[p2].associated_node_volumes[r2] += current_tet_volumes[ii];
		node_class[p3].associated_node_volumes[r3] += current_tet_volumes[ii];
		node_class[p4].associated_node_volumes[r4] += current_tet_volumes[ii];



		
		
		//ls_vec[0] = ls2-ls1;
		//ls_vec[1] = ls3-ls1;
		//ls_vec[2] = ls4-ls1;

		if(param.boundary_tet[ii] == true){

		ls1 = node_class[p1].ls_val[r1];
		ls2 = node_class[p2].ls_val[r2];
		ls3 = node_class[p3].ls_val[r3];
		ls4 = node_class[p4].ls_val[r4];

		x1 = param.n_x[p1];
		x2 = param.n_x[p2];
		x3 = param.n_x[p3];
		x4 = param.n_x[p4];
		y1 = param.n_y[p1];
		y2 = param.n_y[p2];
		y3 = param.n_y[p3];
		y4 = param.n_y[p4];
		z1 = param.n_z[p1];
		z2 = param.n_z[p2];
		z3 = param.n_z[p3];
		z4 = param.n_z[p4];

		dx[0] = x2-x1;
		dx[3] = x3-x1;
		dx[6] = x4-x1;
		dx[1] = y2-y1;
		dx[4] = y3-y1;
		dx[7] = y4-y1;
		dx[2] = z2-z1;
		dx[5] = z3-z1;
		dx[8] = z4-z1;


		//transpose3(dx,trans3_dx);

		//psd_inv3(trans3_dx, inv3_trans3_dx, param);	

		//matrix_m_vec(inv3_trans3_dx,ls_vec,derivec);

		//inv3(dx, inv3_dx);
		//psd_inv3(dx, inv3_dx, param);
		psd_inv3_(dx,inv3_dx,param);


		//transpose3(inv3_dx,inv3_trans3_dx);
		//matrix_m_vec(inv3_trans3_dx,ls_vec,derivec);
		
		dls_dx = inv3_dx[0]*(ls2-ls1)+inv3_dx[1]*(ls3-ls1)+inv3_dx[2]*(ls4-ls1);
		dls_dy = inv3_dx[3]*(ls2-ls1)+inv3_dx[4]*(ls3-ls1)+inv3_dx[5]*(ls4-ls1);
		dls_dz = inv3_dx[6]*(ls2-ls1)+inv3_dx[7]*(ls3-ls1)+inv3_dx[8]*(ls4-ls1);

			//cout << dls_dx << " " << dls_dy << " " << dls_dz << " " << endl;


		//node_class[p1].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r1);
		//node_class[p2].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r2);
		//node_class[p3].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r3);
		//node_class[p4].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r4);
		node_class[p1].vec_x[r1] += current_tet_volumes[ii]*dls_dx;
		node_class[p1].vec_y[r1] += current_tet_volumes[ii]*dls_dy;
		node_class[p1].vec_z[r1] += current_tet_volumes[ii]*dls_dz;
		node_class[p2].vec_x[r2] += current_tet_volumes[ii]*dls_dx;
		node_class[p2].vec_y[r2] += current_tet_volumes[ii]*dls_dy;
		node_class[p2].vec_z[r2] += current_tet_volumes[ii]*dls_dz;
		node_class[p3].vec_x[r3] += current_tet_volumes[ii]*dls_dx;
		node_class[p3].vec_y[r3] += current_tet_volumes[ii]*dls_dy;
		node_class[p3].vec_z[r3] += current_tet_volumes[ii]*dls_dz;
		node_class[p4].vec_x[r4] += current_tet_volumes[ii]*dls_dx;
		node_class[p4].vec_y[r4] += current_tet_volumes[ii]*dls_dy;
		node_class[p4].vec_z[r4] += current_tet_volumes[ii]*dls_dz;



		


		if(param.tets_number < param.tet_mem_lim ){

		inv3_dx[0]=param.inv3_dx_array_0[ii];
		inv3_dx[3]=param.inv3_dx_array_3[ii];
		inv3_dx[6]=param.inv3_dx_array_6[ii];
		inv3_dx[1]=param.inv3_dx_array_1[ii];
		inv3_dx[4]=param.inv3_dx_array_4[ii];
		inv3_dx[7]=param.inv3_dx_array_7[ii];
		inv3_dx[2]=param.inv3_dx_array_2[ii];
		inv3_dx[5]=param.inv3_dx_array_5[ii];
		inv3_dx[8]=param.inv3_dx_array_8[ii];

		}else{

			//inv3(dx,inv3_dx, param);
			//inv3_(dx,inv3_dx,param);
			det3_(dx,det_dx,param);
			inv3_(dx,det_dx,inv3_dx,param);

		}

	
		param.tet_dls_dx[ii] = inv3_dx[0]*(ls2-ls1)+inv3_dx[1]*(ls3-ls1)+inv3_dx[2]*(ls4-ls1);
		param.tet_dls_dy[ii] = inv3_dx[3]*(ls2-ls1)+inv3_dx[4]*(ls3-ls1)+inv3_dx[5]*(ls4-ls1);
		param.tet_dls_dz[ii] = inv3_dx[6]*(ls2-ls1)+inv3_dx[7]*(ls3-ls1)+inv3_dx[8]*(ls4-ls1);

		//if(ii< 800 ){
		//cout << "dx " << dls_dx << " " << param.tet_dls_dx[ii] <<  endl;
		//cout << "dy " << dls_dy << " " << param.tet_dls_dy[ii] << endl;
		//cout << "dz " << dls_dz << " " << param.tet_dls_dz[ii] << endl;
		//cout << " " << endl;
		//}

		//////////////////////////////////
		//finding basis function derivative on tet

		f1_x = -inv3_dx[0]-inv3_dx[1]-inv3_dx[2];
		f1_y = -inv3_dx[3]-inv3_dx[4]-inv3_dx[5];
		f1_z = -inv3_dx[6]-inv3_dx[7]-inv3_dx[8];

		f2_x = inv3_dx[0];
		f2_y = inv3_dx[3];
		f2_z = inv3_dx[6];

		f3_x = inv3_dx[1];
		f3_y = inv3_dx[4];
		f3_z = inv3_dx[7];

		f4_x = inv3_dx[2];
		f4_y = inv3_dx[5];
		f4_z = inv3_dx[8];

		//laplacian phi * grad phi * tet_volume

		//laplacian phi * grad phi * tet_volume

		add_to_p1 = -(f1_x*param.tet_dls_dx[ii]+f1_y*param.tet_dls_dy[ii]+f1_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p2 = -(f2_x*param.tet_dls_dx[ii]+f2_y*param.tet_dls_dy[ii]+f2_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p3 = -(f3_x*param.tet_dls_dx[ii]+f3_y*param.tet_dls_dy[ii]+f3_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p4 = -(f4_x*param.tet_dls_dx[ii]+f4_y*param.tet_dls_dy[ii]+f4_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];


		/////////////////////////////////



		

			
	

			//cout << node_class[p1].associated_node_volumes[r1] << " " << node_class[p2].associated_node_volumes[r2] << " " << node_class[p3].associated_node_volumes[r3] << " " << node_class[p4].associated_node_volumes[r4] << endl;

	
			


			//node_class[p1].add_to_grad2(add_to_p1, r1);
			//node_class[p2].add_to_grad2(add_to_p2, r2);
			//node_class[p3].add_to_grad2(add_to_p3, r3);
			//node_class[p4].add_to_grad2(add_to_p4, r4);
			node_class[p1].grad2_val[r1] += add_to_p1;
			node_class[p2].grad2_val[r2] += add_to_p2;
			node_class[p3].grad2_val[r3] += add_to_p3;
			node_class[p4].grad2_val[r4] += add_to_p4;

		}

	
	//}
	}
	


	for(long n=0;n<param.faces_number;n++){

		//face_class[n].get_normal(nodes);
		get_normal(face_class, n, param);

		tet_num = face_class[n].tet1;
		p1 = face_class[n].node1;
		p2 = face_class[n].node2;
		p3 = face_class[n].node3;

		//region_number=tets_(tet_num,4);
		region_number=param.t_r[tet_num];

		//getting r

		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}


		add_to_p1 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p2 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p3 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);



		//node_class[p1].add_to_grad2_bdry(add_to_p1, r1);
		//node_class[p2].add_to_grad2_bdry(add_to_p2, r2);
		//node_class[p3].add_to_grad2_bdry(add_to_p3, r3);
		node_class[p1].grad2_bdry_val[r1] += add_to_p1;
		node_class[p2].grad2_bdry_val[r2] += add_to_p2;
		node_class[p3].grad2_bdry_val[r3] += add_to_p3;



	}


	/////////////////

	

	for(long n=0;n<param.nodes_number;n++){

		
		for(short r=0;r<node_class[n].number_of_regions_belong;r++){	

			if(node_class[n].associated_node_volumes[r] > .000001){
				k=1/(node_class[n].associated_node_volumes[r]*.25);
			}else{
				k=0;
			}

			node_class[n].vec_x[r] = k*(node_class[n].vec_x[r]);
			node_class[n].vec_y[r] = k*(node_class[n].vec_y[r]);
			node_class[n].vec_z[r] = k*(node_class[n].vec_z[r]);

			node_class[n].grad2_val[r]=k*(node_class[n].grad2_val[r]+node_class[n].grad2_bdry_val[r]);

			//if(node_class[n].boundary == true){
			//	if(node_class[n].current_voxel_region != node_class[n].associated_node_volumes[r]){
					//node_class[n].associated_node_volumes_ext[r] = node_class[n].associated_node_volumes[r];
			//	}
				//node_class[n].associated_node_volumes_ext_tot[r] = node_class[n].associated_node_volumes[r];
			//}
				

		}
	}

	/////////////////////////
	long ee;

	for(long n=0;n<param.nodes_number;n++){
		if( (node_class[n].near_boundary == true)  ){		

			for(short s=0;s<node_class[n].edge_num;s++){

				ee = node_class[n].edge_points[s];

				//if(ee != -1){
				for(short r=0;r<node_class[ee].number_of_regions_belong;r++){

					region_number = node_class[ee].regions_belong[r];

					for(short q=0;q<node_class[n].number_of_regions_belong;q++){

						if(node_class[n].regions_belong[q] == region_number){

							node_class[n].associated_node_volumes_ext_tot[q] = node_class[n].associated_node_volumes_ext_tot[q] + node_class[ee].associated_node_volumes[r];

							if(region_number != node_class[ee].current_voxel_region){

								node_class[n].associated_node_volumes_ext[q] = node_class[n].associated_node_volumes_ext[q] + node_class[ee].associated_node_volumes[r];
								//node_class[n].vec_x_ext[q] = node_class[n].vec_x_ext[q] + node_class[ee].associated_node_volumes[r]*node_class[ee].vec_x[r];
								//node_class[n].vec_y_ext[q] = node_class[n].vec_y_ext[q] + node_class[ee].associated_node_volumes[r]*node_class[ee].vec_y[r];
								//node_class[n].vec_z_ext[q] = node_class[n].vec_z_ext[q] + node_class[ee].associated_node_volumes[r]*node_class[ee].vec_z[r];


							}

						}

					}

				}
				//}

			}

		}
	}
/*
	for(long n=0;n<param.nodes_number;n++){
		for(short r=0;r<node_class[n].number_of_regions_belong;r++){

			if(node_class[n].associated_node_volumes_ext[r] > .000001){
				k=1/(node_class[n].associated_node_volumes_ext[r]);
			}else{
				k=0;
			}

			node_class[n].vec_x_ext[r] = k*(node_class[n].vec_x_ext[r]);
			node_class[n].vec_y_ext[r] = k*(node_class[n].vec_y_ext[r]);
			node_class[n].vec_z_ext[r] = k*(node_class[n].vec_z_ext[r]);

		}
	}
*/

	for(long n=0;n<param.nodes_number;n++){
		if( (node_class[n].boundary == true)  ){		

			for(short s=0;s<node_class[n].edge_num;s++){

				ee = node_class[n].edge_points[s];

				//if(ee != -1){
				for(short r=0;r<node_class[ee].number_of_regions_belong;r++){

					region_number = node_class[ee].regions_belong[r];

					for(short q=0;q<node_class[n].number_of_regions_belong;q++){

						if(node_class[n].regions_belong[q] == region_number){

							node_class[n].associated_node_volumes_ext2_tot[q] = node_class[n].associated_node_volumes_ext2_tot[q] + node_class[ee].associated_node_volumes_ext_tot[r];

							node_class[n].associated_node_volumes_ext2[q] = node_class[n].associated_node_volumes_ext2[q] + node_class[ee].associated_node_volumes_ext[r];
							//node_class[n].vec_x_ext2[q] = node_class[n].vec_x_ext2[q] + node_class[ee].associated_node_volumes_ext[r]*node_class[ee].vec_x_ext[r];
							//node_class[n].vec_y_ext2[q] = node_class[n].vec_y_ext2[q] + node_class[ee].associated_node_volumes_ext[r]*node_class[ee].vec_y_ext[r];
							//node_class[n].vec_z_ext2[q] = node_class[n].vec_z_ext2[q] + node_class[ee].associated_node_volumes_ext[r]*node_class[ee].vec_z_ext[r];



						}

					}

				}
				//}

			}

		}
	}

/*
	for(long n=0;n<param.nodes_number;n++){
		for(short r=0;r<node_class[n].number_of_regions_belong;r++){

			if(node_class[n].associated_node_volumes_ext2[r] > .000001){
				k=1/(node_class[n].associated_node_volumes_ext2[r]);
			}else{
				k=0;
			}

			node_class[n].vec_x_ext2[r] = k*(node_class[n].vec_x_ext2[r]);
			node_class[n].vec_y_ext2[r] = k*(node_class[n].vec_y_ext2[r]);
			node_class[n].vec_z_ext2[r] = k*(node_class[n].vec_z_ext2[r]);

		}
	}
	*/




			



	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	/*
	

	for(long ii=0;ii<param.tets_number;ii++){
		if(param.boundary_tet[ii] == true){


		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];
		region_number=param.t_r[ii];

		//getting r

		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}

		//////////////////////////////////////////////////////////////
		

		////////////////////////////////////////////////////////////////

		//cout << node_class[p1].regions_belong[r1] <<  " " << node_class[p2].regions_belong[r2] << " " << node_class[p3].regions_belong[r3] << " " << node_class[p4].regions_belong[r4] << endl;
		//cout << region_number << endl;
		//cout << " " << endl;

		lap1 = node_class[p1].grad2_val[r1];
		lap2 = node_class[p2].grad2_val[r2];
		lap3 = node_class[p3].grad2_val[r3];
		lap4 = node_class[p4].grad2_val[r4];

		inv3_dx[0]=param.inv3_dx_array_0[ii];
		inv3_dx[3]=param.inv3_dx_array_3[ii];
		inv3_dx[6]=param.inv3_dx_array_6[ii];
		inv3_dx[1]=param.inv3_dx_array_1[ii];
		inv3_dx[4]=param.inv3_dx_array_4[ii];
		inv3_dx[7]=param.inv3_dx_array_7[ii];
		inv3_dx[2]=param.inv3_dx_array_2[ii];
		inv3_dx[5]=param.inv3_dx_array_5[ii];
		inv3_dx[8]=param.inv3_dx_array_8[ii];



		param.tet_dls_dx[ii] = inv3_dx[0]*(lap2-lap1)+inv3_dx[1]*(lap3-lap1)+inv3_dx[2]*(lap4-lap1);
		param.tet_dls_dy[ii] = inv3_dx[3]*(lap2-lap1)+inv3_dx[4]*(lap3-lap1)+inv3_dx[5]*(lap4-lap1);
		param.tet_dls_dz[ii] = inv3_dx[6]*(lap2-lap1)+inv3_dx[7]*(lap3-lap1)+inv3_dx[8]*(lap4-lap1);

		//dls_dx = inv3_dx[0]*(lap2-lap1)+inv3_dx[1]*(lap3-lap1)+inv3_dx[2]*(lap4-lap1);
		//dls_dy = inv3_dx[3]*(lap2-lap1)+inv3_dx[4]*(lap3-lap1)+inv3_dx[5]*(lap4-lap1);
		//dls_dz = inv3_dx[6]*(lap2-lap1)+inv3_dx[7]*(lap3-lap1)+inv3_dx[8]*(lap4-lap1);



	

		

		//////////////////////////////////
		//finding basis function derivative on tet

		f1_x = inv3_dx[0]*(-1)-inv3_dx[1]-inv3_dx[2];
		f1_y = inv3_dx[3]*(-1)-inv3_dx[4]-inv3_dx[5];
		f1_z = inv3_dx[6]*(-1)-inv3_dx[7]-inv3_dx[8];

		f2_x = inv3_dx[0];
		f2_y = inv3_dx[3];
		f2_z = inv3_dx[6];

		f3_x = inv3_dx[1];
		f3_y = inv3_dx[4];
		f3_z = inv3_dx[7];

		f4_x = inv3_dx[2];
		f4_y = inv3_dx[5];
		f4_z = inv3_dx[8];

		//laplacian phi * grad phi * tet_volume

		//laplacian phi * grad phi * tet_volume

		add_to_p1 = -(f1_x*param.tet_dls_dx[ii]+f1_y*param.tet_dls_dy[ii]+f1_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p2 = -(f2_x*param.tet_dls_dx[ii]+f2_y*param.tet_dls_dy[ii]+f2_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p3 = -(f3_x*param.tet_dls_dx[ii]+f3_y*param.tet_dls_dy[ii]+f3_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];
		add_to_p4 = -(f4_x*param.tet_dls_dx[ii]+f4_y*param.tet_dls_dy[ii]+f4_z*param.tet_dls_dz[ii])*current_tet_volumes[ii];




		/////////////////////////////////

			//node_class[p1].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r1);
			//node_class[p2].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r2);
			//node_class[p3].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r3);
			//node_class[p4].add_to_vec(current_tet_volumes[ii]*dls_dx, current_tet_volumes[ii]*dls_dy, current_tet_volumes[ii]*dls_dz, r4);


	
			node_class[p1].add_to_biharm(add_to_p1, r1);
			node_class[p2].add_to_biharm(add_to_p2, r2);
			node_class[p3].add_to_biharm(add_to_p3, r3);
			node_class[p4].add_to_biharm(add_to_p4, r4);

	

	}
	}


	/////////////////
	//cout << "face number size "<< param.faces_number << endl; 

	for(long n=0;n<param.faces_number;n++){

		tet_num = face_class[n].tet1;
		p1 = face_class[n].node1;
		p2 = face_class[n].node2;
		p3 = face_class[n].node3;

		//region_number=tets_(tet_num,4);
		region_number=param.t_r[tet_num];

		//getting r

		for(short m=0;m<node_class[p1].number_of_regions_belong;m++){
			if(node_class[p1].regions_belong[m]==region_number){
				r1=m;
			}
		}
		for(short m=0;m<node_class[p2].number_of_regions_belong;m++){
			if(node_class[p2].regions_belong[m]==region_number){
				r2=m;
			}
		}
		for(short m=0;m<node_class[p3].number_of_regions_belong;m++){
			if(node_class[p3].regions_belong[m]==region_number){
				r3=m;
			}
		}
		for(short m=0;m<node_class[p4].number_of_regions_belong;m++){
			if(node_class[p4].regions_belong[m]==region_number){
				r4=m;
			}
		}


		add_to_p1 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p2 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);
		add_to_p3 = (1.0/3.0)*face_class[n].area*(face_class[n].normal1[0]*param.tet_dls_dx[tet_num]+face_class[n].normal1[1]*param.tet_dls_dy[tet_num]+face_class[n].normal1[2]*param.tet_dls_dz[tet_num]);

	
		node_class[p1].add_to_biharm_bdry(add_to_p1,r1);
		node_class[p2].add_to_biharm_bdry(add_to_p2,r2);
		node_class[p3].add_to_biharm_bdry(add_to_p3,r3);


	}

	/////////////////////////////////////////////////////

	for(long ii=0;ii<param.tets_number;ii++){
		if(param.boundary_tet[ii] == true){


		}
	}
	
	*/

	
	/////////////////

	



	for(long n=0;n<param.nodes_number;n++){
		if(node_class[n].boundary == true){


		
		for(short r=0;r<node_class[n].number_of_regions_belong;r++){	

			if(node_class[n].associated_node_volumes[r] > .000001){
				k=1/(node_class[n].associated_node_volumes[r]*.25);
			}else{
				k=0;
			}


			region_number = node_class[n].regions_belong[r];

			/*
			if(node_class[n].number_of_regions_belong >1){
				cout << k*node_class[n].grad2_val[r] <<" "<< node_class[n].grad2_bdry_val[r] <<" " << region_number << endl;
			}*/

			//node_class[n].vec_x[r] = k*(node_class[n].vec_x[r]);
			//node_class[n].vec_y[r] = k*(node_class[n].vec_y[r]);
			//node_class[n].vec_z[r] = k*(node_class[n].vec_z[r]);

			//node_class[n].biharm_val[r]=k*(node_class[n].biharm_val[r] + node_class[n].biharm_bdry_val[r]);
			

			 //delta = (1/param.pi)*(param.eps/(param.eps*param.eps+node_class[n].ls_val[r]*node_class[n].ls_val[r]));
			 //if(node_class[n].ls_val[r] > 2.0){
			//	 delta = 0.0;
			 //}

			//this_length = sqrt(node_class[n].vec_x[r]*node_class[n].vec_x[r]+node_class[n].vec_y[r]*node_class[n].vec_y[r]+node_class[n].vec_z[r]*node_class[n].vec_z[r]);
			
				v1 = -param.alpha*node_class[n].vec_x[r]*node_class[n].grad2_val[r];
				v2 = -param.alpha*node_class[n].vec_y[r]*node_class[n].grad2_val[r];
				v3 = -param.alpha*node_class[n].vec_z[r]*node_class[n].grad2_val[r];

				//v1 = v1+v1*param.eps/this_length;
				//v2 = v2+v2*param.eps/this_length;
				//v3 = v3+v3*param.eps/this_length;

				//cout << "laplacian " << v1 << " " << v2 << " " << v3 << endl;

			
				//v1 = v1 + param.eps*node_class[n].vec_x[r]*node_class[n].biharm_val[r];
				//v2 = v2 + param.eps*node_class[n].vec_y[r]*node_class[n].biharm_val[r];
				//v3 = v3 + param.eps*node_class[n].vec_z[r]*node_class[n].biharm_val[r];

				//test1 = param.eps*node_class[n].vec_x[r]*node_class[n].biharm_val[r];
				//	test2 = param.eps*node_class[n].vec_y[r]*node_class[n].biharm_val[r];
				//	test3 = param.eps*node_class[n].vec_z[r]*node_class[n].biharm_val[r];

				//v1 = v1 + param.eps*node_class[n].vec_x[r]*node_class[n].grad2_val[r];
				//v2 = v2 + param.eps*node_class[n].vec_y[r]*node_class[n].grad2_val[r];
				//v3 = v3 + param.eps*node_class[n].vec_z[r]*node_class[n].grad2_val[r];

				//cout << "biharmonic " << test1 << " " << test2 << " " << test3 << endl;

				
				

				//if( (node_class[n].regions_belong[r] != node_class[n].current_voxel_region) ){
					
					xx = param.n_x[n];
					yy = param.n_y[n];
					zz = param.n_z[n];

					//ls_val = level_set_value(xx, yy, zz, signed_dist_array, param, 0, false, regions_array);
					ls_val = level_set_value_m(xx, yy, zz, signed_dist_array, param, region_number, true, regions_array);

					
					
					if(ls_val < param.C){
						ls_val = 0;
					}else{

						//if(ls_val > (2.0*lsle) ){
						//	ls_val = 2.0*lsle;
						//}

						ls_val = (ls_val - param.C);
						//cout << ls_val << " " ;
						
					}

					//if(ls_val >= (lsle)){
					//	v1=0;
					//	v2=0;
					//	v3=0;
					//}
					
					
				//if(node_class[n].associated_node_volumes_ext_tot[r] ==0){
				//	cout << "ext tot problem " << endl;
				//	exit(1);
				//}
					

					vol = node_class[n].associated_node_volumes_ext2[r]/node_class[n].associated_node_volumes_ext2_tot[r];

					//cout << vol << " ";

					
					//if(vol < lsle){
					//	vol = 0;
					//}else{
					//	vol = (vol - lsle);						
					//}

					
					
					



					//cout << node_class[n].number_of_regions_belong << " " << node_class[n].boundary_0 << endl;

										

					//cout << "ls_val (not 0) = " << ls_val << endl;
		
					
					//if(ls_val > 0){
					//cout << v1 << " " << v2 << " " << v3 << endl;
					//cout << ls_val << endl;
					//}
					
					

					v1 = v1 + ls_val*param.beta*vol*node_class[n].vec_x[r];
					v2 = v2 + ls_val*param.beta*vol*node_class[n].vec_y[r];
					v3 = v3 + ls_val*param.beta*vol*node_class[n].vec_z[r];

					

					//if(ls_val > 0){
					//cout << v1 << " " << v2 << " " << v3 << endl;
					//}

					

				//}
		
				

				node_class[n].vec_x[r] = v1;
				node_class[n].vec_y[r] = v2;
				node_class[n].vec_z[r] = v3;

				

				

			}

	

			}else{
				for(short r=0;r<node_class[n].number_of_regions_belong;r++){
					node_class[n].vec_x[r] = 0;
					node_class[n].vec_y[r] = 0;
					node_class[n].vec_z[r] = 0;
				}
				}


			}

			


		
		

	

	float sum_x, sum_y, sum_z;

	

	for(long n=0;n<param.nodes_number;n++){

			sum_x = 0;
			sum_y = 0;
			sum_z = 0;

			param.lsnf_x[n] = 0;
			param.lsnf_y[n] = 0;
			param.lsnf_z[n] = 0;


			for(short r=0;r<node_class[n].number_of_regions_belong;r++){

				sum_x = sum_x + node_class[n].vec_x[r];
				sum_y = sum_y + node_class[n].vec_y[r];
				sum_z = sum_z + node_class[n].vec_z[r];

				//cout << node_class[n].regions_belong[r] << endl;

				
			}

			//cout << " " << endl;

			//param.lsnf_x[n] = sum_x/node_class[n].number_of_regions_belong;
			//param.lsnf_y[n] = sum_y/node_class[n].number_of_regions_belong;
			//param.lsnf_z[n] = sum_z/node_class[n].number_of_regions_belong;

			param.lsnf_x[n] = sum_x/2;
				param.lsnf_y[n] = sum_y/2;
				param.lsnf_z[n] = sum_z/2;



			//cout << param.lsnf_x[n] << " " << param.lsnf_y[n] << " " <<param.lsnf_z[n] << endl;

			//this_length = sqrt(param.lsnf_x[n]*param.lsnf_x[n]+param.lsnf_y[n]*param.lsnf_y[n]+param.lsnf_z[n]*param.lsnf_z[n]);
/*
			if( (node_class[n].singleton == false) && (param.constrain == true) && (node_class[n].boundary == true) ){
			//if( (node_class[n].hard_limit == false) && (param.constrain == true) && (node_class[n].boundary == true) ){



				

				//if(this_length > (param.alpha/120.0) ){
			//	if(this_length > 0 ){


							f[0]=param.lsnf_x[n];
							f[1]=param.lsnf_y[n];
							f[2]=param.lsnf_z[n];

							e[0]=param.enf_x[n];
							e[1]=param.enf_y[n];
							e[2]=param.enf_z[n];

							f_length = vec_length(f);

							if(f_length != 0){
								f[0]=f[0]/f_length;
								f[1]=f[1]/f_length;
								f[2]=f[2]/f_length;
							}


							//cout << f[0] << " " << f[1] << " " << f[2] << endl;
							//cout << e[0] << " " << e[1] << " " << e[2] << endl;

							
							param.enf_x[n]=(1.0-f[0]*f[0])*e[0]-f[0]*f[1]*e[1]-f[0]*f[2]*e[2];
							param.enf_y[n]=-f[0]*f[1]*e[0]+(1.0-f[1]*f[1])*e[1]-f[1]*f[2]*e[2];
							param.enf_z[n]=-f[0]*f[2]*e[0]-f[1]*f[2]*e[1]+(1.0-f[2]*f[2])*e[2];

							//cout << param.enf_x[n] << " "  << param.enf_y[n] << " " << param.enf_z[n] << endl;
							//cout << "constrained " << endl;
					
						//}
					//}

			//	}

			}
			*/







			//if(this_length>max_length){
			//	max_length=this_length;
			//}
		
		//cout << "max smoothing vector length " << max_length << endl;

	}




}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



void SG(short regions_array[],  node_info node_class[], float current_tet_volumes[], sparse_matrix &A, parameters &param){

	long p1,p2,p3,p4;
	float s_x, s_y, s_z;

	float dx[9];
	float inv3_dx[9];
	float x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4;
	float f1_x,f1_y,f1_z,f2_x,f2_y,f2_z,f3_x,f3_y,f3_z,f4_x,f4_y,f4_z;
	float add_to_p1_p1;
	float add_to_p1_p2;
	float add_to_p1_p3;
	float add_to_p1_p4;
	float add_to_p2_p2;
	float add_to_p2_p3;
	float add_to_p2_p4;
	float add_to_p3_p3;
	float add_to_p3_p4;
	float add_to_p4_p4;

	long p1c, p2c, p3c, p4c;

	//float *vec_b; vec_b = new float[param.SG_length];
	//float *vec_x; vec_x = new float[param.SG_length];


	
	//long length_input = param.SG_length;
	//long sm_entry_num_input = param.SG_initial_entry_num;

	float stop_cri = .00000001*param.SG_length;

	//cout << param.nodes_number << endl;
	//cout << param.tets_number << endl;
	//cout << param.SG_length << endl;
	//cout << param.SG_initial_entry_num << endl;




	//A.initialize(sm_entry_num_input, length_input);


	//here the lsnf is overwritten to contain both the elastic and level set forces
	//float *//vtu; //vtu = new float[param.nodes_number];
	//float *//vt; //vt = new float[param.nodes_number];

	for(long n=0;n<param.nodes_number;n++){

		param.vec_b_xu[n] = param.lsnf_x[n]+param.enf_x[n];
		param.vec_b_yu[n] = param.lsnf_y[n]+param.enf_y[n];
		param.vec_b_zu[n] = param.lsnf_z[n]+param.enf_z[n];

		////vtu[n] = 1.0;

		node_class[n].associated_node_volume_all = 0;

	}

	float SG_mult;

	if(param.zoom_level == 3){
		SG_mult = .1;
	}
	if(param.zoom_level == 2){
		SG_mult = .1;
	}
	if(param.zoom_level == 1){
		SG_mult = .1;
	}


	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		node_class[p1].associated_node_volume_all = node_class[p1].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p2].associated_node_volume_all = node_class[p2].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p3].associated_node_volume_all = node_class[p3].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p4].associated_node_volume_all = node_class[p4].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];

	}


	for(long n=0;n<param.nodes_number;n++){

		param.vec_b_x[n] = param.vec_b_xu[n]*node_class[n].associated_node_volume_all;
		param.vec_b_y[n] = param.vec_b_yu[n]*node_class[n].associated_node_volume_all;
		param.vec_b_z[n] = param.vec_b_zu[n]*node_class[n].associated_node_volume_all;

		////vt[n] = //vtu[n]*node_class[n].associated_node_volume_all;


		//node_class[n].associated_node_volume_all = 0;

	}


	//for(long n=0;n<param.nodes_number;n++){
	//		if(node_class[n].boundary == false){

	//			cout << param.vec_b_x[n] << endl;
	//		}
	//	}


	


	//float *g2_test; g2_test = new float[param.nodes_number];
	//for(long n=0;n<param.nodes_number;n++){

	//	g2_test[n] = 0;

	//}

	//float dls_dx;
	//float dls_dy;
	//float dls_dz;

	//float add_to_p1;
	//float add_to_p2;
	//float add_to_p3;
	//float add_to_p4;

	//float ls1, ls2, ls3, ls4;

	//short counter;



	//need to precompute dx_-1

	// need to check if node is on the boundary of the entire thing, regardless of regions - and if so set value to itself

	//for(long n=0;n<A.sm_entry_num; n++){
		//cout << A.e[n].order_number << " " ;
	//}
	

	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		p1c = param.conv[p1];
		p2c = param.conv[p2];
		p3c = param.conv[p3];
		p4c = param.conv[p4];


/*
		if(p1 == 924){
			//cout << "is a p1" << endl;
			//cout << node_class[p1].number_of_regions_belong << endl;
			//cout << node_class[p1].regions_belong[0] << endl;
			}
		if(p2 == 924){
			//cout << "is a p2" << endl;
			//cout << node_class[p2].number_of_regions_belong << endl;
			//cout << node_class[p2].regions_belong[0] << endl;

			}
		if(p3 == 924){
			//cout << "is a p3" << endl;
			//cout << node_class[p3].number_of_regions_belong << endl;
			//cout << node_class[p3].regions_belong[0] << endl;
			}
		if(p4 == 924){
			//cout << "is a p4" << endl;
			//cout << node_class[p4].number_of_regions_belong << endl;
			//cout << node_class[p4].regions_belong[0] << endl;
			}

		if( (p1 == 924) || (p2 == 924) || (p3 == 924) || (p4 == 924) ){

		counter = 0;

		if(node_class[p1].boundary == true){
			counter = counter +1;
		}
		if(node_class[p2].boundary == true){
			counter = counter +1;
		}
		if(node_class[p3].boundary == true){
			counter = counter +1;
		}
		if(node_class[p4].boundary == true){
			counter = counter +1;
		}

		//cout << "counter is " << counter << endl;

		}
		*/

		//cout << p1 << " " << p2 << " " << p3 << " " << p4 << endl;
		//cout << p1c << " " << p2c << " " << p3c << " " << p4c << endl;


		//if(param.tets_number < param.tet_mem_lim ){


		inv3_dx[0]=param.inv3_dx_array_0[ii];
		inv3_dx[3]=param.inv3_dx_array_3[ii];
		inv3_dx[6]=param.inv3_dx_array_6[ii];
		inv3_dx[1]=param.inv3_dx_array_1[ii];
		inv3_dx[4]=param.inv3_dx_array_4[ii];
		inv3_dx[7]=param.inv3_dx_array_7[ii];
		inv3_dx[2]=param.inv3_dx_array_2[ii];
		inv3_dx[5]=param.inv3_dx_array_5[ii];
		inv3_dx[8]=param.inv3_dx_array_8[ii];

		//}else{

			//inv3(dx,inv3_dx);

		//}

		//ls1 = param.vec_b_xu[p1];
		//ls2 = param.vec_b_xu[p2];
		//ls3 = param.vec_b_xu[p3];
		//ls4 = param.vec_b_xu[p4];

		//ls1 = 1;
		//ls2 = 1;
		//ls3 = 1;
		//ls4 = 1;

		//dls_dx = inv3_dx_(0,0)*(ls2-ls1)+inv3_dx_(1,0)*(ls3-ls1)+inv3_dx_(2,0)*(ls4-ls1);
		//dls_dy = inv3_dx_(0,1)*(ls2-ls1)+inv3_dx_(1,1)*(ls3-ls1)+inv3_dx_(2,1)*(ls4-ls1);
		//dls_dz = inv3_dx_(0,2)*(ls2-ls1)+inv3_dx_(1,2)*(ls3-ls1)+inv3_dx_(2,2)*(ls4-ls1);

		s_x=-(inv3_dx_(0,0)+inv3_dx_(1,0)+inv3_dx_(2,0));
		s_y=-(inv3_dx_(0,1)+inv3_dx_(1,1)+inv3_dx_(2,1));
		s_z=-(inv3_dx_(0,2)+inv3_dx_(1,2)+inv3_dx_(2,2));


		//f1_x = inv3_dx_(0,0)*(0-1)+inv3_dx_(1,0)*(0-1)+inv3_dx_(2,0)*(0-1);
		//f1_y = inv3_dx_(0,1)*(0-1)+inv3_dx_(1,1)*(0-1)+inv3_dx_(2,1)*(0-1);
		//f1_z = inv3_dx_(0,2)*(0-1)+inv3_dx_(1,2)*(0-1)+inv3_dx_(2,2)*(0-1);

		f1_x = s_x;
		f1_y = s_y;
		f1_z = s_z;

		f2_x = inv3_dx_(0,0);//*(1-0);
		f2_y = inv3_dx_(0,1);//*(1-0);
		f2_z = inv3_dx_(0,2);//*(1-0);

		f3_x = inv3_dx_(1,0);//*(1-0);
		f3_y = inv3_dx_(1,1);//*(1-0);
		f3_z = inv3_dx_(1,2);//*(1-0);

		f4_x = inv3_dx_(2,0);//*(1-0);
		f4_y = inv3_dx_(2,1);//*(1-0);
		f4_z = inv3_dx_(2,2);//*(1-0);

		//laplacian phi * grad phi * tet_volume

		//laplacian phi * grad phi * tet_volume

		//add_to_p1 = -(f1_x*dls_dx+f1_y*dls_dy+f1_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p2 = -(f2_x*dls_dx+f2_y*dls_dy+f2_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p3 = -(f3_x*dls_dx+f3_y*dls_dy+f3_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p4 = -(f4_x*dls_dx+f4_y*dls_dy+f4_z*dls_dz)*current_tet_volumes[ii];

		//g2_test[p1] = g2_test[p1] + add_to_p1;
		//g2_test[p2] = g2_test[p2] + add_to_p2;
		//g2_test[p3] = g2_test[p3] + add_to_p3;
		//g2_test[p4] = g2_test[p4] + add_to_p4;

		add_to_p1_p1 = -(f1_x*s_x+f1_y*s_y+f1_z*s_z)*current_tet_volumes[ii];
		add_to_p1_p2 = -(f1_x*inv3_dx_(0,0)+f1_y*inv3_dx_(0,1)+f1_z*inv3_dx_(0,2))*current_tet_volumes[ii];
		add_to_p1_p3 = -(f1_x*inv3_dx_(1,0)+f1_y*inv3_dx_(1,1)+f1_z*inv3_dx_(1,2))*current_tet_volumes[ii];
		add_to_p1_p4 = -(f1_x*inv3_dx_(2,0)+f1_y*inv3_dx_(2,1)+f1_z*inv3_dx_(2,2))*current_tet_volumes[ii];

		//add_to_p2_p1 = -(f2_x*s_x+f2_y*s_y+f2_z*s_z)*current_tet_volumes[ii];
		add_to_p2_p2 = -(f2_x*inv3_dx_(0,0)+f2_y*inv3_dx_(0,1)+f2_z*inv3_dx_(0,2))*current_tet_volumes[ii];
		add_to_p2_p3 = -(f2_x*inv3_dx_(1,0)+f2_y*inv3_dx_(1,1)+f2_z*inv3_dx_(1,2))*current_tet_volumes[ii];
		add_to_p2_p4 = -(f2_x*inv3_dx_(2,0)+f2_y*inv3_dx_(2,1)+f2_z*inv3_dx_(2,2))*current_tet_volumes[ii];

		//add_to_p3_p1 = -(f3_x*s_x+f3_y*s_y+f3_z*s_z)*current_tet_volumes[ii];
		//add_to_p3_p2 = -(f3_x*inv3_dx_(0,0)+f3_y*inv3_dx_(0,1)+f3_z*inv3_dx_(0,2))*current_tet_volumes[ii];
		add_to_p3_p3 = -(f3_x*inv3_dx_(1,0)+f3_y*inv3_dx_(1,1)+f3_z*inv3_dx_(1,2))*current_tet_volumes[ii];
		add_to_p3_p4 = -(f3_x*inv3_dx_(2,0)+f3_y*inv3_dx_(2,1)+f3_z*inv3_dx_(2,2))*current_tet_volumes[ii];

		//add_to_p4_p1 = -(f4_x*s_x+f4_y*s_y+f4_z*s_z)*current_tet_volumes[ii];
		//add_to_p4_p2 = -(f4_x*inv3_dx_(0,0)+f4_y*inv3_dx_(0,1)+f4_z*inv3_dx_(0,2))*current_tet_volumes[ii];
		//add_to_p4_p3 = -(f4_x*inv3_dx_(1,0)+f4_y*inv3_dx_(1,1)+f4_z*inv3_dx_(1,2))*current_tet_volumes[ii];
		add_to_p4_p4 = -(f4_x*inv3_dx_(2,0)+f4_y*inv3_dx_(2,1)+f4_z*inv3_dx_(2,2))*current_tet_volumes[ii];

		if(node_class[p1].boundary == false){
			if(node_class[p2].boundary == false){
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//add all
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						A.add_entry_s(p1c,p2c,add_to_p1_p2);
						A.add_entry_s(p1c,p3c,add_to_p1_p3);
						A.add_entry_s(p1c,p4c,add_to_p1_p4);
						A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						A.add_entry_s(p2c,p3c,add_to_p2_p3);
						A.add_entry_s(p2c,p4c,add_to_p2_p4);
						A.add_entry_s(p3c,p1c,add_to_p1_p3);
						A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						A.add_entry_s(p3c,p4c,add_to_p3_p4);
						A.add_entry_s(p4c,p1c,add_to_p1_p4);
						A.add_entry_s(p4c,p2c,add_to_p2_p4);
						A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
					}else{
						//1,2,3
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						A.add_entry_s(p1c,p2c,add_to_p1_p2);
						A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						A.add_entry_s(p3c,p1c,add_to_p1_p3);
						A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p4*param.vec_b_xu[p4];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p4*param.vec_b_yu[p4];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p4*param.vec_b_zu[p4];
						////vt[p1]=//vt[p1]+add_to_p1_p4*//vtu[p4];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p4*param.vec_b_xu[p4];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p4*param.vec_b_yu[p4];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p4*param.vec_b_zu[p4];
						////vt[p2]=//vt[p2]+add_to_p2_p4*//vtu[p4];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p3_p4*param.vec_b_xu[p4];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p3_p4*param.vec_b_yu[p4];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p3_p4*param.vec_b_zu[p4];
						////vt[p3]=//vt[p3]+add_to_p3_p4*//vtu[p4];


						
						
					}
				}else{
					if(node_class[p4].boundary == false){
						//1,2,4
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						A.add_entry_s(p1c,p4c,add_to_p1_p4);
						A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						A.add_entry_s(p4c,p1c,add_to_p1_p4);
						A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p3*param.vec_b_xu[p3];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p3*param.vec_b_yu[p3];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p3*param.vec_b_zu[p3];
						////vt[p1]=//vt[p1]+add_to_p1_p3*//vtu[p3];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p3*param.vec_b_xu[p3];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p3*param.vec_b_yu[p3];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p3*param.vec_b_zu[p3];
						////vt[p2]=//vt[p2]+add_to_p2_p3*//vtu[p3];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p3_p4*param.vec_b_xu[p3];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p3_p4*param.vec_b_yu[p3];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p3_p4*param.vec_b_zu[p3];
						////vt[p4]=//vt[p4]+add_to_p3_p4*//vtu[p3];

					}else{
						//1,2
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p3*param.vec_b_xu[p3];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p3*param.vec_b_yu[p3];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p3*param.vec_b_zu[p3];
						////vt[p1]=//vt[p1]+add_to_p1_p3*//vtu[p3];

						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p4*param.vec_b_xu[p4];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p4*param.vec_b_yu[p4];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p4*param.vec_b_zu[p4];
						////vt[p1]=//vt[p1]+add_to_p1_p4*//vtu[p4];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p3*param.vec_b_xu[p3];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p3*param.vec_b_yu[p3];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p3*param.vec_b_zu[p3];
						////vt[p2]=//vt[p2]+add_to_p2_p3*//vtu[p3];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p4*param.vec_b_xu[p4];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p4*param.vec_b_yu[p4];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p4*param.vec_b_zu[p4];
						////vt[p2]=//vt[p2]+add_to_p2_p4*//vtu[p4];

					}
				}
			}else{
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//1,3,4
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						A.add_entry_s(p1c,p3c,add_to_p1_p3);
						A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						A.add_entry_s(p3c,p4c,add_to_p3_p4);
						A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p2*param.vec_b_xu[p2];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p2*param.vec_b_yu[p2];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p2*param.vec_b_zu[p2];
						////vt[p1]=//vt[p1]+add_to_p1_p2*//vtu[p2];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p2_p3*param.vec_b_xu[p2];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p2_p3*param.vec_b_yu[p2];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p2_p3*param.vec_b_zu[p2];
						////vt[p3]=//vt[p3]+add_to_p2_p3*//vtu[p2];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p2_p4*param.vec_b_xu[p2];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p2_p4*param.vec_b_yu[p2];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p2_p4*param.vec_b_zu[p2];
						////vt[p4]=//vt[p4]+add_to_p2_p4*//vtu[p2];
					}else{
						//1,3
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p2*param.vec_b_xu[p2];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p2*param.vec_b_yu[p2];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p2*param.vec_b_zu[p2];
						////vt[p1]=//vt[p1]+add_to_p1_p2*//vtu[p2];

						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p4*param.vec_b_xu[p4];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p4*param.vec_b_yu[p4];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p4*param.vec_b_zu[p4];
						////vt[p1]=//vt[p1]+add_to_p1_p4*//vtu[p4];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p2_p3*param.vec_b_xu[p2];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p2_p3*param.vec_b_yu[p2];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p2_p3*param.vec_b_zu[p2];
						////vt[p3]=//vt[p3]+add_to_p2_p3*//vtu[p2];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p3_p4*param.vec_b_xu[p4];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p3_p4*param.vec_b_yu[p4];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p3_p4*param.vec_b_zu[p4];
						////vt[p3]=//vt[p3]+add_to_p3_p4*//vtu[p4];
					}
				}else{
					if(node_class[p4].boundary == false){
						//1,4
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p2*param.vec_b_xu[p2];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p2*param.vec_b_yu[p2];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p2*param.vec_b_zu[p2];
						//vt[p1]=//vt[p1]+add_to_p1_p2*//vtu[p2];

						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p3*param.vec_b_xu[p3];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p3*param.vec_b_yu[p3];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p3*param.vec_b_zu[p3];
						//vt[p1]=//vt[p1]+add_to_p1_p3*//vtu[p3];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p2_p4*param.vec_b_xu[p2];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p2_p4*param.vec_b_yu[p2];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p2_p4*param.vec_b_zu[p2];
						//vt[p4]=//vt[p4]+add_to_p2_p4*//vtu[p2];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p3_p4*param.vec_b_xu[p3];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p3_p4*param.vec_b_yu[p3];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p3_p4*param.vec_b_zu[p3];
						//vt[p4]=//vt[p4]+add_to_p3_p4*//vtu[p3];

					}else{
						//1
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p2*param.vec_b_xu[p2];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p2*param.vec_b_yu[p2];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p2*param.vec_b_zu[p2];
						//vt[p1]=//vt[p1]+add_to_p1_p2*//vtu[p2];

						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p3*param.vec_b_xu[p3];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p3*param.vec_b_yu[p3];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p3*param.vec_b_zu[p3];
						//vt[p1]=//vt[p1]+add_to_p1_p3*//vtu[p3];

						param.vec_b_x[p1]=param.vec_b_x[p1] + add_to_p1_p4*param.vec_b_xu[p4];
						param.vec_b_y[p1]=param.vec_b_y[p1] + add_to_p1_p4*param.vec_b_yu[p4];
						param.vec_b_z[p1]=param.vec_b_z[p1] + add_to_p1_p4*param.vec_b_zu[p4];
						//vt[p1]=//vt[p1]+add_to_p1_p4*//vtu[p4];

					}
				}
			}
		}else{
			if(node_class[p2].boundary == false){
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						// 2,3,4
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						A.add_entry_s(p2c,p3c,add_to_p2_p3);
						A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						A.add_entry_s(p4c,p2c,add_to_p2_p4);
						A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p1_p2*param.vec_b_xu[p1];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p1_p2*param.vec_b_yu[p1];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p1_p2*param.vec_b_zu[p1];
						//vt[p2]=//vt[p2]+add_to_p1_p2*//vtu[p1];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p1_p3*param.vec_b_xu[p1];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p1_p3*param.vec_b_yu[p1];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p1_p3*param.vec_b_zu[p1];
						//vt[p3]=//vt[p3]+add_to_p1_p3*//vtu[p1];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p1_p4*param.vec_b_xu[p1];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p1_p4*param.vec_b_yu[p1];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p1_p4*param.vec_b_zu[p1];
						//vt[p4]=//vt[p4]+add_to_p1_p4*//vtu[p1];

					}else{
						// 2,3
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p1_p2*param.vec_b_xu[p1];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p1_p2*param.vec_b_yu[p1];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p1_p2*param.vec_b_zu[p1];
						//vt[p2]=//vt[p2]+add_to_p1_p2*//vtu[p1];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p4*param.vec_b_xu[p4];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p4*param.vec_b_yu[p4];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p4*param.vec_b_zu[p4];
						//vt[p2]=//vt[p2]+add_to_p2_p4*//vtu[p4];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p1_p3*param.vec_b_xu[p1];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p1_p3*param.vec_b_yu[p1];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p1_p3*param.vec_b_zu[p1];
						//vt[p3]=//vt[p3]+add_to_p1_p3*//vtu[p1];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p3_p4*param.vec_b_xu[p4];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p3_p4*param.vec_b_yu[p4];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p3_p4*param.vec_b_zu[p4];
						//vt[p3]=//vt[p3]+add_to_p3_p4*//vtu[p4];
					}
				}else{
					if(node_class[p4].boundary == false){
						//2,4
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p1_p2*param.vec_b_xu[p1];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p1_p2*param.vec_b_yu[p1];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p1_p2*param.vec_b_zu[p1];
						//vt[p2]=//vt[p2]+add_to_p1_p2*//vtu[p1];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p3*param.vec_b_xu[p3];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p3*param.vec_b_yu[p3];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p3*param.vec_b_zu[p3];
						//vt[p2]=//vt[p2]+add_to_p2_p3*//vtu[p3];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p1_p4*param.vec_b_xu[p1];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p1_p4*param.vec_b_yu[p1];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p1_p4*param.vec_b_zu[p1];
						//vt[p4]=//vt[p4]+add_to_p1_p4*//vtu[p1];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p3_p4*param.vec_b_xu[p3];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p3_p4*param.vec_b_yu[p3];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p3_p4*param.vec_b_zu[p3];
						//vt[p4]=//vt[p4]+add_to_p3_p4*//vtu[p3];

					}else{
						//2
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p1_p2*param.vec_b_xu[p1];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p1_p2*param.vec_b_yu[p1];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p1_p2*param.vec_b_zu[p1];
						//vt[p2]=//vt[p2]+add_to_p1_p2*//vtu[p1];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p3*param.vec_b_xu[p3];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p3*param.vec_b_yu[p3];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p3*param.vec_b_zu[p3];
						//vt[p2]=//vt[p2]+add_to_p2_p3*//vtu[p3];

						param.vec_b_x[p2]=param.vec_b_x[p2] + add_to_p2_p4*param.vec_b_xu[p4];
						param.vec_b_y[p2]=param.vec_b_y[p2] + add_to_p2_p4*param.vec_b_yu[p4];
						param.vec_b_z[p2]=param.vec_b_z[p2] + add_to_p2_p4*param.vec_b_zu[p4];
						//vt[p2]=//vt[p2]+add_to_p2_p4*//vtu[p4];
					}
				}
			}else{
				if(node_class[p3].boundary == false){
					if(node_class[p4].boundary == false){
						//3,4
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p1_p3*param.vec_b_xu[p1];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p1_p3*param.vec_b_yu[p1];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p1_p3*param.vec_b_zu[p1];
						//vt[p3]=//vt[p3]+add_to_p1_p3*//vtu[p1];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p2_p3*param.vec_b_xu[p2];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p2_p3*param.vec_b_yu[p2];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p2_p3*param.vec_b_zu[p2];
						//vt[p3]=//vt[p3]+add_to_p2_p3*//vtu[p2];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p1_p4*param.vec_b_xu[p1];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p1_p4*param.vec_b_yu[p1];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p1_p4*param.vec_b_zu[p1];
						//vt[p4]=//vt[p4]+add_to_p1_p4*//vtu[p1];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p2_p4*param.vec_b_xu[p2];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p2_p4*param.vec_b_yu[p2];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p2_p4*param.vec_b_zu[p2];
						//vt[p4]=//vt[p4]+add_to_p2_p4*//vtu[p2];

					}else{
						//3
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p1_p3*param.vec_b_xu[p1];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p1_p3*param.vec_b_yu[p1];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p1_p3*param.vec_b_zu[p1];
						//vt[p3]=//vt[p3]+add_to_p1_p3*//vtu[p1];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p2_p3*param.vec_b_xu[p2];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p2_p3*param.vec_b_yu[p2];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p2_p3*param.vec_b_zu[p2];
						//vt[p3]=//vt[p3]+add_to_p2_p3*//vtu[p2];

						param.vec_b_x[p3]=param.vec_b_x[p3] + add_to_p3_p4*param.vec_b_xu[p4];
						param.vec_b_y[p3]=param.vec_b_y[p3] + add_to_p3_p4*param.vec_b_yu[p4];
						param.vec_b_z[p3]=param.vec_b_z[p3] + add_to_p3_p4*param.vec_b_zu[p4];
						//vt[p3]=//vt[p3]+add_to_p3_p4*//vtu[p4];

					}
				}else{
					if(node_class[p4].boundary == false){
						//4
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p1_p4*param.vec_b_xu[p1];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p1_p4*param.vec_b_yu[p1];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p1_p4*param.vec_b_zu[p1];
						//vt[p4]=//vt[p4]+add_to_p1_p4*//vtu[p1];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p2_p4*param.vec_b_xu[p2];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p2_p4*param.vec_b_yu[p2];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p2_p4*param.vec_b_zu[p2];
						//vt[p4]=//vt[p4]+add_to_p2_p4*//vtu[p2];

						param.vec_b_x[p4]=param.vec_b_x[p4] + add_to_p3_p4*param.vec_b_xu[p3];
						param.vec_b_y[p4]=param.vec_b_y[p4] + add_to_p3_p4*param.vec_b_yu[p3];
						param.vec_b_z[p4]=param.vec_b_z[p4] + add_to_p3_p4*param.vec_b_zu[p3];
						//vt[p4]=//vt[p4]+add_to_p3_p4*//vtu[p3];

					}else{
						//none
						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p1c,add_to_p1_p2);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p1c,add_to_p1_p3);
						//A.add_entry_s(p3c,p2c,add_to_p2_p3);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p1c,add_to_p1_p4);
						//A.add_entry_s(p4c,p2c,add_to_p2_p4);
						//A.add_entry_s(p4c,p3c,add_to_p3_p4);
						//A.add_entry_s_s(p4c,p4c,add_to_p4_p4);
					}
				}
			}
		}


		}
		
		




		if(param.t == 0){

			A.get_NZREN();

	
		}

		for(long n=0; n<A.sm_entry_num; n++){

			//cout << A.e[n].order_number << " " << A.e[n].val << endl;
			

			A.e[n].val = - A.e[n].val;

			//A.e[n].val = 0;

			if(A.e[n].row == A.e[n].column){

				A.e[n].val = node_class[A.e[n].row].associated_node_volume_all + A.e[n].val;

				//A.e[n].val = 1.0;

				//cout << param.conv_inv[A.e[n].row] << " " ;

			}

		}

		

		

		

		

		

		//for(long n=0; n<A.sm_entry_num; n++){
			//if( (A.e[n].column == 710) && (A.e[n].row == 710)){
				//cout << A.e[n].order_number << endl;
				//cout << "710 hit" <<endl;
			//}
			//cout << A.e[n].row << " " << A.e[n].column <<  " " << A.e[n].order_number << " " << A.e[n].val << endl;
	//	}

		//cout << param.SG_length << endl;

		///
/*

		for(long n=0;n<param.nodes_number;n++){

				vec_b[n] = vt[n];
				vec_x[n] = vtu[n];

				//cout << n << " " ;

		}

		conj_grad(vec_x, vec_b, A, stop_cri);

		for(long n=0;n<(param.nodes_number);n++){	
			
				cout << vtu[n] << " " << vec_x[n] << endl;

		}

		*/
		
		//

		



		//
		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_x[n];
				param.vec_x[param.conv[n]] = param.vec_b_xu[n];

			}
		}

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_x[n]=param.n_x[n]+param.delta_t*param.vec_b_xu[n];
				//cout << "broken " << endl;
			}else{
				param.n_x[n]=param.n_x[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}


		//

		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_y[n];
				param.vec_x[param.conv[n]] = param.vec_b_yu[n];

			}
		}

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_y[n]=param.n_y[n]+param.delta_t*param.vec_b_yu[n];
			}else{
				param.n_y[n]=param.n_y[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}

		//

		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_z[n];
				param.vec_x[param.conv[n]] = param.vec_b_zu[n];

			}
		}

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_z[n]=param.n_z[n]+param.delta_t*param.vec_b_zu[n];
			}else{
				param.n_z[n]=param.n_z[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}


		

		A.zero();

		//for(long n=0; n<A.sm_entry_num; n++){
		//	cout << A.e[n].val << endl;
		//}




		


}



////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////



void SG2(short regions_array[],  node_info node_class[], float current_tet_volumes[], sparse_matrix &A, parameters &param){

	long p1,p2,p3,p4;
	float s_x, s_y, s_z;

	float dx[9];
	float inv3_dx[9];
	float x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4;
	float f1_x,f1_y,f1_z,f2_x,f2_y,f2_z,f3_x,f3_y,f3_z,f4_x,f4_y,f4_z;
	float add_to_p1_p1;
	float add_to_p1_p2;
	float add_to_p1_p3;
	float add_to_p1_p4;
	float add_to_p2_p2;
	float add_to_p2_p3;
	float add_to_p2_p4;
	float add_to_p3_p3;
	float add_to_p3_p4;
	float add_to_p4_p4;

	long p1c, p2c, p3c, p4c;
	float det_dx;

	


	
	//long length_input = param.SG_length;
	//long sm_entry_num_input = param.SG_initial_entry_num;

	float stop_cri = .1*.1*param.SG_length;

	if(param.jagged_compression == true){

		//stop_cri = .0002*.0002*param.SG_length;
		stop_cri = .02;
		//stop_cri = .008;

	}

	

	//cout << param.nodes_number << endl;
	//cout << param.tets_number << endl;
	//cout << param.SG_length << endl;
	//cout << param.SG_initial_entry_num << endl;




	//A.initialize(sm_entry_num_input, length_input);


	//here the lsnf is overwritten to contain both the elastic and level set forces
	//float *vtu; vtu = new float[param.nodes_number];
	//float *vt; vt = new float[param.nodes_number];

	for(long n=0;n<param.nodes_number;n++){

		param.vec_b_xu[n] = param.lsnf_x[n]+param.enf_x[n];
		param.vec_b_yu[n] = param.lsnf_y[n]+param.enf_y[n];
		param.vec_b_zu[n] = param.lsnf_z[n]+param.enf_z[n];

		//vtu[n] = 1.0;

		node_class[n].associated_node_volume_all = 0;

	}

	float SG_mult;

	if(param.zoom_level == 3){
		SG_mult = 0.1;
	}
	if(param.zoom_level == 2){
		SG_mult = 0.1;
	}
	if(param.zoom_level == 1){
		SG_mult = 0.1;
	}

	if(param.jagged_compression == true){

		if(param.zoom_level == 3){
		SG_mult = .1;
	}
	if(param.zoom_level == 2){
		SG_mult = .1;
	}
	if(param.zoom_level == 1){
		SG_mult = 1/float(param.kappa);
	}




	}


	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		node_class[p1].associated_node_volume_all = node_class[p1].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p2].associated_node_volume_all = node_class[p2].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p3].associated_node_volume_all = node_class[p3].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];
		node_class[p4].associated_node_volume_all = node_class[p4].associated_node_volume_all + SG_mult*(.25)*current_tet_volumes[ii];

	}

	for(long n=0;n<param.nodes_number;n++){

		param.vec_b_x[n] = param.vec_b_xu[n]*node_class[n].associated_node_volume_all;
		param.vec_b_y[n] = param.vec_b_yu[n]*node_class[n].associated_node_volume_all;
		param.vec_b_z[n] = param.vec_b_zu[n]*node_class[n].associated_node_volume_all;

		//vt[n] = vtu[n]*node_class[n].associated_node_volume_all;


		//node_class[n].associated_node_volume_all = 0;

	}


	//for(long n=0;n<param.nodes_number;n++){
	//		if(node_class[n].boundary == false){

	//			cout << param.vec_b_x[n] << endl;
	//		}
	//	}


	


	//float *g2_test; g2_test = new float[param.nodes_number];
	//for(long n=0;n<param.nodes_number;n++){

	//	g2_test[n] = 0;

	//}

	//float dls_dx;
	//float dls_dy;
	//float dls_dz;

	//float add_to_p1;
	//float add_to_p2;
	//float add_to_p3;
	//float add_to_p4;

	//float ls1, ls2, ls3, ls4;

	//short counter;



	//need to precompute dx_-1

	// need to check if node is on the boundary of the entire thing, regardless of regions - and if so set value to itself

	//for(long n=0;n<A.sm_entry_num; n++){
		//cout << A.e[n].order_number << " " ;
	//}
	

	for(long ii=0;ii<param.tets_number;ii++){

		p1=param.t_1[ii];
		p2=param.t_2[ii];
		p3=param.t_3[ii];
		p4=param.t_4[ii];

		p1c = param.conv[p1];
		p2c = param.conv[p2];
		p3c = param.conv[p3];
		p4c = param.conv[p4];


/*
		if(p1 == 924){
			//cout << "is a p1" << endl;
			//cout << node_class[p1].number_of_regions_belong << endl;
			//cout << node_class[p1].regions_belong[0] << endl;
			}
		if(p2 == 924){
			//cout << "is a p2" << endl;
			//cout << node_class[p2].number_of_regions_belong << endl;
			//cout << node_class[p2].regions_belong[0] << endl;

			}
		if(p3 == 924){
			//cout << "is a p3" << endl;
			//cout << node_class[p3].number_of_regions_belong << endl;
			//cout << node_class[p3].regions_belong[0] << endl;
			}
		if(p4 == 924){
			//cout << "is a p4" << endl;
			//cout << node_class[p4].number_of_regions_belong << endl;
			//cout << node_class[p4].regions_belong[0] << endl;
			}

		if( (p1 == 924) || (p2 == 924) || (p3 == 924) || (p4 == 924) ){

		counter = 0;

		if(node_class[p1].boundary == true){
			counter = counter +1;
		}
		if(node_class[p2].boundary == true){
			counter = counter +1;
		}
		if(node_class[p3].boundary == true){
			counter = counter +1;
		}
		if(node_class[p4].boundary == true){
			counter = counter +1;
		}

		//cout << "counter is " << counter << endl;

		}
		*/

		//cout << p1 << " " << p2 << " " << p3 << " " << p4 << endl;
		//cout << p1c << " " << p2c << " " << p3c << " " << p4c << endl;





		

		if(param.tets_number < param.tet_mem_lim ){

		inv3_dx[0]=param.inv3_dx_array_0[ii];
		inv3_dx[3]=param.inv3_dx_array_3[ii];
		inv3_dx[6]=param.inv3_dx_array_6[ii];
		inv3_dx[1]=param.inv3_dx_array_1[ii];
		inv3_dx[4]=param.inv3_dx_array_4[ii];
		inv3_dx[7]=param.inv3_dx_array_7[ii];
		inv3_dx[2]=param.inv3_dx_array_2[ii];
		inv3_dx[5]=param.inv3_dx_array_5[ii];
		inv3_dx[8]=param.inv3_dx_array_8[ii];

		}else{

		x1 = param.n_x[p1];
		x2 = param.n_x[p2];
		x3 = param.n_x[p3];
		x4 = param.n_x[p4];
		y1 = param.n_y[p1];
		y2 = param.n_y[p2];
		y3 = param.n_y[p3];
		y4 = param.n_y[p4];
		z1 = param.n_z[p1];
		z2 = param.n_z[p2];
		z3 = param.n_z[p3];
		z4 = param.n_z[p4];

		dx[0] = x2-x1;
		dx[3] = x3-x1;
		dx[6] = x4-x1;
		dx[1] = y2-y1;
		dx[4] = y3-y1;
		dx[7] = y4-y1;
		dx[2] = z2-z1;
		dx[5] = z3-z1;
		dx[8] = z4-z1;

			//inv3(dx,inv3_dx, param);
			//inv3_(dx,inv3_dx,param);
			det3_(dx,det_dx,param);
			inv3_(dx,det_dx,inv3_dx,param);

		}

		//inv3(dx, inv3_dx);
		//psd_inv3(dx, inv3_dx, param);
		//ls1 = param.vec_b_xu[p1];
		//ls2 = param.vec_b_xu[p2];
		//ls3 = param.vec_b_xu[p3];
		//ls4 = param.vec_b_xu[p4];

		//ls1 = 1;
		//ls2 = 1;
		//ls3 = 1;
		//ls4 = 1;

		//dls_dx = inv3_dx_(0,0)*(ls2-ls1)+inv3_dx_(1,0)*(ls3-ls1)+inv3_dx_(2,0)*(ls4-ls1);
		//dls_dy = inv3_dx_(0,1)*(ls2-ls1)+inv3_dx_(1,1)*(ls3-ls1)+inv3_dx_(2,1)*(ls4-ls1);
		//dls_dz = inv3_dx_(0,2)*(ls2-ls1)+inv3_dx_(1,2)*(ls3-ls1)+inv3_dx_(2,2)*(ls4-ls1);

		s_x=-(inv3_dx[0]+inv3_dx[1]+inv3_dx[2]);
		s_y=-(inv3_dx[3]+inv3_dx[4]+inv3_dx[5]);
		s_z=-(inv3_dx[6]+inv3_dx[7]+inv3_dx[8]);


		//f1_x = inv3_dx_(0,0)*(0-1)+inv3_dx_(1,0)*(0-1)+inv3_dx_(2,0)*(0-1);
		//f1_y = inv3_dx_(0,1)*(0-1)+inv3_dx_(1,1)*(0-1)+inv3_dx_(2,1)*(0-1);
		//f1_z = inv3_dx_(0,2)*(0-1)+inv3_dx_(1,2)*(0-1)+inv3_dx_(2,2)*(0-1);

		f1_x = s_x;
		f1_y = s_y;
		f1_z = s_z;

		f2_x = inv3_dx[0];//*(1-0);
		f2_y = inv3_dx[3];//*(1-0);
		f2_z = inv3_dx[6];//*(1-0);

		f3_x = inv3_dx[1];//*(1-0);
		f3_y = inv3_dx[4];//*(1-0);
		f3_z = inv3_dx[7];//*(1-0);

		f4_x = inv3_dx[2];//*(1-0);
		f4_y = inv3_dx[5];//*(1-0);
		f4_z = inv3_dx[8];//*(1-0);

		//laplacian phi * grad phi * tet_volume

		//laplacian phi * grad phi * tet_volume

		//add_to_p1 = -(f1_x*dls_dx+f1_y*dls_dy+f1_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p2 = -(f2_x*dls_dx+f2_y*dls_dy+f2_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p3 = -(f3_x*dls_dx+f3_y*dls_dy+f3_z*dls_dz)*current_tet_volumes[ii];
		//add_to_p4 = -(f4_x*dls_dx+f4_y*dls_dy+f4_z*dls_dz)*current_tet_volumes[ii];

		//g2_test[p1] = g2_test[p1] + add_to_p1;
		//g2_test[p2] = g2_test[p2] + add_to_p2;
		//g2_test[p3] = g2_test[p3] + add_to_p3;
		//g2_test[p4] = g2_test[p4] + add_to_p4;

		add_to_p1_p1 = -(f1_x*s_x+f1_y*s_y+f1_z*s_z)*current_tet_volumes[ii];
		add_to_p1_p2 = -(f1_x*inv3_dx[0]+f1_y*inv3_dx[3]+f1_z*inv3_dx[6])*current_tet_volumes[ii];
		add_to_p1_p3 = -(f1_x*inv3_dx[1]+f1_y*inv3_dx[4]+f1_z*inv3_dx[7])*current_tet_volumes[ii];
		add_to_p1_p4 = -(f1_x*inv3_dx[2]+f1_y*inv3_dx[5]+f1_z*inv3_dx[8])*current_tet_volumes[ii];

		//add_to_p2_p1 = -(f2_x*s_x+f2_y*s_y+f2_z*s_z)*current_tet_volumes[ii];
		add_to_p2_p2 = -(f2_x*inv3_dx[0]+f2_y*inv3_dx[3]+f2_z*inv3_dx[6])*current_tet_volumes[ii];
		add_to_p2_p3 = -(f2_x*inv3_dx[1]+f2_y*inv3_dx[4]+f2_z*inv3_dx[7])*current_tet_volumes[ii];
		add_to_p2_p4 = -(f2_x*inv3_dx[2]+f2_y*inv3_dx[5]+f2_z*inv3_dx[8])*current_tet_volumes[ii];

		//add_to_p3_p1 = -(f3_x*s_x+f3_y*s_y+f3_z*s_z)*current_tet_volumes[ii];
		//add_to_p3_p2 = -(f3_x*inv3_dx[0]+f3_y*inv3_dx[3]+f3_z*inv3_dx[6])*current_tet_volumes[ii];
		add_to_p3_p3 = -(f3_x*inv3_dx[1]+f3_y*inv3_dx[4]+f3_z*inv3_dx[7])*current_tet_volumes[ii];
		add_to_p3_p4 = -(f3_x*inv3_dx[2]+f3_y*inv3_dx[5]+f3_z*inv3_dx[8])*current_tet_volumes[ii];

		//add_to_p4_p1 = -(f4_x*s_x+f4_y*s_y+f4_z*s_z)*current_tet_volumes[ii];
		//add_to_p4_p2 = -(f4_x*inv3_dx[0]+f4_y*inv3_dx[3]+f4_z*inv3_dx[6])*current_tet_volumes[ii];
		//add_to_p4_p3 = -(f4_x*inv3_dx[1]+f4_y*inv3_dx[4]+f4_z*inv3_dx[7])*current_tet_volumes[ii];
		add_to_p4_p4 = -(f4_x*inv3_dx[2]+f4_y*inv3_dx[5]+f4_z*inv3_dx[8])*current_tet_volumes[ii];


		/*
						A.add_entry_s(p1c,p1c,add_to_p1_p1);
						A.add_entry_s(p1c,p2c,add_to_p1_p2);
						A.add_entry_s(p1c,p3c,add_to_p1_p3);
						A.add_entry_s(p1c,p4c,add_to_p1_p4);
						A.add_entry_s(p2c,p1c,add_to_p1_p2);
						A.add_entry_s(p2c,p2c,add_to_p2_p2);
						A.add_entry_s(p2c,p3c,add_to_p2_p3);
						A.add_entry_s(p2c,p4c,add_to_p2_p4);
						A.add_entry_s(p3c,p1c,add_to_p1_p3);
						A.add_entry_s(p3c,p2c,add_to_p2_p3);
						A.add_entry_s(p3c,p3c,add_to_p3_p3);
						A.add_entry_s(p3c,p4c,add_to_p3_p4);
						A.add_entry_s(p4c,p1c,add_to_p1_p4);
						A.add_entry_s(p4c,p2c,add_to_p2_p4);
						A.add_entry_s(p4c,p3c,add_to_p3_p4);
						A.add_entry_s(p4c,p4c,add_to_p4_p4);
						*/

						//A.add_entry_s(p1c,p1c,add_to_p1_p1);
						//A.add_entry_s(p1c,p2c,add_to_p1_p2);
						//A.add_entry_s(p1c,p3c,add_to_p1_p3);
						//A.add_entry_s(p1c,p4c,add_to_p1_p4);
						//A.add_entry_s(p2c,p2c,add_to_p2_p2);
						//A.add_entry_s(p2c,p3c,add_to_p2_p3);
						//A.add_entry_s(p2c,p4c,add_to_p2_p4);
						//A.add_entry_s(p3c,p3c,add_to_p3_p3);
						//A.add_entry_s(p3c,p4c,add_to_p3_p4);
						//A.add_entry_s(p4c,p4c,add_to_p4_p4);

						add_entry_s_(A,p1c,p1c,add_to_p1_p1);
						add_entry_s_(A,p1c,p2c,add_to_p1_p2);
						add_entry_s_(A,p1c,p3c,add_to_p1_p3);
						add_entry_s_(A,p1c,p4c,add_to_p1_p4);
						add_entry_s_(A,p2c,p2c,add_to_p2_p2);
						add_entry_s_(A,p2c,p3c,add_to_p2_p3);
						add_entry_s_(A,p2c,p4c,add_to_p2_p4);
						add_entry_s_(A,p3c,p3c,add_to_p3_p3);
						add_entry_s_(A,p3c,p4c,add_to_p3_p4);
						add_entry_s_(A,p4c,p4c,add_to_p4_p4);


					






		}

		//
/*
		float *vec_in; vec_in = new float[param.SG_length];
		float *vec_out; vec_out = new float[param.SG_length];

		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].boundary == false){
				//vec_in[param.conv[n]] = param.vec_b_xu[n];
				vec_in[n] = 1.0;
			}
		}


		sparse_matrix_m_vec(A, vec_in, vec_out);

		for(long n=0;n<param.nodes_number;n++){

				cout << vec_out[n] << " " <<  " " << n << endl;
					//}
				
			
		}


		delete [] vec_in;
		delete [] vec_out;
		*/


		//

		

		if(param.first_SG == true){

			A.get_NZREN();
			param.first_SG = false;

			param.vec_r_k = new float[A.length];
			//param.vec_r_kp1 = new float[A.length];
			param.vec_p_k = new float[A.length];
			//param.vec_p_kp1 = new float[A.length];
			param.vec_x_k = new float[A.length];
			//param.vec_x_kp1 = new float[A.length];
			param.vec_A_p_k = new float[A.length];
			param.vec_A_x0 = new float[A.length];

			param.vec_b = new float[param.SG_length];
			param.vec_x = new float[param.SG_length];

	
		}else{

			A.fill_in_other_half();

		}


		for(long n=0; n<A.sm_entry_num; n++){

			//cout << A.e[n].order_number << " " << A.e[n].val << endl;
			

			A.e[n].val = - A.e[n].val;

			//A.e[n].val = 0;

			if(A.e[n].row == A.e[n].column){

				A.e[n].val = node_class[A.e[n].row].associated_node_volume_all + A.e[n].val;

				//A.e[n].val = 1.0;

				//cout << param.conv_inv[A.e[n].row] << " " ;

			}

		}

		

		

		

		

		

		//for(long n=0; n<A.sm_entry_num; n++){
			//if( (A.e[n].column == 710) && (A.e[n].row == 710)){
				//cout << A.e[n].order_number << endl;
				//cout << "710 hit" <<endl;
			//}
			//cout << A.e[n].row << " " << A.e[n].column <<  " " << A.e[n].order_number << " " << A.e[n].val << endl;
	//	}

		//cout << param.SG_length << endl;

		///
/*

		for(long n=0;n<param.nodes_number;n++){

				vec_b[n] = vt[n];
				vec_x[n] = vtu[n];

				//cout << n << " " ;

		}

		conj_grad(vec_x, vec_b, A, stop_cri);

		for(long n=0;n<(param.nodes_number);n++){	
			
				cout << vtu[n] << " " << vec_x[n] << endl;

		}

		*/
		
		//

		



		//
		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_x[n];
				param.vec_x[param.conv[n]] = param.vec_b_xu[n];

			}
		}

		

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

/*
		float *test_vec;
		test_vec = new float[param.SG_length];
		sparse_matrix_m_vec(A,param.vec_x,test_vec);

		for(long n=0;n<param.SG_length;n++){
			cout << test_vec[n] << " " << param.vec_b[n] << endl;
		}
		exit(1);
		*/
		

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_x[n]=param.n_x[n]+param.delta_t*param.vec_b_xu[n];
				//cout << "broken " << endl;
			}else{
				param.n_x[n]=param.n_x[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}


		//

		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_y[n];
				param.vec_x[param.conv[n]] = param.vec_b_yu[n];

			}
		}

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_y[n]=param.n_y[n]+param.delta_t*param.vec_b_yu[n];
			}else{
				param.n_y[n]=param.n_y[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}

		//

		for(long n=0;n<param.nodes_number;n++){
			if(node_class[n].number_of_regions_belong > 0){
				param.vec_b[param.conv[n]] = param.vec_b_z[n];
				param.vec_x[param.conv[n]] = param.vec_b_zu[n];

			}
		}

		conj_grad(param.vec_x, param.vec_b, A, stop_cri, param);

		for(long n=0;n<(param.nodes_number);n++){	
			if(node_class[n].number_of_regions_belong == 0){
				param.n_z[n]=param.n_z[n]+param.delta_t*param.vec_b_zu[n];
			}else{
				param.n_z[n]=param.n_z[n]+param.delta_t*param.vec_x[param.conv[n]];
				//cout << param.vec_b_xu[n] << " " << vec_x[param.conv[n]] << endl;
			}
		}


		

		A.zero();

		//for(long n=0; n<A.sm_entry_num; n++){
		//	cout << A.e[n].val << endl;
		//}





		


}







void uninvert(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param){

	long p1, p2, p3, p4;
	float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;

	float n1[3],n2[3],n3[3],n4[3];
		float n1_length,n2_length,n3_length,n4_length;
		float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
		float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
		float alt1[3], alt2[3], alt3[3], alt4[3];
		float alt_length1, alt_length2, alt_length3, alt_length4;
		float v[3];
		float F[9];
		float inv3_dX[9];
		float dx[9];




		for(long ii=0;ii<param.tets_number;ii++){   

			if(param.inverted[ii] == true){


			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];
	
			dx[0] = x2-x1;
			dx[3] = x3-x1;
			dx[6] = x4-x1;
			dx[1] = y2-y1;
			dx[4] = y3-y1;
			dx[7] = y4-y1;
			dx[2] = z2-z1;
			dx[5] = z3-z1;
			dx[8] = z4-z1;



			inv3_dX[0]=param.inv3_dX_array_0[ii];
			inv3_dX[3]=param.inv3_dX_array_3[ii];
			inv3_dX[6]=param.inv3_dX_array_6[ii];
			inv3_dX[1]=param.inv3_dX_array_1[ii];
			inv3_dX[4]=param.inv3_dX_array_4[ii];
			inv3_dX[7]=param.inv3_dX_array_7[ii];
			inv3_dX[2]=param.inv3_dX_array_2[ii];
			inv3_dX[5]=param.inv3_dX_array_5[ii];
			inv3_dX[8]=param.inv3_dX_array_8[ii];


			m(dx, inv3_dX, F);

			if( (det3(F, param)) <0){

			vec1[0]=x2-x1;
			vec1[1]=y2-y1;
			vec1[2]=z2-z1;

			vec2[0]=x3-x1;
			vec2[1]=y3-y1;
			vec2[2]=z3-z1;

			vec3[0]=x4-x1;
			vec3[1]=y4-y1;
			vec3[2]=z4-z1;

			vec4[0]=x3-x2;
			vec4[1]=y3-y2;
			vec4[2]=z3-z2;

			vec5[0]=x4-x2;
			vec5[1]=y4-y2;
			vec5[2]=z4-z2;

			vec6[0]=x4-x3;
			vec6[1]=y4-y3;
			vec6[2]=z4-z3;

			cross_product(vec2,vec1,n4);
			cross_product(vec1,vec3,n3);
			cross_product(vec3,vec2,n2);
			cross_product(vec4,vec5,n1);

			n1_length=vec_length(n1);
			n2_length=vec_length(n2);
			n3_length=vec_length(n3);
			n4_length=vec_length(n4);

			for(short ww=0;ww<3;ww++){

					n1[ww]=n1[ww]/n1_length;
					n2[ww]=n2[ww]/n2_length;
					n3[ww]=n3[ww]/n3_length;
					n4[ww]=n4[ww]/n4_length;

				}

			for(short bb=0;bb<3;bb++){
					v[bb]=-vec1[bb];
				}

				alt_p1[0]=n1[0]*n1[0]*v[0] + n1[0]*n1[1]*v[1] + n1[0]*n1[2]*v[2];
				alt_p1[1]=n1[0]*n1[1]*v[0] + n1[1]*n1[1]*v[1] + n1[1]*n1[2]*v[2];
				alt_p1[2]=n1[0]*n1[2]*v[0] + n1[1]*n1[2]*v[1] + n1[2]*n1[2]*v[2];

				alt_length1 = vec_length(alt_p1);
				
				for(short bb=0;bb<3;bb++){
					v[bb]=vec1[bb];
				}

				alt_p2[0]=n2[0]*n2[0]*v[0] + n2[0]*n2[1]*v[1] + n2[0]*n2[2]*v[2];
				alt_p2[1]=n2[0]*n2[1]*v[0] + n2[1]*n2[1]*v[1] + n2[1]*n2[2]*v[2];
				alt_p2[2]=n2[0]*n2[2]*v[0] + n2[1]*n2[2]*v[1] + n2[2]*n2[2]*v[2];

				alt_length2 = vec_length(alt_p2);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec4[bb];
				}

				alt_p3[0]=n3[0]*n3[0]*v[0] + n3[0]*n3[1]*v[1] + n3[0]*n3[2]*v[2];
				alt_p3[1]=n3[0]*n3[1]*v[0] + n3[1]*n3[1]*v[1] + n3[1]*n3[2]*v[2];
				alt_p3[2]=n3[0]*n3[2]*v[0] + n3[1]*n3[2]*v[1] + n3[2]*n3[2]*v[2];

				alt_length3 = vec_length(alt_p3);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec3[bb];
				}

				alt_p4[0]=n4[0]*n4[0]*v[0] + n4[0]*n4[1]*v[1] + n4[0]*n4[2]*v[2];
				alt_p4[1]=n4[0]*n4[1]*v[0] + n4[1]*n4[1]*v[1] + n4[1]*n4[2]*v[2];
				alt_p4[2]=n4[0]*n4[2]*v[0] + n4[1]*n4[2]*v[1] + n4[2]*n4[2]*v[2];

				alt_length4 = vec_length(alt_p4);



				if( (alt_length1 < alt_length2) && (alt_length1 < alt_length3) && (alt_length1 < alt_length4) ){

					param.n_x[p1] = param.n_x[p1] -2.0*alt_p1[0];
					param.n_y[p1] = param.n_y[p1] -2.0*alt_p1[1];
					param.n_z[p1] = param.n_z[p1] -2.0*alt_p1[2];

				}

				if( (alt_length2 < alt_length1) && (alt_length2 < alt_length3) && (alt_length2 < alt_length4) ){

					param.n_x[p2] = param.n_x[p2] -2.0*alt_p2[0];
					param.n_y[p2] = param.n_y[p2] -2.0*alt_p2[1];
					param.n_z[p2] = param.n_z[p2] -2.0*alt_p2[2];

				}

				if( (alt_length3 < alt_length1) && (alt_length3 < alt_length2) && (alt_length3 < alt_length4) ){

					param.n_x[p3] = param.n_x[p3] -2.0*alt_p3[0];
					param.n_y[p3] = param.n_y[p3] -2.0*alt_p3[1];
					param.n_z[p3] = param.n_z[p3] -2.0*alt_p3[2];

				}

				if( (alt_length4 < alt_length1) && (alt_length4 < alt_length2) && (alt_length4 < alt_length3) ){

					param.n_x[p4] = param.n_x[p4] -2.0*alt_p4[0];
					param.n_y[p4] = param.n_y[p4] -2.0*alt_p4[1];
					param.n_z[p4] = param.n_z[p4] -2.0*alt_p4[2];

				}

			}
				
		}

	}

	param.inverted_count = 0;

	for(long ii=0;ii<param.tets_number;ii++){   


			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];
	
			dx[0] = x2-x1;
			dx[3] = x3-x1;
			dx[6] = x4-x1;
			dx[1] = y2-y1;
			dx[4] = y3-y1;
			dx[7] = y4-y1;
			dx[2] = z2-z1;
			dx[5] = z3-z1;
			dx[8] = z4-z1;



			inv3_dX[0]=param.inv3_dX_array_0[ii];
			inv3_dX[3]=param.inv3_dX_array_3[ii];
			inv3_dX[6]=param.inv3_dX_array_6[ii];
			inv3_dX[1]=param.inv3_dX_array_1[ii];
			inv3_dX[4]=param.inv3_dX_array_4[ii];
			inv3_dX[7]=param.inv3_dX_array_7[ii];
			inv3_dX[2]=param.inv3_dX_array_2[ii];
			inv3_dX[5]=param.inv3_dX_array_5[ii];
			inv3_dX[8]=param.inv3_dX_array_8[ii];


			m(dx, inv3_dX, F);

			param.inverted[ii] = false;
			if( (det3(F, param)) <0){
				param.inverted[ii] = true;
				param.inverted_count = param.inverted_count + 1;
			}

	}

	cout << "inverted count " << param.inverted_count << endl;

}



				


				
				





	


